# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.Anasazi is the python interface to the Trilinos eigensolver
package Anasazi:

    https://trilinos.org/docs/dev/packages/anasazi/doc/html/index.html

Anasazi is a collection of eigensolver technologies.  The C++ version
makes liberal use of templates to abstract out the scalar type,
multivector type and operator type.  Currently, the python version
supports only an Epetra interface, so that the scalar type is float
(C++ double), the multivector type is Epetra.MultiVector and the
operator type is Epetra.Operator.  The following python factories
produce python wrappers to underlying C++ instances of the given C++
names with concrete Epetra implementations:

    * SortManager
    * BasicSort
    * Eigenproblem
    * BasicEigenproblem
    * StatusTest
    * StatusTestCombo
    * StatusTestMaxIters
    * StatusTestOutput
    * StatusTestResNorm
    * OrthoManager
    * MatOrthoManager
    * SVQBOrthoManager
    * Eigensolver
    * SolverManager
    * BlockDavidson
    * BlockDavidsonSolMgr
    * BlockKrylovSchur
    * BlockKrylovSchurSolMgr
    * LOBPCG
    * LOBPCGSolMgr
    * Eigensolution

For an example of usage of Anasazi to solve an eigenproblem, see the
following script in the example subdirectory of the PyTrilinos
package:

    * exAnasazi_BlockDavidson.py

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Anasazi
else:
    import _Anasazi

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

HAVE_EPETRA_THYRA = _Anasazi.HAVE_EPETRA_THYRA
class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_SwigPyIterator

    def value(self):
        return _Anasazi.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _Anasazi.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _Anasazi.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _Anasazi.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _Anasazi.SwigPyIterator_equal(self, x)

    def copy(self):
        return _Anasazi.SwigPyIterator_copy(self)

    def next(self):
        return _Anasazi.SwigPyIterator_next(self)

    def __next__(self):
        return _Anasazi.SwigPyIterator___next__(self)

    def previous(self):
        return _Anasazi.SwigPyIterator_previous(self)

    def advance(self, n):
        return _Anasazi.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _Anasazi.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _Anasazi.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _Anasazi.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _Anasazi.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _Anasazi.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _Anasazi.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Anasazi:
_Anasazi.SwigPyIterator_swigregister(SwigPyIterator)
from . import Teuchos
from .Teuchos import Base
from . import Epetra

def Anasazi_Version(*args):
    return _Anasazi.Anasazi_Version(*args)

__version__ = Anasazi_Version().split()[2]

class AnasaziError(object):
    r"""      An exception class parent to all Anasazi exceptions."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.AnasaziError_swiginit(self, _Anasazi.new_AnasaziError(*args))
    __swig_destroy__ = _Anasazi.delete_AnasaziError

# Register AnasaziError in _Anasazi:
_Anasazi.AnasaziError_swigregister(AnasaziError)
Converged = _Anasazi.Converged
r""" The solver manager computed the requested eigenvalues."""
Unconverged = _Anasazi.Unconverged
r""" This solver manager did not compute all of the requested eigenvalues."""
NO_CONJ = _Anasazi.NO_CONJ
r""" Not conjugated"""
CONJ = _Anasazi.CONJ
r""" Conjugated"""
Passed = _Anasazi.Passed
r""" The solver passed the test"""
Failed = _Anasazi.Failed
r""" The solver failed the test"""
Undefined = _Anasazi.Undefined
r""" The test has not been evaluated on the solver"""
RES_ORTH = _Anasazi.RES_ORTH
RES_2NORM = _Anasazi.RES_2NORM
RITZRES_2NORM = _Anasazi.RITZRES_2NORM
Errors = _Anasazi.Errors
r""" Errors [ always printed ]"""
Warnings = _Anasazi.Warnings
r""" Internal warnings"""
IterationDetails = _Anasazi.IterationDetails
r""" Approximate eigenvalues, errors"""
OrthoDetails = _Anasazi.OrthoDetails
r""" Orthogonalization/orthonormalization details"""
FinalSummary = _Anasazi.FinalSummary
r""" Final computational summary"""
TimingDetails = _Anasazi.TimingDetails
r""" Timing details, uses MPI_COMM_WORLD by default."""
StatusTestDetails = _Anasazi.StatusTestDetails
r""" Status test details"""
Debug = _Anasazi.Debug
r""" Debugging information"""
class ValueDouble(object):
    r"""  This struct is used for storing eigenvalues and Ritz values, as a pair of real values."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    realpart = property(_Anasazi.ValueDouble_realpart_get, _Anasazi.ValueDouble_realpart_set, doc=r""" The real component of the eigenvalue.""")
    imagpart = property(_Anasazi.ValueDouble_imagpart_get, _Anasazi.ValueDouble_imagpart_set, doc=r""" The imaginary component of the eigenvalue.""")

    def set(self, *args):
        return _Anasazi.ValueDouble_set(self, *args)

    def __str__(self, *args):
        return _Anasazi.ValueDouble___str__(self, *args)

    def __init__(self, *args):
        _Anasazi.ValueDouble_swiginit(self, _Anasazi.new_ValueDouble(*args))
    __swig_destroy__ = _Anasazi.delete_ValueDouble

# Register ValueDouble in _Anasazi:
_Anasazi.ValueDouble_swigregister(ValueDouble)
class OutputManagerDouble(object):
    r"""
    Output managers remove the need for the eigensolver to know any information
    about the required output.  Calling isVerbosity( MsgType type ) informs the solver if
    it is supposed to output the information corresponding to the message type.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Default constructor"""
        _Anasazi.OutputManagerDouble_swiginit(self, _Anasazi.new_OutputManagerDouble(*args))
    __swig_destroy__ = _Anasazi.delete_OutputManagerDouble

    def setVerbosity(self, *args):
        r""" Set the message output types for this manager."""
        return _Anasazi.OutputManagerDouble_setVerbosity(self, *args)

    def getVerbosity(self, *args):
        r""" Get the message output types for this manager."""
        return _Anasazi.OutputManagerDouble_getVerbosity(self, *args)

    def setFancyOStream(self, *args):
        r""" Set the formatted output stream object for this manager."""
        return _Anasazi.OutputManagerDouble_setFancyOStream(self, *args)

    def getFancyOStream(self, *args):
        r""" Get the formatted output stream object for this manager."""
        return _Anasazi.OutputManagerDouble_getFancyOStream(self, *args)

    def isVerbosity(self, *args):
        r"""
        Find out whether we need to print out information for this message type. This method is used by the solver to determine whether computations are
             necessary for this message type.
        """
        return _Anasazi.OutputManagerDouble_isVerbosity(self, *args)

    def stream(self, *args):
        r""" Create a stream for outputting to."""
        return _Anasazi.OutputManagerDouble_stream(self, *args)

# Register OutputManagerDouble in _Anasazi:
_Anasazi.OutputManagerDouble_swigregister(OutputManagerDouble)
class BasicOutputManagerDouble(OutputManagerDouble):
    r"""
    Anasazi's basic output manager for sending information of select verbosity levels
    to the appropriate output stream.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Default constructor

        |

        *Overload 2:*
        Constructor with specified verbosity and formatted output stream
        """
        _Anasazi.BasicOutputManagerDouble_swiginit(self, _Anasazi.new_BasicOutputManagerDouble(*args))
    __swig_destroy__ = _Anasazi.delete_BasicOutputManagerDouble

# Register BasicOutputManagerDouble in _Anasazi:
_Anasazi.BasicOutputManagerDouble_swigregister(BasicOutputManagerDouble)
class SortManagerError(AnasaziError):
    r"""
    SortManagerError is thrown when the Anasazi::SortManager is unable to sort the numbers,
    due to some failure of the sort method or error in calling it.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.SortManagerError_swiginit(self, _Anasazi.new_SortManagerError(*args))
    __swig_destroy__ = _Anasazi.delete_SortManagerError

# Register SortManagerError in _Anasazi:
_Anasazi.SortManagerError_swigregister(SortManagerError)
class MultiVecDouble(object):
    r"""
    Interface for multivectors used by Anasazi's linear solvers.
    Author: Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist

    :param ScalarType: The type of entries of the multivector.

    Anasazi accesses multivectors through a traits interface called
    MultiVecTraits.  If you want to use Anasazi with your own
    multivector class MV, you may either specialize MultiVecTraits for
    MV, or you may wrap MV in your own class that implements MultiVec.
    Specializing MultiVecTraits works via compile-time polymorphism,
    whereas implementing the MultiVec interface works via run-time
    polymorphism.  You may pick whichever option you like.  However,
    specializing MultiVecTraits is the preferred method.  This is
    because Anasazi's linear solvers always use a specialization of
    MultiVecTraits to access multivector operations.  They only use
    MultiVec through a specialization of the MultiVecTraits traits
    class, which is implemented below in this header file.

    If you want your multivector class (or a wrapper thereof) to
    implement the MultiVec interface, you should inherit from
    MultiVec<ScalarType>, where ScalarType is the type of entries in
    the multivector.  For example, a multivector with entries of type
    double would inherit from MultiVec<double>.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_MultiVecDouble

    def Clone(self, *args):
        r"""
        Create a new MultiVec with ``numvecs`` columns.
        :rtype: Anasazi::MultiVec< double >
        :return: Pointer to the new multivector with uninitialized values.
        """
        return _Anasazi.MultiVecDouble_Clone(self, *args)

    def CloneCopy(self, *args):
        r"""
        *Overload 1:*
        Create a new MultiVec and copy contents of ``*this`` into it (deep copy).
        :rtype: Anasazi::MultiVec< double >
        :return: Pointer to the new multivector	

        |

        *Overload 2:*
        Creates a new Anasazi::MultiVec and copies the selected contents of ``*this``
           into the new vector (deep copy).  The copied
           vectors from ``*this`` are indicated by the ``index.size()`` indices in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _Anasazi.MultiVecDouble_CloneCopy(self, *args)

    def CloneViewNonConst(self, *args):
        r"""
        Creates a new Anasazi::MultiVec that shares the selected contents of ``*this``.
           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _Anasazi.MultiVecDouble_CloneViewNonConst(self, *args)

    def CloneView(self, *args):
        r"""
        Creates a new Anasazi::MultiVec that shares the selected contents of ``*this``.
           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _Anasazi.MultiVecDouble_CloneView(self, *args)

    def GetGlobalLength(self, *args):
        r""" The number of rows in the multivector."""
        return _Anasazi.MultiVecDouble_GetGlobalLength(self, *args)

    def GetNumberVecs(self, *args):
        r""" The number of vectors (i.e., columns) in the multivector."""
        return _Anasazi.MultiVecDouble_GetNumberVecs(self, *args)

    def MvTimesMatAddMv(self, *args):
        r""" Update ``*this`` with ``alpha`` * ``A`` * ``B`` + ``beta`` * (``*this)``."""
        return _Anasazi.MultiVecDouble_MvTimesMatAddMv(self, *args)

    def MvAddMv(self, *args):
        r""" Replace ``*this`` with ``alpha`` * ``A`` + ``beta`` * ``B``."""
        return _Anasazi.MultiVecDouble_MvAddMv(self, *args)

    def MvScale(self, *args):
        r"""
        *Overload 1:*
        Scale each element of the vectors in ``*this`` with ``alpha``.

        |

        *Overload 2:*
        Scale each element of the i-th vector in ``*this`` with alpha[i].
        """
        return _Anasazi.MultiVecDouble_MvScale(self, *args)

    def MvTransMv(self, *args):
        r"""
        Compute a dense matrix ``B`` through the matrix-matrix multiply
           ``alpha`` * ``A^T`` * (``*this)``.
        """
        return _Anasazi.MultiVecDouble_MvTransMv(self, *args)

    def MvDot(self, *args):
        r"""
        Compute the dot product of each column of *this with the corresponding column of A.

        Compute a vector ``b`` whose entries are the individual
        dot-products.  That is, b[i] = A[i]^H * (*this)[i]
        where A[i] is the i-th column of A.
        """
        return _Anasazi.MultiVecDouble_MvDot(self, *args)

    def MvNorm(self, *args):
        r"""
        Compute the 2-norm of each vector in ``*this``.

        :type normvec: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :param normvec: [out] On output, normvec[i] holds the 2-norm of the
              ``i-th`` vector of ``*this``.
        """
        return _Anasazi.MultiVecDouble_MvNorm(self, *args)

    def SetBlock(self, *args):
        r"""
        Copy the vectors in ``A`` to a set of vectors in ``*this``.

        The ``numvecs`` vectors in ``A`` are copied to a subset of vectors
        in ``*this`` indicated by the indices given in ``index``.
        """
        return _Anasazi.MultiVecDouble_SetBlock(self, *args)

    def MvRandom(self, *args):
        r""" Fill all the vectors in ``*this`` with random numbers."""
        return _Anasazi.MultiVecDouble_MvRandom(self, *args)

    def MvInit(self, *args):
        r""" Replace each element of the vectors in ``*this`` with ``alpha``."""
        return _Anasazi.MultiVecDouble_MvInit(self, *args)

    def MvPrint(self, *args):
        r""" Print ``*this`` multivector to the ``os`` output stream."""
        return _Anasazi.MultiVecDouble_MvPrint(self, *args)

# Register MultiVecDouble in _Anasazi:
_Anasazi.MultiVecDouble_swigregister(MultiVecDouble)
class OperatorError(AnasaziError):
    r""" Exceptions thrown to signal error in operator application."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.OperatorError_swiginit(self, _Anasazi.new_OperatorError(*args))
    __swig_destroy__ = _Anasazi.delete_OperatorError

# Register OperatorError in _Anasazi:
_Anasazi.OperatorError_swigregister(OperatorError)
class OperatorDouble(object):
    r"""
    Anasazi's templated virtual class for constructing an operator that can interface with the
    OperatorTraits class used by the eigensolvers.

    A concrete implementation of this class is necessary.  The user can create their own implementation
    if those supplied are not suitable for their needs.

    Author: Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_OperatorDouble

    def Apply(self, *args):
        r"""
        This method takes the Anasazi::MultiVec ``x`` and
             applies the operator to it resulting in the Anasazi::MultiVec ``y``.
        """
        return _Anasazi.OperatorDouble_Apply(self, *args)

# Register OperatorDouble in _Anasazi:
_Anasazi.OperatorDouble_swigregister(OperatorDouble)
class StatusTestError(AnasaziError):
    r""" Exception thrown to signal error in a status test during Anasazi::StatusTest::checkStatus()."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.StatusTestError_swiginit(self, _Anasazi.new_StatusTestError(*args))
    __swig_destroy__ = _Anasazi.delete_StatusTestError

# Register StatusTestError in _Anasazi:
_Anasazi.StatusTestError_swigregister(StatusTestError)
class ResNormNaNError(AnasaziError):
    r"""
    ResNormNaNError is thrown from StatusTestResNorm::checkStatus()
    when a NaN ("not a number") is detected among the residual norms returned
    by the eigensolver.

    This behavior is optional and is controlled by flag to StatusTestResNorm::StatusTestResNorm().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.ResNormNaNError_swiginit(self, _Anasazi.new_ResNormNaNError(*args))
    __swig_destroy__ = _Anasazi.delete_ResNormNaNError

# Register ResNormNaNError in _Anasazi:
_Anasazi.ResNormNaNError_swigregister(ResNormNaNError)
class OrthoError(AnasaziError):
    r""" Exception thrown to signal error in an orthogonalization manager method."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.OrthoError_swiginit(self, _Anasazi.new_OrthoError(*args))
    __swig_destroy__ = _Anasazi.delete_OrthoError

# Register OrthoError in _Anasazi:
_Anasazi.OrthoError_swigregister(OrthoError)
class BlockDavidsonInitFailure(AnasaziError):
    r"""
     BlockDavidsonInitFailure is thrown when the BlockDavidson solver is unable to
    generate an initial iterate in the BlockDavidson::initialize() routine.

    This exception is thrown from the BlockDavidson::initialize() method, which is
    called by the user or from the BlockDavidson::iterate() method if isInitialized()
    == ``false``.

    In the case that this exception is thrown,
    BlockDavidson::isInitialized() will be ``false`` and the user will need to provide
    a new initial iterate to the solver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.BlockDavidsonInitFailure_swiginit(self, _Anasazi.new_BlockDavidsonInitFailure(*args))
    __swig_destroy__ = _Anasazi.delete_BlockDavidsonInitFailure

# Register BlockDavidsonInitFailure in _Anasazi:
_Anasazi.BlockDavidsonInitFailure_swigregister(BlockDavidsonInitFailure)
class BlockDavidsonOrthoFailure(AnasaziError):
    r"""
     BlockDavidsonOrthoFailure is thrown when the orthogonalization manager is
    unable to orthogonalize the preconditioned residual against (a.k.a. ``H)``
    the current basis (a.k.a. ``V)``.

    This exception is thrown from the BlockDavidson::iterate() method.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.BlockDavidsonOrthoFailure_swiginit(self, _Anasazi.new_BlockDavidsonOrthoFailure(*args))
    __swig_destroy__ = _Anasazi.delete_BlockDavidsonOrthoFailure

# Register BlockDavidsonOrthoFailure in _Anasazi:
_Anasazi.BlockDavidsonOrthoFailure_swigregister(BlockDavidsonOrthoFailure)
class BlockKrylovSchurInitFailure(AnasaziError):
    r"""
     BlockKrylovSchurInitFailure is thrown when the BlockKrylovSchur solver is unable to
    generate an initial iterate in the BlockKrylovSchur::initialize() routine.

    This exception is thrown from the BlockKrylovSchur::initialize() method, which is
    called by the user or from the BlockKrylovSchur::iterate() method if isInitialized()
    == ``false``.

    In the case that this exception is thrown,
    BlockKrylovSchur::isInitialized() will be ``false`` and the user will need to provide
    a new initial iterate to the solver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.BlockKrylovSchurInitFailure_swiginit(self, _Anasazi.new_BlockKrylovSchurInitFailure(*args))
    __swig_destroy__ = _Anasazi.delete_BlockKrylovSchurInitFailure

# Register BlockKrylovSchurInitFailure in _Anasazi:
_Anasazi.BlockKrylovSchurInitFailure_swigregister(BlockKrylovSchurInitFailure)
class BlockKrylovSchurOrthoFailure(AnasaziError):
    r"""
     BlockKrylovSchurOrthoFailure is thrown when the orthogonalization manager is
    unable to generate orthonormal columns from the new basis vectors.

    This exception is thrown from the BlockKrylovSchur::iterate() method.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.BlockKrylovSchurOrthoFailure_swiginit(self, _Anasazi.new_BlockKrylovSchurOrthoFailure(*args))
    __swig_destroy__ = _Anasazi.delete_BlockKrylovSchurOrthoFailure

# Register BlockKrylovSchurOrthoFailure in _Anasazi:
_Anasazi.BlockKrylovSchurOrthoFailure_swigregister(BlockKrylovSchurOrthoFailure)
class LOBPCGRitzFailure(AnasaziError):
    r"""
     LOBPCGRitzFailure is thrown when the LOBPCG solver is unable to
     continue a call to LOBPCG::iterate() due to a failure of the algorithm.

     This signals that the Rayleigh-Ritz analysis over the subspace
    ``colsp([X`` H P]) detected ill-conditioning of the projected mass matrix
     and the inability to generate a set of orthogonal eigenvectors for
     the projected problem.

     This exception is only thrown from the LOBPCG::iterate() routine. After
     catching this exception, the user can recover the subspace via
     LOBPCG::getState(). This information can be used to restart the solver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.LOBPCGRitzFailure_swiginit(self, _Anasazi.new_LOBPCGRitzFailure(*args))
    __swig_destroy__ = _Anasazi.delete_LOBPCGRitzFailure

# Register LOBPCGRitzFailure in _Anasazi:
_Anasazi.LOBPCGRitzFailure_swigregister(LOBPCGRitzFailure)
class LOBPCGInitFailure(AnasaziError):
    r"""
     LOBPCGInitFailure is thrown when the LOBPCG solver is unable to
    generate an initial iterate in the LOBPCG::initialize() routine.

    This exception is thrown from the LOBPCG::initialize() method, which is
    called by the user or from the LOBPCG::iterate() method when isInitialized()
    == ``false``.

    In the case that this exception is thrown, LOBPCG::hasP() and
    LOBPCG::isInitialized() will be ``false`` and the user will need to provide
    a new initial iterate to the solver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.LOBPCGInitFailure_swiginit(self, _Anasazi.new_LOBPCGInitFailure(*args))
    __swig_destroy__ = _Anasazi.delete_LOBPCGInitFailure

# Register LOBPCGInitFailure in _Anasazi:
_Anasazi.LOBPCGInitFailure_swigregister(LOBPCGInitFailure)
class LOBPCGOrthoFailure(AnasaziError):
    r"""
     LOBPCGOrthoFailure is thrown when an orthogonalization attempt
    fails.

    This is thrown in one of two scenarstd::ios. After preconditioning the residual,
    the orthogonalization manager is asked to orthogonalize the preconditioned
    residual (H) against the auxiliary vectors. If full orthogonalization
    is enabled, H is also orthogonalized against X and P and normalized.

    The second scenario involves the generation of new X and P from the
    basis [X H P]. When full orthogonalization is enabled, an attempt is
    made to select coefficients for X and P so that they will be
    mutually orthogonal and orthonormal.

    If either of these attempts fail, the solver throws an LOBPCGOrthoFailure
    exception.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.LOBPCGOrthoFailure_swiginit(self, _Anasazi.new_LOBPCGOrthoFailure(*args))
    __swig_destroy__ = _Anasazi.delete_LOBPCGOrthoFailure

# Register LOBPCGOrthoFailure in _Anasazi:
_Anasazi.LOBPCGOrthoFailure_swigregister(LOBPCGOrthoFailure)
class EpetraMultiVecFailure(AnasaziError):
    r"""
     EpetraMultiVecFailure is thrown when a return value from an Epetra
    call on an Epetra_MultiVector is non-zero.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.EpetraMultiVecFailure_swiginit(self, _Anasazi.new_EpetraMultiVecFailure(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraMultiVecFailure

# Register EpetraMultiVecFailure in _Anasazi:
_Anasazi.EpetraMultiVecFailure_swigregister(EpetraMultiVecFailure)
class EpetraOpFailure(AnasaziError):
    r"""
     EpetraOpFailure is thrown when a return value from an Epetra
    call on an Epetra_Operator is non-zero.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Anasazi.EpetraOpFailure_swiginit(self, _Anasazi.new_EpetraOpFailure(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraOpFailure

# Register EpetraOpFailure in _Anasazi:
_Anasazi.EpetraOpFailure_swigregister(EpetraOpFailure)
class EpetraMultiVecAccessor(object):
    r"""
     EpetraMultiVecAccessor is an interfaceto allow any Anasazi::MultiVec implementation
    that is based on Epetra_MultiVector to use the various Anasazi::Operator interfaces defined for Epetra_Operator.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_EpetraMultiVecAccessor

    def GetEpetraMultiVec(self, *args):
        r"""
        *Overload 1:*
        Return the pointer to the Epetra_MultiVector object.

        |

        *Overload 2:*
        Return the pointer to the Epetra_MultiVector object.
        """
        return _Anasazi.EpetraMultiVecAccessor_GetEpetraMultiVec(self, *args)

    def __init__(self, *args):
        _Anasazi.EpetraMultiVecAccessor_swiginit(self, _Anasazi.new_EpetraMultiVecAccessor(*args))

# Register EpetraMultiVecAccessor in _Anasazi:
_Anasazi.EpetraMultiVecAccessor_swigregister(EpetraMultiVecAccessor)
class EpetraMultiVec(MultiVecDouble, Epetra.MultiVector, EpetraMultiVecAccessor):
    r"""
    Basic adapter class for Anasazi::MultiVec that uses Epetra_MultiVector.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Basic EpetraMultiVec constructor. :param Map: [in] An Epetra_LocalMap, Epetra_Map or Epetra_BlockMap.
              :type numvecs: int
              :param numvecs: [in] Number of vectors in multi-vector.

              :return: Pointer to an EpetraMultiVec

        |

        *Overload 2:*
         Copy constructor.

        |

        *Overload 3:*
         Create multi-vector with values from two dimensional array. :param Map: [in] An Epetra_LocalMap, Epetra_Map or Epetra_BlockMap
              :type array: float
              :param array: [in] Pointer to an array of double precision numbers.  The first vector starts at ``array``, the
                  second at ``array+stride``, and so on.  This array is copied.
              :type numvecs: int
              :param numvecs: [in] Number of vectors in the multi-vector.
              :type stride: int, optional
              :param stride: [in] The stride between vectors in memory of ``array``.

              :return: Pointer to an EpetraMultiVec

        |

        *Overload 4:*
         Create multi-vector from list of vectors in an existing EpetraMultiVec. :type CV: int
        :param CV: [in] Enumerated type set to Copy or View.
              :type P_vec: :py:class:`Epetra_MultiVector`
              :param P_vec: [in] An existing fully constructed Epetra_MultiVector.
              :type index: std::vector< int,std::allocator< int > >
              :param index: [in] A integer vector containing the indices of the vectors to copy out of ``P_vec``.

              :return: Pointer to an EpetraMultiVec
        """
        _Anasazi.EpetraMultiVec_swiginit(self, _Anasazi.new_EpetraMultiVec(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraMultiVec

    def Clone(self, *args):
        r"""
        Creates a new empty EpetraMultiVec containing ``numvecs`` columns.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to an EpetraMultiVec
        """
        return _Anasazi.EpetraMultiVec_Clone(self, *args)

    def CloneCopy(self, *args):
        r"""
        *Overload 1:*
        Creates a new EpetraMultiVec and copies contents of ``*this`` into
             the new vector (deep copy).

             :rtype: Anasazi::MultiVec< double >
             :return: Pointer to an EpetraMultiVec

        |

        *Overload 2:*
        Creates a new EpetraMultiVec and copies the selected contents of ``*this``
             into the new vector (deep copy).

             The copied vectors from ``*this`` are indicated by the ``index.size()`` indices in ``index``.

             :rtype: Anasazi::MultiVec< double >
             :return: Pointer to an EpetraMultiVec
        """
        return _Anasazi.EpetraMultiVec_CloneCopy(self, *args)

    def CloneViewNonConst(self, *args):
        r"""
        Creates a new EpetraMultiVec that shares the selected contents of ``*this``.

           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to an EpetraMultiVec
        """
        return _Anasazi.EpetraMultiVec_CloneViewNonConst(self, *args)

    def CloneView(self, *args):
        r"""
        Creates a new EpetraMultiVec that shares the selected contents of ``*this``.

           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to an EpetraMultiVec
        """
        return _Anasazi.EpetraMultiVec_CloneView(self, *args)

    def GetGlobalLength(self, *args):
        r""" The number of rows in the multivector."""
        return _Anasazi.EpetraMultiVec_GetGlobalLength(self, *args)

    def GetNumberVecs(self, *args):
        r""" Obtain the vector length of *this."""
        return _Anasazi.EpetraMultiVec_GetNumberVecs(self, *args)

    def MvTimesMatAddMv(self, *args):
        r""" Update ``*this`` with :math:`\alpha AB + \beta (*this)`."""
        return _Anasazi.EpetraMultiVec_MvTimesMatAddMv(self, *args)

    def MvAddMv(self, *args):
        r""" Replace ``*this`` with :math:`\alpha A + \beta B`."""
        return _Anasazi.EpetraMultiVec_MvAddMv(self, *args)

    def MvTransMv(self, *args):
        r""" Compute a dense matrix ``B`` through the matrix-matrix multiply :math:`\alpha A^T(*this)`."""
        return _Anasazi.EpetraMultiVec_MvTransMv(self, *args)

    def MvDot(self, *args):
        r""" Compute a vector ``b`` where the components are the individual dot-products, i.e. :math:`b[i] = A[i]^H(this[i])` where ``A[i]`` is the i-th column of ``A``."""
        return _Anasazi.EpetraMultiVec_MvDot(self, *args)

    def MvScale(self, *args):
        r"""
        *Overload 1:*
        Scale each element of the vectors in ``*this`` with ``alpha``.

        |

        *Overload 2:*
        Scale each element of the ``i-th`` vector in ``*this`` with ``alpha[i]``.
        """
        return _Anasazi.EpetraMultiVec_MvScale(self, *args)

    def MvNorm(self, *args):
        r"""
        Compute the 2-norm of each individual vector of ``*this``.
             Upon return, ``normvec[i]`` holds the 2-norm of the ``i-th`` vector of ``*this``
        """
        return _Anasazi.EpetraMultiVec_MvNorm(self, *args)

    def SetBlock(self, *args):
        r"""
        Copy the vectors in ``A`` to a set of vectors in ``*this``.

           The ``numvecs`` vectors in ``A`` are copied to a subset of vectors in ``*this``
           indicated by the indices given in ``index``.
        """
        return _Anasazi.EpetraMultiVec_SetBlock(self, *args)

    def MvRandom(self, *args):
        r""" Fill the vectors in ``*this`` with random numbers."""
        return _Anasazi.EpetraMultiVec_MvRandom(self, *args)

    def MvInit(self, *args):
        r""" Replace each element of the vectors in ``*this`` with ``alpha``."""
        return _Anasazi.EpetraMultiVec_MvInit(self, *args)

    def GetEpetraMultiVec(self, *args):
        r"""
        *Overload 1:*
        Return the pointer to the Epetra_MultiVector object.

        |

        *Overload 2:*
        Return the pointer to the Epetra_MultiVector object.
        """
        return _Anasazi.EpetraMultiVec_GetEpetraMultiVec(self, *args)

    def MvPrint(self, *args):
        r""" Print ``*this`` EpetraMultiVec."""
        return _Anasazi.EpetraMultiVec_MvPrint(self, *args)

# Register EpetraMultiVec in _Anasazi:
_Anasazi.EpetraMultiVec_swigregister(EpetraMultiVec)
class EpetraOp(OperatorDouble):
    r"""
    Basic adapter class for Anasazi::Operator that uses Epetra_Operator.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Basic constructor.  Accepts reference-counted pointer to an Epetra_Operator."""
        _Anasazi.EpetraOp_swiginit(self, _Anasazi.new_EpetraOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraOp

    def Apply(self, *args):
        r"""
        This method takes the Anasazi::MultiVec ``X`` and
             applies the operator to it resulting in the Anasazi::MultiVec ``Y``.
        """
        return _Anasazi.EpetraOp_Apply(self, *args)

# Register EpetraOp in _Anasazi:
_Anasazi.EpetraOp_swigregister(EpetraOp)
class EpetraGenOp(OperatorDouble, Epetra.Operator):
    r"""
    Adapter class for creating an operators often used in solving generalized eigenproblems.

    This class will apply the operation :math:`A^{-1}M` [default] or :math:`AM`, for the ``Apply`` method of the
    Epetra_Operator / Anasazi::Operator.  The Anasazi::EpetraGenOp operator is useful when spectral
    transformations are used within eigensolvers.  For instance, :math:`A^{-1}M` is a shift and invert
    spectral transformation commonly used with Anasazi::BlockKrylovSchur to compute the smallest-magnitude
    eigenvalues for the eigenproblem :math:`Ax = \lambda Mx`.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Basic constructor for applying operator :math:`A^{-1}M` [default] or :math:`AM`. If ``isAInverse`` is true this operator will apply :math:`A^{-1}M`, else
             it will apply :math:`AM`.
        """
        _Anasazi.EpetraGenOp_swiginit(self, _Anasazi.new_EpetraGenOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraGenOp

    def Apply(self, *args):
        r"""
        *Overload 1:*
        Apply method [inherited from Anasazi::Operator class] This method will apply :math:`A^{-1}M` or :math:`AM` to ``X``, returning ``Y``.

        |

        *Overload 2:*
        Apply method [inherited from Epetra_Operator class] This method will apply :math:`A^{-1}M` or :math:`AM` to ``X``, returning ``Y``.
        """
        return _Anasazi.EpetraGenOp_Apply(self, *args)

    def ApplyInverse(self, *args):
        r""" Apply inverse method [inherited from Epetra_Operator class] This method will apply :math:`(A^{-1}M)^{-1}` or :math:`(AM)^{-1}` to ``X``, returning ``Y``."""
        return _Anasazi.EpetraGenOp_ApplyInverse(self, *args)

    def Label(self, *args):
        r""" Returns a character string describing the operator."""
        return _Anasazi.EpetraGenOp_Label(self, *args)

    def UseTranspose(self, *args):
        r""" Returns the current UseTranspose setting [always false for this operator]."""
        return _Anasazi.EpetraGenOp_UseTranspose(self, *args)

    def SetUseTranspose(self, *args):
        r""" If set true, the transpose of this operator will be applied [not functional for this operator]."""
        return _Anasazi.EpetraGenOp_SetUseTranspose(self, *args)

    def HasNormInf(self, *args):
        r""" Returns true if this object can provide an approximate inf-norm [always false for this operator]."""
        return _Anasazi.EpetraGenOp_HasNormInf(self, *args)

    def NormInf(self, *args):
        r""" Returns the infinity norm of the global matrix [not functional for this operator]."""
        return _Anasazi.EpetraGenOp_NormInf(self, *args)

    def Comm(self, *args):
        r""" Returns the Epetra_Comm communicator associated with this operator."""
        return _Anasazi.EpetraGenOp_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _Anasazi.EpetraGenOp_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _Anasazi.EpetraGenOp_OperatorRangeMap(self, *args)

# Register EpetraGenOp in _Anasazi:
_Anasazi.EpetraGenOp_swigregister(EpetraGenOp)
class EpetraSymOp(OperatorDouble, Epetra.Operator):
    r"""
    Adapter class for creating a symmetric operator from an Epetra_Operator.

    This class will apply the operation :math:`A^TA` [default] or :math:`AA^T`, for the ``Apply`` method of the
    Epetra_Operator / Anasazi::Operator.  The Anasazi::EpetraSymOp operator is useful when trying to compute
    a few singular values of the operator :math:`A`.  The singular values are the square-root of the eigenvalues
    of :math:`A^TA` and :math:`AA^T`.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Basic constructor for applying operator :math:`A^TA` [default] or :math:`AA^T`. If ``isTrans`` is false this operator will apply :math:`A^TA`, else it will apply :math:`AA^T`."""
        _Anasazi.EpetraSymOp_swiginit(self, _Anasazi.new_EpetraSymOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraSymOp

    def Apply(self, *args):
        r"""
        *Overload 1:*
        Apply method [inherited from Anasazi::Operator class] This method will apply :math:`A^TA` or :math:`AA^T` to ``X``, returning ``Y``.

        |

        *Overload 2:*
        Apply method [inherited from Epetra_Operator class] This method will apply :math:`A^TA` or :math:`AA^T` to ``X``, returning ``Y``.
        """
        return _Anasazi.EpetraSymOp_Apply(self, *args)

    def ApplyInverse(self, *args):
        r"""
        Apply inverse method [inherited from Epetra_Operator class] This method will apply :math:`(A^TA)^{-1}` or :math:`(AA^T)^{-1}` to ``X``, returning ``Y``.
             Notes: This method is only defined if :math:`A^{-1}` is defined for the given Epetra_Operator.
        """
        return _Anasazi.EpetraSymOp_ApplyInverse(self, *args)

    def Label(self, *args):
        r""" Returns a character string describing the operator."""
        return _Anasazi.EpetraSymOp_Label(self, *args)

    def UseTranspose(self, *args):
        r""" Returns the current UseTranspose setting [always false for this operator]."""
        return _Anasazi.EpetraSymOp_UseTranspose(self, *args)

    def SetUseTranspose(self, *args):
        r""" If set true, the transpose of this operator will be applied [not functional for this operator]."""
        return _Anasazi.EpetraSymOp_SetUseTranspose(self, *args)

    def HasNormInf(self, *args):
        r""" Returns true if this object can provide an approximate inf-norm [always false for this operator]."""
        return _Anasazi.EpetraSymOp_HasNormInf(self, *args)

    def NormInf(self, *args):
        r""" Returns the infinity norm of the global matrix [not functional for this operator]."""
        return _Anasazi.EpetraSymOp_NormInf(self, *args)

    def Comm(self, *args):
        r""" Returns the Epetra_Comm communicator associated with this operator."""
        return _Anasazi.EpetraSymOp_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _Anasazi.EpetraSymOp_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _Anasazi.EpetraSymOp_OperatorRangeMap(self, *args)

# Register EpetraSymOp in _Anasazi:
_Anasazi.EpetraSymOp_swigregister(EpetraSymOp)
class EpetraSymMVOp(OperatorDouble):
    r"""
    Adapter class for creating a symmetric operator from an Epetra_MultiVector.

    This class will apply the operation :math:`A^TA` [default] or :math:`AA^T`, for the ``Apply`` method of the
    Epetra_Operator / Anasazi::Operator.  The Anasazi::EpetraSymMvOp operator is useful when trying to compute
    a few singular values of the Epetra_MultiVector :math:`A`.  The singular values are the square-root of the
    eigenvalues of :math:`A^TA` and :math:`AA^T`.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Basic constructor for applying operator :math:`A^TA` [default] or :math:`AA^T`. If ``isTrans`` is false this operator will apply :math:`A^TA`, else it will apply :math:`AA^T`."""
        _Anasazi.EpetraSymMVOp_swiginit(self, _Anasazi.new_EpetraSymMVOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraSymMVOp

    def Apply(self, *args):
        r""" Apply method  This method will apply :math:`A^TA` or :math:`AA^T` to ``X``, returning ``Y``."""
        return _Anasazi.EpetraSymMVOp_Apply(self, *args)

# Register EpetraSymMVOp in _Anasazi:
_Anasazi.EpetraSymMVOp_swigregister(EpetraSymMVOp)
class EpetraWSymMVOp(OperatorDouble):
    r"""
    Adapter class for creating a weighted operator from an Epetra_MultiVector and Epetra_Operator.

    This class will apply the operation :math:`A^T*W*A` for the ``Apply`` method of the
    Anasazi::Operator.  The Anasazi::EpetraWSymMvOp operator is useful when trying to compute
    a few singular values of the Epetra_MultiVector :math:`A` under the weighting matrix :math:`W`.
    The singular values are the square-root of the eigenvalues of :math:`A^T*W*A`.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Basic constructor for applying operator :math:`A^T*W*A`."""
        _Anasazi.EpetraWSymMVOp_swiginit(self, _Anasazi.new_EpetraWSymMVOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraWSymMVOp

    def Apply(self, *args):
        r""" Apply method  This method will apply :math:`(WA)^T*WA` to ``X``, returning ``Y``."""
        return _Anasazi.EpetraWSymMVOp_Apply(self, *args)

# Register EpetraWSymMVOp in _Anasazi:
_Anasazi.EpetraWSymMVOp_swigregister(EpetraWSymMVOp)
class EpetraW2SymMVOp(OperatorDouble):
    r"""
    Adapter class for creating a weighted symmetric operator from an Epetra_MultiVector and Epetra_Operator.

    This class will apply the operation :math:`(WA)^T*WA` for the ``Apply`` method of the
    Anasazi::Operator.  The Anasazi::EpetraW2SymMvOp operator is useful when trying to compute
    a few singular values of the Epetra_MultiVector :math:`A` under the weighting matrix :math:`W`.
    The singular values are the square-root of the eigenvalues of :math:`(WA)^T*WA`.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Basic constructor for applying operator :math:`A^T*W*A`."""
        _Anasazi.EpetraW2SymMVOp_swiginit(self, _Anasazi.new_EpetraW2SymMVOp(*args))
    __swig_destroy__ = _Anasazi.delete_EpetraW2SymMVOp

    def Apply(self, *args):
        r""" Apply method  This method will apply :math:`(WA)^T*WA` to ``X``, returning ``Y``."""
        return _Anasazi.EpetraW2SymMVOp_Apply(self, *args)

# Register EpetraW2SymMVOp in _Anasazi:
_Anasazi.EpetraW2SymMVOp_swigregister(EpetraW2SymMVOp)
class SortManagerEpetra(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_SortManagerEpetra

    def sort(self, *args):
        r"""
        *Overload 1:*
        Sort real eigenvalues, optionally returning the permutation vector.

              :type evals: std::vector< double,std::allocator< double > >
              :param evals: [in/out] Vector of length at least ``n`` containing the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type perm: std::vector<int,std::allocator<int> >, optional
              :param perm: [out] Vector of length at least ``n`` to store the permutation index (optional).  

                  If specified, on output the first ``n`` eigenvalues will contain the permutation indices, in the range [0,n-1], such that evals_out[i] = evals_in[perm[i]]

              :type n: int, optional
              :param n: [in] Number of values in evals to be sorted. If n == -1, all values will be sorted.

        |

        *Overload 2:*
        Sort complex eigenvalues, optionally returning the permutation vector.

              This routine takes two vectors, one for each part of a complex
              eigenvalue. This is helpful for solving real, non-symmetric eigenvalue
              problems.

              :type r_evals: std::vector< double,std::allocator< double > >
              :param r_evals: [in/out] Vector of length at least ``n`` containing the real part of the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type i_evals: std::vector< double,std::allocator< double > >
              :param i_evals: [in/out] Vector of length at least ``n`` containing the imaginary part of the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type perm: std::vector<int,std::allocator<int> >, optional
              :param perm: [out] Vector of length at least ``n`` to store the permutation index (optional).  

                  If specified, on output the first ``n`` eigenvalues will contain the permutation indices, in the range [0,n-1], such that r_evals_out[i] = r_evals_in[perm[i]]
                  and similarly for ``i_evals``.

              :type n: int, optional
              :param n: [in] Number of values in ``r_evals``, ``i_evals`` to be sorted. If n == -1, all values will be sorted.
        """
        return _Anasazi.SortManagerEpetra_sort(self, *args)

# Register SortManagerEpetra in _Anasazi:
_Anasazi.SortManagerEpetra_swigregister(SortManagerEpetra)
class BasicSortEpetra(SortManagerEpetra):
    r"""
    An implementation of the Anasazi::SortManager that performs a collection
    of common sorting techniques.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Parameter list driven constructor

               This constructor accepts a paramter list with the following options:
              - ``"Sort Strategy"`` - a ``string`` specifying the desired sorting strategy. See setSortType() for valid options.

        |

        *Overload 2:*
        String driven constructor

               Directly pass the string specifying sort strategy. See setSortType() for valid options.
        """
        _Anasazi.BasicSortEpetra_swiginit(self, _Anasazi.new_BasicSortEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BasicSortEpetra

    def setSortType(self, *args):
        r"""
        Set sort type
              :type which: string
              :param which: [in] The eigenvalues of interest for this eigenproblem.
                  - ``"LM"`` - Largest Magnitude [ default ]
                  - ``"SM"`` - Smallest Magnitude
                  - ``"LR"`` - Largest Real
                  - ``"SR"`` - Smallest Real
                  - ``"LI"`` - Largest Imaginary
                  - ``"SI"`` - Smallest Imaginary
        """
        return _Anasazi.BasicSortEpetra_setSortType(self, *args)

    def sort(self, *args):
        r"""
        *Overload 1:*
        Sort real eigenvalues, optionally returning the permutation vector.

              Notes: This method is not valid when the sort manager is configured for "LI" or "SI" sorting
              (i.e., sorting by the imaginary components). Calling this method in that scenario will result
              in a SortManagerError exception.

              :type evals: std::vector< double,std::allocator< double > >
              :param evals: [in/out] Vector of length at least ``n`` containing the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type perm: std::vector<int,std::allocator<int> >, optional
              :param perm: [out] Vector of length at least ``n`` to store the permutation index (optional).  

                  If specified, on output the first ``n`` eigenvalues will contain the permutation indices, in the range [0,n-1], such that evals_out[i] = evals_in[perm[i]]

              :type n: int, optional
              :param n: [in] Number of values in evals to be sorted. If n == -1, all values will be sorted.

        |

        *Overload 2:*
        Sort complex eigenvalues, optionally returning the permutation vector.

              This routine takes two vectors, one for each part of a complex
              eigenvalue. This is helpful for solving real, non-symmetric eigenvalue
              problems.

              :type r_evals: std::vector< double,std::allocator< double > >
              :param r_evals: [in/out] Vector of length at least ``n`` containing the real part of the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type i_evals: std::vector< double,std::allocator< double > >
              :param i_evals: [in/out] Vector of length at least ``n`` containing the imaginary part of the eigenvalues to be sorted.  

                                On output, the first ``n`` eigenvalues will be sorted. The rest will be unchanged.

              :type perm: std::vector<int,std::allocator<int> >, optional
              :param perm: [out] Vector of length at least ``n`` to store the permutation index (optional).  

                  If specified, on output the first ``n`` eigenvalues will contain the permutation indices, in the range [0,n-1], such that r_evals_out[i] = r_evals_in[perm[i]]
                  and similarly for ``i_evals``.

              :type n: int, optional
              :param n: [in] Number of values in ``r_evals``, ``i_evals`` to be sorted. If n == -1, all values will be sorted, as decided by the minimum of the length of ``r_evals`` and the length of ``i_evals``.
        """
        return _Anasazi.BasicSortEpetra_sort(self, *args)

# Register BasicSortEpetra in _Anasazi:
_Anasazi.BasicSortEpetra_swigregister(BasicSortEpetra)
class MultiVecTraitsEpetra(object):
    r"""
    Template specialization of Anasazi::MultiVecTraits class using the Epetra_MultiVector class.

    This interface will ensure that any Epetra_MultiVector will be accepted by the Anasazi
    templated solvers.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    @staticmethod
    def Clone(*args):
        r"""
        Creates a new empty Epetra_MultiVector containing ``numVecs`` columns.

           :rtype: Teuchos::RCP< Epetra_MultiVector >
           :return: Reference-counted pointer to the new Epetra_MultiVector.
        """
        return _Anasazi.MultiVecTraitsEpetra_Clone(*args)

    @staticmethod
    def CloneCopy(*args):
        return _Anasazi.MultiVecTraitsEpetra_CloneCopy(*args)

    @staticmethod
    def CloneViewNonConst(*args):
        return _Anasazi.MultiVecTraitsEpetra_CloneViewNonConst(*args)

    @staticmethod
    def CloneView(*args):
        return _Anasazi.MultiVecTraitsEpetra_CloneView(*args)

    @staticmethod
    def GetGlobalLength(*args):
        r""" Obtain the vector length of ``mv``."""
        return _Anasazi.MultiVecTraitsEpetra_GetGlobalLength(*args)

    @staticmethod
    def GetNumberVecs(*args):
        r""" Obtain the number of vectors in ``mv``"""
        return _Anasazi.MultiVecTraitsEpetra_GetNumberVecs(*args)

    @staticmethod
    def HasConstantStride(*args):
        return _Anasazi.MultiVecTraitsEpetra_HasConstantStride(*args)

    @staticmethod
    def MvTimesMatAddMv(*args):
        r""" Update ``mv`` with :math:`\alpha AB + \beta mv`."""
        return _Anasazi.MultiVecTraitsEpetra_MvTimesMatAddMv(*args)

    @staticmethod
    def MvAddMv(*args):
        r""" Replace ``mv`` with :math:`\alpha A + \beta B`."""
        return _Anasazi.MultiVecTraitsEpetra_MvAddMv(*args)

    @staticmethod
    def MvTransMv(*args):
        r""" Compute a dense matrix ``B`` through the matrix-matrix multiply :math:`\alpha A^Tmv`."""
        return _Anasazi.MultiVecTraitsEpetra_MvTransMv(*args)

    @staticmethod
    def MvDot(*args):
        r""" Compute a vector ``b`` where the components are the individual dot-products of the ``i-th`` columns of ``A`` and ``mv``, i.e.:math:`b[i] = A[i]^Tmv[i]`."""
        return _Anasazi.MultiVecTraitsEpetra_MvDot(*args)

    @staticmethod
    def MvNorm(*args):
        r"""
        Compute the 2-norm of each individual vector of ``mv``.
             Upon return, ``normvec[i]`` holds the value of :math:`||mv_i||_2`, the ``i-th`` column of ``mv``.
        """
        return _Anasazi.MultiVecTraitsEpetra_MvNorm(*args)

    @staticmethod
    def SetBlock(*args):
        return _Anasazi.MultiVecTraitsEpetra_SetBlock(*args)

    @staticmethod
    def Assign(*args):
        return _Anasazi.MultiVecTraitsEpetra_Assign(*args)

    @staticmethod
    def MvScale(*args):
        r"""
        *Overload 1:*
        Scale each element of the vectors in ``mv`` with ``alpha``.

        |

        *Overload 2:*
        Scale each element of the ``i-th`` vector in ``mv`` with ``alpha[i]``.
        """
        return _Anasazi.MultiVecTraitsEpetra_MvScale(*args)

    @staticmethod
    def MvRandom(*args):
        r""" Replace the vectors in ``mv`` with random vectors."""
        return _Anasazi.MultiVecTraitsEpetra_MvRandom(*args)

    @staticmethod
    def MvInit(*args):
        r""" Replace each element of the vectors in ``mv`` with ``alpha``."""
        return _Anasazi.MultiVecTraitsEpetra_MvInit(*args)

    @staticmethod
    def MvPrint(*args):
        r""" Print the ``mv`` multi-vector to the ``os`` output stream."""
        return _Anasazi.MultiVecTraitsEpetra_MvPrint(*args)

    def __init__(self, *args):
        _Anasazi.MultiVecTraitsEpetra_swiginit(self, _Anasazi.new_MultiVecTraitsEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_MultiVecTraitsEpetra

# Register MultiVecTraitsEpetra in _Anasazi:
_Anasazi.MultiVecTraitsEpetra_swigregister(MultiVecTraitsEpetra)
class OperatorTraitsEpetra(object):
    r"""
    Template specialization of Anasazi::OperatorTraits class using the Epetra_Operator virtual base class and
    Epetra_MultiVector class.

    This interface will ensure that any Epetra_Operator and Epetra_MultiVector will be accepted by the Anasazi
    templated solvers.

    Notes: The Epetra package performs double-precision arithmetic, so the use of Epetra with Anasazi will
    only provide a double-precision eigensolver.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    @staticmethod
    def Apply(*args):
        r"""
        This method takes the Epetra_MultiVector ``x`` and
             applies the Epetra_Operator ``Op`` to it resulting in the Epetra_MultiVector ``y``.
        """
        return _Anasazi.OperatorTraitsEpetra_Apply(*args)

    def __init__(self, *args):
        _Anasazi.OperatorTraitsEpetra_swiginit(self, _Anasazi.new_OperatorTraitsEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_OperatorTraitsEpetra

# Register OperatorTraitsEpetra in _Anasazi:
_Anasazi.OperatorTraitsEpetra_swigregister(OperatorTraitsEpetra)
class EigenproblemEpetra(object):
    r"""
    This class defines the interface required by an eigensolver and status
    test class to compute solutions to an eigenproblem.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_EigenproblemEpetra

    def setOperator(self, *args):
        r"""
         Set the operator for which eigenvalues will be computed.

        Notes: This may be different from the ``A`` if a spectral transformation
        is employed.  For example, this operator may apply the operation
        :math:`(A-\sigma I)^{-1}` if you are looking for eigenvalues of ``A``
        around :math:`\sigma`.
        """
        return _Anasazi.EigenproblemEpetra_setOperator(self, *args)

    def setA(self, *args):
        r""" Set the operator ``A`` of the eigenvalue problem :math:`Ax=\lambda Mx`."""
        return _Anasazi.EigenproblemEpetra_setA(self, *args)

    def setM(self, *args):
        r""" Set the operator ``M`` of the eigenvalue problem :math:`Ax=\lambda Mx`."""
        return _Anasazi.EigenproblemEpetra_setM(self, *args)

    def setPrec(self, *args):
        r""" Set the preconditioner for this eigenvalue problem :math:`Ax=\lambda Mx`."""
        return _Anasazi.EigenproblemEpetra_setPrec(self, *args)

    def setInitVec(self, *args):
        r"""
         Set the initial guess.

        Notes: This multivector should have the same number of columns as the blocksize.
        """
        return _Anasazi.EigenproblemEpetra_setInitVec(self, *args)

    def setAuxVecs(self, *args):
        r"""
         Set auxiliary vectors.

        Notes: This multivector can have any number of columns, and most likely
        will contain vectors that will be used by the eigensolver to
        orthogonalize against.
        """
        return _Anasazi.EigenproblemEpetra_setAuxVecs(self, *args)

    def setNEV(self, *args):
        r""" The number of eigenvalues (NEV) that are requested."""
        return _Anasazi.EigenproblemEpetra_setNEV(self, *args)

    def setHermitian(self, *args):
        r"""
        Specify the symmetry of the eigenproblem.

        This knowledge may allow the solver to take advantage of the eigenproblems' symmetry.
        Some computational work may be avoided by setting this properly.
        """
        return _Anasazi.EigenproblemEpetra_setHermitian(self, *args)

    def setProblem(self, *args):
        r"""
         Specify that this eigenproblem is fully defined.

        This routine serves multiple purpose:

        *  sanity check that the eigenproblem has been fully and consistently defined
        *  opportunity for the eigenproblem to allocate internal storage for eigenvalues
        and eigenvectors (to be used by eigensolvers and solver managers)


        Notes: The user MUST call this routine before they send the eigenproblem to any solver or solver manager.

        :rtype: boolean
        :return: ``true`` signifies success, ``false`` signifies error.
        """
        return _Anasazi.EigenproblemEpetra_setProblem(self, *args)

    def setSolution(self, *args):
        r"""
         Set the solution to the eigenproblem.

        This mechanism allows an Eigensolution struct to be associated with an Eigenproblem object.
        setSolution() is usually called by a solver manager at the end of its SolverManager::solve()
        routine.
        """
        return _Anasazi.EigenproblemEpetra_setSolution(self, *args)

    def getOperator(self, *args):
        r""" Get a pointer to the operator for which eigenvalues will be computed."""
        return _Anasazi.EigenproblemEpetra_getOperator(self, *args)

    def getA(self, *args):
        r""" Get a pointer to the operator ``A`` of the eigenproblem :math:`AX=\lambda Mx`."""
        return _Anasazi.EigenproblemEpetra_getA(self, *args)

    def getM(self, *args):
        r""" Get a pointer to the operator ``M`` of the eigenproblem :math:`AX=\lambda Mx`."""
        return _Anasazi.EigenproblemEpetra_getM(self, *args)

    def getPrec(self, *args):
        r""" Get a pointer to the preconditioner."""
        return _Anasazi.EigenproblemEpetra_getPrec(self, *args)

    def getInitVec(self, *args):
        r""" Get a pointer to the initial vector"""
        return _Anasazi.EigenproblemEpetra_getInitVec(self, *args)

    def getAuxVecs(self, *args):
        r""" Get a pointer to the auxiliary vector"""
        return _Anasazi.EigenproblemEpetra_getAuxVecs(self, *args)

    def getNEV(self, *args):
        r""" Get the number of eigenvalues (NEV) that are required by this eigenproblem."""
        return _Anasazi.EigenproblemEpetra_getNEV(self, *args)

    def isHermitian(self, *args):
        r""" Get the symmetry information for this eigenproblem."""
        return _Anasazi.EigenproblemEpetra_isHermitian(self, *args)

    def isProblemSet(self, *args):
        r""" If the problem has been set, this method will return true."""
        return _Anasazi.EigenproblemEpetra_isProblemSet(self, *args)

    def getSolution(self, *args):
        r"""
         Get the solution to the eigenproblem.

        There is no computation associated with this method. It only provides a
        mechanism for associating an Eigensolution with a Eigenproblem.
        """
        return _Anasazi.EigenproblemEpetra_getSolution(self, *args)

# Register EigenproblemEpetra in _Anasazi:
_Anasazi.EigenproblemEpetra_swigregister(EigenproblemEpetra)
class BasicEigenproblemEpetra(EigenproblemEpetra):
    r"""
    This provides a basic implementation for defining standard or
    generalized eigenvalue problems.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Empty constructor - allows Anasazi::BasicEigenproblem to be described at a later time through "Set Methods".

        |

        *Overload 2:*
        Standard Eigenvalue Problem Constructor.

        |

        *Overload 3:*
        Generalized Eigenvalue Problem Constructor.

        |

        *Overload 4:*
        Copy Constructor.
        """
        _Anasazi.BasicEigenproblemEpetra_swiginit(self, _Anasazi.new_BasicEigenproblemEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BasicEigenproblemEpetra

    def setOperator(self, *args):
        r"""
        Set the operator for which eigenvalues will be computed.

           Notes: This may be different from the ``A`` if a spectral transformation is employed.
           For example, this operator may apply the operation :math:`(A-\sigma I)^{-1}` if you are
           looking for eigenvalues of ``A`` around :math:`\sigma`.
        """
        return _Anasazi.BasicEigenproblemEpetra_setOperator(self, *args)

    def setA(self, *args):
        r""" Set the operator ``A`` of the eigenvalue problem :math:`Ax=Mx\lambda`."""
        return _Anasazi.BasicEigenproblemEpetra_setA(self, *args)

    def setM(self, *args):
        r""" Set the operator ``M`` of the eigenvalue problem :math:`Ax = Mx\lambda`."""
        return _Anasazi.BasicEigenproblemEpetra_setM(self, *args)

    def setPrec(self, *args):
        r""" Set the preconditioner for this eigenvalue problem :math:`Ax = Mx\lambda`."""
        return _Anasazi.BasicEigenproblemEpetra_setPrec(self, *args)

    def setInitVec(self, *args):
        r"""
        Set the initial guess.

           This vector is required to create all the space needed
           by Anasazi to solve the eigenvalue problem.

           Notes: Even if an initial guess is not known by the user, an initial vector must be passed in.
        """
        return _Anasazi.BasicEigenproblemEpetra_setInitVec(self, *args)

    def setAuxVecs(self, *args):
        r"""
        Set auxiliary vectors.

           Notes: This multivector can have any number of columns, and most likely will contain vectors that
           will be used by the eigensolver to orthogonalize against.
        """
        return _Anasazi.BasicEigenproblemEpetra_setAuxVecs(self, *args)

    def setNEV(self, *args):
        r""" Specify the number of eigenvalues (NEV) that are requested."""
        return _Anasazi.BasicEigenproblemEpetra_setNEV(self, *args)

    def setHermitian(self, *args):
        r"""
        Specify the symmetry of this eigenproblem. This knowledge may allow the solver to take advantage of the eigenproblems' symmetry.
             Some computational work can be avoided by setting this properly.
        """
        return _Anasazi.BasicEigenproblemEpetra_setHermitian(self, *args)

    def setProblem(self, *args):
        r"""
         Specify that this eigenproblem is fully defined.

        This routine serves multiple purpose:
           - sanity check that the eigenproblem has been fully and consistently defined
           - opportunity for the eigenproblem to allocate internal storage for eigenvalues
        and eigenvectors (to be used by eigensolvers and solver managers)


        This method reallocates internal storage, so that any previously retrieved references to
        internal storage (eigenvectors or eigenvalues) are invalidated.

        Notes: The user MUST call this routine before they send the eigenproblem to any solver or solver manager.

        :rtype: boolean
        :return: ``true`` signifies success, ``false`` signifies error.
        """
        return _Anasazi.BasicEigenproblemEpetra_setProblem(self, *args)

    def setSolution(self, *args):
        r"""
         Set the solution to the eigenproblem.

        This mechanism allows an Eigensolution struct to be associated with an Eigenproblem object.
        setSolution() is usually called by a solver manager at the end of its SolverManager::solve()
        routine.
        """
        return _Anasazi.BasicEigenproblemEpetra_setSolution(self, *args)

    def getOperator(self, *args):
        r""" Get a pointer to the operator for which eigenvalues will be computed."""
        return _Anasazi.BasicEigenproblemEpetra_getOperator(self, *args)

    def getA(self, *args):
        r""" Get a pointer to the operator ``A`` of the eigenproblem :math:`Ax=\lambda Mx`."""
        return _Anasazi.BasicEigenproblemEpetra_getA(self, *args)

    def getM(self, *args):
        r""" Get a pointer to the operator ``M`` of the eigenproblem :math:`Ax=\lambda Mx`."""
        return _Anasazi.BasicEigenproblemEpetra_getM(self, *args)

    def getPrec(self, *args):
        r""" Get a pointer to the preconditioner of the eigenproblem :math:`Ax=\lambda Mx`."""
        return _Anasazi.BasicEigenproblemEpetra_getPrec(self, *args)

    def getInitVec(self, *args):
        r""" Get a pointer to the initial vector"""
        return _Anasazi.BasicEigenproblemEpetra_getInitVec(self, *args)

    def getAuxVecs(self, *args):
        r""" Get a pointer to the auxiliary vector"""
        return _Anasazi.BasicEigenproblemEpetra_getAuxVecs(self, *args)

    def getNEV(self, *args):
        r""" Get the number of eigenvalues (NEV) that are required by this eigenproblem."""
        return _Anasazi.BasicEigenproblemEpetra_getNEV(self, *args)

    def isHermitian(self, *args):
        r""" Get the symmetry information for this eigenproblem."""
        return _Anasazi.BasicEigenproblemEpetra_isHermitian(self, *args)

    def isProblemSet(self, *args):
        r""" If the problem has been set, this method will return true."""
        return _Anasazi.BasicEigenproblemEpetra_isProblemSet(self, *args)

    def getSolution(self, *args):
        r"""
         Get the solution to the eigenproblem.

        There is no computation associated with this method. It only provides a
        mechanism for associating an Eigensolution with a Eigenproblem.
        """
        return _Anasazi.BasicEigenproblemEpetra_getSolution(self, *args)

    def computeCurrResVec(self, *args):
        r"""
         Returns the residual vector corresponding to the computed solution

        If there is no computed solution, returns Teuchos::null.

        Notes: If A has not been set, this function will compute :math:`R = OpX-MX\Lambda`
        If you are using a spectral transformation, this may not be what you want.
        """
        return _Anasazi.BasicEigenproblemEpetra_computeCurrResVec(self, *args)

# Register BasicEigenproblemEpetra in _Anasazi:
_Anasazi.BasicEigenproblemEpetra_swigregister(BasicEigenproblemEpetra)
class StatusTestEpetra(object):
    r"""
    Use LOBPCG with Tpetra, with custom StatusTest.

    This example shows how to define a custom StatusTest so that
    Anasazi's solver LOBPCG converges correctly with spectrum folding.
    Without a custom status test, Anasazi would compute the residual
    as :math:`R = A^2 X - X \Sigma^2`.  The custom status test makes
    Anasazi use the residual :math:`R = A X - X \Sigma` instead.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_StatusTestEpetra

    def checkStatus(self, *args):
        r"""
        Check status as defined by test.

           :rtype: int
           :return: TestStatus indicating whether the test passed or failed.
        """
        return _Anasazi.StatusTestEpetra_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call, or undefined if it has not been run."""
        return _Anasazi.StatusTestEpetra_getStatus(self, *args)

    def whichVecs(self, *args):
        r""" Get the indices for the vectors that passed the test."""
        return _Anasazi.StatusTestEpetra_whichVecs(self, *args)

    def howMany(self, *args):
        r""" Get the number of vectors that passed the test."""
        return _Anasazi.StatusTestEpetra_howMany(self, *args)

    def reset(self, *args):
        r"""
        Informs the status test that it should reset its internal configuration to the uninitialized state. This is necessary for the case when the status test is being reused by another solver or for another
           eigenvalue problem. The status test may have information that pertains to a particular problem or solver
           state. The internal information will be reset back to the uninitialized state. The user specified information
           that the convergence test uses will remain.
        """
        return _Anasazi.StatusTestEpetra_reset(self, *args)

    def clearStatus(self, *args):
        r"""
         Clears the results of the last status test. This should be distinguished from the reset() method, as it only clears the cached result from the last
        status test, so that a call to getStatus() will return ::Undefined. This is necessary for the SEQOR and SEQAND
        tests in the StatusTestCombo class, which may short circuit and not evaluate all of the StatusTests contained
        in them.
        """
        return _Anasazi.StatusTestEpetra_clearStatus(self, *args)

# Register StatusTestEpetra in _Anasazi:
_Anasazi.StatusTestEpetra_swigregister(StatusTestEpetra)
class StatusTestComboEpetra(StatusTestEpetra):
    r"""
    Status test for forming logical combinations of other status tests.

    Test types include StatusTestCombo::OR, StatusTestCombo::AND, StatusTestCombo::SEQOR and StatusTestCombo::SEQAND.  The StatusTestCombo::OR and StatusTestCombo::AND tests
    evaluate all of the tests, in the order they were passed to the
    StatusTestCombo.  The StatusTestCombo::SEQOR and StatusTestCombo::SEQAND run only the tests necessary to
    determine the final outcome, short-circuiting on the first test that
    conclusively decides the outcome. More formally, StatusTestCombo::SEQAND runs the tests in
    the order they were given to the StatusTestCombo class and stops after the
    first test that evaluates ::Failed. StatusTestCombo::SEQOR run the tests in the order they
    were given to the StatusTestCombo class and stops after the first test that
    evaluates ::Passed.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    OR = _Anasazi.StatusTestComboEpetra_OR
    r""" Logical OR which evaluates all tests"""
    AND = _Anasazi.StatusTestComboEpetra_AND
    r""" Logical AND which evaluates all tests"""
    SEQOR = _Anasazi.StatusTestComboEpetra_SEQOR
    r""" Short-circuited logical OR"""
    SEQAND = _Anasazi.StatusTestComboEpetra_SEQAND
    r""" Short-circuited logical AND"""

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor Default constructor has no tests and initializes to StatusTestCombo::ComboType StatusTestCombo::OR.

        |

        *Overload 2:*
        Constructor Constructor specifying the StatusTestCombo::ComboType and the tests.
        """
        _Anasazi.StatusTestComboEpetra_swiginit(self, _Anasazi.new_StatusTestComboEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_StatusTestComboEpetra

    def checkStatus(self, *args):
        r"""
        Check status as defined by test.

           :rtype: int
           :return: TestStatus indicating whether the test passed or failed.
        """
        return _Anasazi.StatusTestComboEpetra_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call."""
        return _Anasazi.StatusTestComboEpetra_getStatus(self, *args)

    def whichVecs(self, *args):
        r"""
         Get the indices for the vectors that passed the test.
        This returns some combination of the passing vectors from the
        tests comprising the StatusTestCombo. The nature of the combination depends on the
        StatusTestCombo::ComboType:
           - StatusTestCombo::SEQOR, StatusTestCombo::OR - whichVecs() returns the union of whichVecs() from all evaluated constituent tests
           - StatusTestCombo::SEQAND, StatusTestCombo::AND - whichVecs() returns the intersection of whichVecs() from all evaluated constituent tests
        """
        return _Anasazi.StatusTestComboEpetra_whichVecs(self, *args)

    def howMany(self, *args):
        r""" Get the number of vectors that passed the test."""
        return _Anasazi.StatusTestComboEpetra_howMany(self, *args)

    def setComboType(self, *args):
        r"""
        Set the maximum number of iterations.
        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestComboEpetra_setComboType(self, *args)

    def getComboType(self, *args):
        r""" Get the maximum number of iterations."""
        return _Anasazi.StatusTestComboEpetra_getComboType(self, *args)

    def setTests(self, *args):
        r"""
        Set the tests
        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestComboEpetra_setTests(self, *args)

    def getTests(self, *args):
        r""" Get the tests"""
        return _Anasazi.StatusTestComboEpetra_getTests(self, *args)

    def addTest(self, *args):
        r"""
        Add a test to the combination.

        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestComboEpetra_addTest(self, *args)

    def removeTest(self, *args):
        r"""
         Removes a test from the combination, if it exists in the tester.

        This also resets the test status to ::Undefined, if a test was removed.
        """
        return _Anasazi.StatusTestComboEpetra_removeTest(self, *args)

    def reset(self, *args):
        r"""
        Informs the status test that it should reset its internal configuration to the uninitialized state. The StatusTestCombo class has no internal state, but children classes might, so this method will call
            reset() on all child status tests. It also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestComboEpetra_reset(self, *args)

    def clearStatus(self, *args):
        r"""
         Clears the results of the last status test. This should be distinguished from the reset() method, as it only clears the cached result from the last
        status test, so that a call to getStatus() will return ::Undefined. This is necessary for the StatusTestCombo::SEQOR and StatusTestCombo::SEQAND
        tests in the StatusTestCombo class, which may short circuit and not evaluate all of the StatusTests contained
        in them.
        """
        return _Anasazi.StatusTestComboEpetra_clearStatus(self, *args)

# Register StatusTestComboEpetra in _Anasazi:
_Anasazi.StatusTestComboEpetra_swigregister(StatusTestComboEpetra)
class StatusTestMaxItersEpetra(StatusTestEpetra):
    r"""
    A status test for testing the number of iterations.

    Anasazi::StatusTestMaxIters will test true when an eigensolver has reached some number
    of iterations. Specifically,

                     { Passed,  if solver->getNumIters() >= maxIter
    status(solver) = {
                     { Failed,  if solver->getNumIters()  < maxIter

    where maxIter is the parameter given to the status tester.

    This status test also supports negation, so that it negates the need for a
    StatusTestMinIters status tester. In this way, all tests on the range of iterations
    can be constructed through the appropriate use of StatusTestMaxIters and StatusTestCombo.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _Anasazi.StatusTestMaxItersEpetra_swiginit(self, _Anasazi.new_StatusTestMaxItersEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_StatusTestMaxItersEpetra

    def checkStatus(self, *args):
        r"""
        Check status as defined by test.
           :rtype: int
           :return: TestStatus indicating whether the test passed or failed.
        """
        return _Anasazi.StatusTestMaxItersEpetra_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call."""
        return _Anasazi.StatusTestMaxItersEpetra_getStatus(self, *args)

    def whichVecs(self, *args):
        r""" Get the indices for the vectors that passed the test."""
        return _Anasazi.StatusTestMaxItersEpetra_whichVecs(self, *args)

    def howMany(self, *args):
        r""" Get the number of vectors that passed the test."""
        return _Anasazi.StatusTestMaxItersEpetra_howMany(self, *args)

    def setMaxIters(self, *args):
        r"""
        Set the maximum number of iterations.
        Notes: This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestMaxItersEpetra_setMaxIters(self, *args)

    def getMaxIters(self, *args):
        r""" Get the maximum number of iterations."""
        return _Anasazi.StatusTestMaxItersEpetra_getMaxIters(self, *args)

    def setNegate(self, *args):
        r"""
        Set the negation policy for the status test.
        Notes: This also reset the test status to ::Undefined.
        """
        return _Anasazi.StatusTestMaxItersEpetra_setNegate(self, *args)

    def getNegate(self, *args):
        r""" Get the negation policy for the status test."""
        return _Anasazi.StatusTestMaxItersEpetra_getNegate(self, *args)

    def reset(self, *args):
        r"""
        Informs the status test that it should reset its internal configuration to the uninitialized state. The StatusTestMaxIters class has no internal state, so this call is equivalent to calling clearStatus().
           eigenvalue problem. The status test may have information that pertains to a particular problem or solver
           state. The internal information will be reset back to the uninitialized state. The user specified information
           that the convergence test uses will remain.
        """
        return _Anasazi.StatusTestMaxItersEpetra_reset(self, *args)

    def clearStatus(self, *args):
        r"""
         Clears the results of the last status test. This should be distinguished from the reset() method, as it only clears the cached result from the last
        status test, so that a call to getStatus() will return ::Undefined. This is necessary for the SEQOR and SEQAND
        tests in the StatusTestCombo class, which may short circuit and not evaluate all of the StatusTests contained
        in them.
        """
        return _Anasazi.StatusTestMaxItersEpetra_clearStatus(self, *args)

# Register StatusTestMaxItersEpetra in _Anasazi:
_Anasazi.StatusTestMaxItersEpetra_swigregister(StatusTestMaxItersEpetra)
class StatusTestOutputEpetra(StatusTestEpetra):
    r"""
    A special StatusTest for printing other status tests.

    StatusTestOutput is a wrapper around another StatusTest that calls
    StatusTest::print() on the underlying object on calls to StatusTestOutput::checkStatus().
    The frequency and occasion of the printing can be dictated according to some parameters passed to
    StatusTestOutput::StatusTestOutput().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Constructor

        The StatusTestOutput requires an OutputManager for printing the underlying StatusTest on
        calls to checkStatus(), as well as an underlying StatusTest.

        StatusTestOutput can be initialized with a null pointer for argument ``test``. However, calling checkStatus() with a null child pointer
        will result in a StatusTestError exception being thrown. See checkStatus() for more information.

        The last two parameters, described below, in addition to the verbosity level of the OutputManager, control when printing is
        called. When both the ``mod`` criterion and the ``printStates`` criterion are satisfied, the status test will be printed to the
        OutputManager with ::MsgType of ::StatusTestDetails.

        :type mod: int, optional
        :param mod: (in) A positive number describes how often the output should be printed. On every call to checkStatus(), an internal counter
                           is incremented. Printing may only occur when this counter is congruent to zero modulo ``mod``. Default: 1 (attempt to print on every call to checkStatus())
        :type printStates: int, optional
        :param printStates: (in) A combination of ::TestStatus values for which the output may be printed. Default: ::Passed (attempt to print whenever checkStatus() will return ::Passed)
        """
        _Anasazi.StatusTestOutputEpetra_swiginit(self, _Anasazi.new_StatusTestOutputEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_StatusTestOutputEpetra

    def checkStatus(self, *args):
        r"""
        Check and return status of underlying StatusTest.

           This method calls checkStatus() on the StatusTest object passed in the constructor. If appropriate, the
           method will follow this call with a call to print() on the underlying object, using the OutputManager passed via the constructor
           with verbosity level ::StatusTestDetails.

           The internal counter will be incremented during this call, but only after
           performing the tests to decide whether or not to print the underlying
           StatusTest. This way, the very first call to checkStatus() following
           initialization or reset() will enable the underlying StatusTest to be
           printed, regardless of the mod parameter, as the current number of calls
           will be zero.

           If the specified Teuchos::RCP for the child class is Teuchos::null, then calling checkStatus() will result in a StatusTestError exception being thrown.

           :rtype: int
           :return: ::TestStatus indicating whether the underlying test passed or failed.
        """
        return _Anasazi.StatusTestOutputEpetra_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call, or undefined if it has not been run."""
        return _Anasazi.StatusTestOutputEpetra_getStatus(self, *args)

    def whichVecs(self, *args):
        r""" Get the indices for the vectors that passed the test."""
        return _Anasazi.StatusTestOutputEpetra_whichVecs(self, *args)

    def howMany(self, *args):
        r""" Get the number of vectors that passed the test."""
        return _Anasazi.StatusTestOutputEpetra_howMany(self, *args)

    def setChild(self, *args):
        r"""
        Set child test.

        Notes: This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestOutputEpetra_setChild(self, *args)

    def getChild(self, *args):
        r""" Get child test."""
        return _Anasazi.StatusTestOutputEpetra_getChild(self, *args)

    def reset(self, *args):
        r"""
        Informs the status test that it should reset its internal configuration to the uninitialized state.

        This resets the cached state to an ::Undefined state and calls reset() on the underlying test. It also
        resets the counter for the number of calls to checkStatus().
        """
        return _Anasazi.StatusTestOutputEpetra_reset(self, *args)

    def clearStatus(self, *args):
        r""" Clears the results of the last status test. This resets the cached state to an ::Undefined state and calls clearStatus() on the underlying test."""
        return _Anasazi.StatusTestOutputEpetra_clearStatus(self, *args)

# Register StatusTestOutputEpetra in _Anasazi:
_Anasazi.StatusTestOutputEpetra_swigregister(StatusTestOutputEpetra)
class StatusTestResNormEpetra(StatusTestEpetra):
    r"""
    A status test for testing the norm of the eigenvectors residuals.

    StatusTestResNorm was designed to be used as a test for
    convergence. The tester compares the norms of the residual vectors against
    a user specified tolerance.

    In addition to specifying the tolerance, the user may specify:

    *  the norm to be used: 2-norm or OrthoManager::norm() or Eigensolver::getRitzRes2Norms()
    *  the scale: absolute or relative to magnitude of Ritz value
    *  the quorum: the number of vectors required for the test to
    evaluate as ::Passed.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _Anasazi.StatusTestResNormEpetra_swiginit(self, _Anasazi.new_StatusTestResNormEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_StatusTestResNormEpetra

    def checkStatus(self, *args):
        r"""
        Check status as defined by test.

             :rtype: int
             :return: TestStatus indicating whether the test passed or failed.
        """
        return _Anasazi.StatusTestResNormEpetra_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call, or undefined if it has not been run."""
        return _Anasazi.StatusTestResNormEpetra_getStatus(self, *args)

    def whichVecs(self, *args):
        r""" Get the indices for the vectors that passed the test."""
        return _Anasazi.StatusTestResNormEpetra_whichVecs(self, *args)

    def howMany(self, *args):
        r""" Get the number of vectors that passed the test."""
        return _Anasazi.StatusTestResNormEpetra_howMany(self, *args)

    def setQuorum(self, *args):
        r"""
        Set quorum.

        Setting quorum to -1 signifies that all residuals from the solver must meet the tolerance.
        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestResNormEpetra_setQuorum(self, *args)

    def getQuorum(self, *args):
        r""" Get quorum."""
        return _Anasazi.StatusTestResNormEpetra_getQuorum(self, *args)

    def setTolerance(self, *args):
        r"""
        Set tolerance.
        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestResNormEpetra_setTolerance(self, *args)

    def getTolerance(self, *args):
        r""" Get tolerance."""
        return _Anasazi.StatusTestResNormEpetra_getTolerance(self, *args)

    def setWhichNorm(self, *args):
        r"""
        Set the residual norm to be used by the status test.

        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestResNormEpetra_setWhichNorm(self, *args)

    def getWhichNorm(self, *args):
        r""" Return the residual norm used by the status test."""
        return _Anasazi.StatusTestResNormEpetra_getWhichNorm(self, *args)

    def setScale(self, *args):
        r"""
        Instruct test to scale norms by eigenvalue estimates (relative scale).
        This also resets the test status to ::Undefined.
        """
        return _Anasazi.StatusTestResNormEpetra_setScale(self, *args)

    def getScale(self, *args):
        r""" Returns true if the test scales the norms by the eigenvalue estimates (relative scale)."""
        return _Anasazi.StatusTestResNormEpetra_getScale(self, *args)

    def reset(self, *args):
        r"""
        Informs the status test that it should reset its internal configuration to the uninitialized state. This is necessary for the case when the status test is being reused by another solver or for another
             eigenvalue problem. The status test may have information that pertains to a particular problem or solver
             state. The internal information will be reset back to the uninitialized state. The user specified information
             that the convergence test uses will remain.
        """
        return _Anasazi.StatusTestResNormEpetra_reset(self, *args)

    def clearStatus(self, *args):
        r"""
         Clears the results of the last status test. This should be distinguished from the reset() method, as it only clears the cached result from the last
        status test, so that a call to getStatus() will return ::Undefined. This is necessary for the SEQOR and SEQAND
        tests in the StatusTestCombo class, which may short circuit and not evaluate all of the StatusTests contained
        in them.
        """
        return _Anasazi.StatusTestResNormEpetra_clearStatus(self, *args)

# Register StatusTestResNormEpetra in _Anasazi:
_Anasazi.StatusTestResNormEpetra_swigregister(StatusTestResNormEpetra)
class OrthoManagerEpetra(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_OrthoManagerEpetra

    def innerProd(self, *args):
        r"""
        Provides the inner product defining the orthogonality concepts.

           All concepts of orthogonality discussed in this class are defined with respect to this inner product.

           Notes: This is potentially different from MultiVecTraits::MvTransMv(). For example, it is customary in many
           eigensolvers to exploit a mass matrix ``M`` for the inner product: :math:`x^HMx`.

           :type Z: Teuchos::SerialDenseMatrix< int,double >
           :param Z: [out] Z(i,j) contains the inner product of X[i] and Y[i]:

               .. math::

                   Z(i,j) = \langle X[i], Y[i] \rangle
        """
        return _Anasazi.OrthoManagerEpetra_innerProd(self, *args)

    def norm(self, *args):
        r"""
         Provides the norm induced by innerProd().

        This computes the norm for each column of a multivector. This is the norm induced by innerProd():

        .. math::

            \|x\| = \sqrt{\langle x, x \rangle}

             :type normvec: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
             :param normvec: [out] Vector of norms, whose ``i-th`` entry corresponds to the ``i-th`` column of ``X``


        """
        return _Anasazi.OrthoManagerEpetra_norm(self, *args)

    def normalize(self, *args):
        r"""
         This method takes a multivector ``X`` and attempts to compute a basis
        for :math:`colspan(X)`. This basis is orthonormal with respect to innerProd().

        This routine returns an integer ``rank`` stating the rank of the computed
        basis. If ``X`` does not have full rank and the normalize() routine does
        not attempt to augment the subspace, then ``rank`` may be smaller than
        the number of columns in ``X``. In this case, only the first ``rank``
        columns of output ``X`` and first ``rank`` rows of ``B`` will be valid.

             :type X: :py:class:`Epetra_MultiVector`
             :param X: [in/out] The multivector to be modified.

                   On output, the first ``rank`` columns of ``X`` satisfy

                   .. math::

                       \langle X[i], X[j] \rangle = \delta_{ij}\ .
               Also,

               .. math::

                   X_{in}(1:m,1:n) = X_{out}(1:m,1:rank) B(1:rank,1:n)\ ,
               where ``m`` is the number of rows in ``X`` and ``n`` is the number of
               columns in ``X``.

             :type B: Teuchos::SerialDenseMatrix< int,double >, optional
             :param B: [out] The coefficients of the original ``X`` with respect to the
                   computed basis. If ``B`` is a non-null pointer and ``B`` matches the
                   dimensions of ``B``, then the coefficients computed during the
                   orthogonalization routine will be stored in ``B``, similar to calling

                   .. code-block:: c++

                      innerProd( X_{out}, X_{in}, B );
               If ``B`` points to a Teuchos::SerialDenseMatrix with
               size inconsistent with ``X``, then a std::invalid_argument exception will
               be thrown.

               Otherwise, if ``B`` is null, the caller will not have access
               to the computed coefficients.

               Notes: This matrix is not necessarily triangular (as in a QR factorization);
               see the documentation of specific orthogonalization managers.

             :rtype: int
             :return: Rank of the basis computed by this method, less than or equal to
                   the number of columns in ``X``. This specifies how many columns in the
                   returned ``X`` and rows in the returned ``B`` are valid.
        """
        return _Anasazi.OrthoManagerEpetra_normalize(self, *args)

    def orthonormError(self, *args):
        r"""
         This method computes the error in orthonormality of a multivector.

        This method return some measure of :math:`\| \langle X, X \rangle - I \|`. 

        See the documentation of specific orthogonalization managers.
        """
        return _Anasazi.OrthoManagerEpetra_orthonormError(self, *args)

    def orthogError(self, *args):
        r"""
         This method computes the error in orthogonality of two multivectors.

        This method return some measure of :math:`\| \langle X1, X2 \rangle \|`. 

        See the documentation of specific orthogonalization managers.
        """
        return _Anasazi.OrthoManagerEpetra_orthogError(self, *args)

# Register OrthoManagerEpetra in _Anasazi:
_Anasazi.OrthoManagerEpetra_swigregister(OrthoManagerEpetra)
class MatOrthoManagerEpetra(OrthoManagerEpetra):
    r"""
    Anasazi's templated virtual class for providing routines for
    orthogonalization and orthonormalization of multivectors using matrix-based
    inner products.

    This class extends Anasazi::OrthoManager by providing extra calling arguments
    to orthogonalization routines, to reduce the cost of applying the inner
    product in cases where the user already has the image of target multivectors
    under the inner product matrix.

    A concrete implementation of this class is necessary. The user can create
    their own implementation if those supplied are not suitable for their needs.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_MatOrthoManagerEpetra

    def setOp(self, *args):
        r""" Set operator used for inner product."""
        return _Anasazi.MatOrthoManagerEpetra_setOp(self, *args)

    def getOp(self, *args):
        r""" Get operator used for inner product."""
        return _Anasazi.MatOrthoManagerEpetra_getOp(self, *args)

    def getOpCounter(self, *args):
        r"""
         Retrieve operator counter. This counter returns the number of applications of the operator specifying the inner
        product. When the operator is applied to a multivector, the counter is incremented by the
        number of vectors in the multivector. If the operator is not specified, the counter is never
        incremented.
        """
        return _Anasazi.MatOrthoManagerEpetra_getOpCounter(self, *args)

    def resetOpCounter(self, *args):
        r""" Reset the operator counter to zero. See getOpCounter() for more details."""
        return _Anasazi.MatOrthoManagerEpetra_resetOpCounter(self, *args)

    def innerProdMat(self, *args):
        r"""
         Provides a matrix-based inner product.

        Provides the inner product

        .. math::

            \langle x, y \rangle = x^H M y
        Optionally allows the provision of :math:`M y` and/or :math:`M x`. See OrthoManager::innerProd() for more details.
        """
        return _Anasazi.MatOrthoManagerEpetra_innerProdMat(self, *args)

    def normMat(self, *args):
        r"""
        Provides the norm induced by the matrix-based inner product.

        Provides the norm:

        .. math::

            \|x\|_M = \sqrt{x^H M y}
        Optionally allows the provision of :math:`M x`. See OrthoManager::norm() for more details.
        """
        return _Anasazi.MatOrthoManagerEpetra_normMat(self, *args)

    def normalizeMat(self, *args):
        r"""
         Provides matrix-based orthonormalization method.

        This method optionally allows the provision of :math:`M X`. See orthoManager::normalize() for more details.
             :type X: :py:class:`Epetra_MultiVector`
             :param X:, B [in/out] As in OrthoManager::normalize()

             :type MX: Teuchos::RCP< Epetra_MultiVector >, optional
             :param MX: [in/out] If specified by the user, on input ``MX`` is required to be the image of ``X`` under the operator getOp().
                 On output, ``MX`` will be updated to reflect the changes in ``X``.

             :rtype: int
             :return: Rank of the basis computed by this method, less than or equal to
                   the number of columns in ``X``. This specifies how many columns in the
                   returned ``X`` and ``MX`` and rows in the returned ``B`` are valid.
        """
        return _Anasazi.MatOrthoManagerEpetra_normalizeMat(self, *args)

    def orthonormErrorMat(self, *args):
        r"""
        This method computes the error in orthonormality of a multivector.

        This method optionally allows optionally exploits a caller-provided ``MX``.
        """
        return _Anasazi.MatOrthoManagerEpetra_orthonormErrorMat(self, *args)

    def orthogErrorMat(self, *args):
        r"""
        This method computes the error in orthogonality of two multivectors.

        This method optionally allows optionally exploits a caller-provided ``MX`` and/or ``MY``.
        """
        return _Anasazi.MatOrthoManagerEpetra_orthogErrorMat(self, *args)

    def innerProd(self, *args):
        r"""
         Implements the interface OrthoManager::innerProd().

        This method calls

        .. code-block:: c++

            innerProdMat(X,Y,Z);
        """
        return _Anasazi.MatOrthoManagerEpetra_innerProd(self, *args)

    def norm(self, *args):
        r"""
         Implements the interface OrthoManager::norm().

        This method calls

        .. code-block:: c++

            normMat(X,normvec);
        """
        return _Anasazi.MatOrthoManagerEpetra_norm(self, *args)

    def normalize(self, *args):
        r"""
         Implements the interface OrthoManager::normalize().

        This method calls

        .. code-block:: c++

            normalizeMat(X,B);
        """
        return _Anasazi.MatOrthoManagerEpetra_normalize(self, *args)

    def orthonormError(self, *args):
        r"""
         Implements the interface OrthoManager::orthonormError().

        This method calls

        .. code-block:: c++

            orthonormErrorMat(X);
        """
        return _Anasazi.MatOrthoManagerEpetra_orthonormError(self, *args)

    def orthogError(self, *args):
        r"""
         Implements the interface OrthoManager::orthogError().

        This method calls

        .. code-block:: c++

            orthogErrorMat(X1,X2);
        """
        return _Anasazi.MatOrthoManagerEpetra_orthogError(self, *args)

# Register MatOrthoManagerEpetra in _Anasazi:
_Anasazi.MatOrthoManagerEpetra_swigregister(MatOrthoManagerEpetra)
class BasicOrthoManagerEpetra(MatOrthoManagerEpetra):
    r"""
    An implementation of the Anasazi::MatOrthoManager that performs orthogonalization
    using (potentially) multiple steps of classical Gram-Schmidt.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor specifying re-orthogonalization tolerance."""
        _Anasazi.BasicOrthoManagerEpetra_swiginit(self, _Anasazi.new_BasicOrthoManagerEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BasicOrthoManagerEpetra

    def orthonormErrorMat(self, *args):
        r"""
         This method computes the error in orthonormality of a multivector, measured
        as the Frobenius norm of the difference innerProd(X,Y) - I.
         The method has the option of exploiting a caller-provided ``MX``.
        """
        return _Anasazi.BasicOrthoManagerEpetra_orthonormErrorMat(self, *args)

    def orthogErrorMat(self, *args):
        r"""
         This method computes the error in orthogonality of two multivectors, measured
        as the Frobenius norm of innerProd(X,Y).
         The method has the option of exploiting a caller-provided ``MX``.
        """
        return _Anasazi.BasicOrthoManagerEpetra_orthogErrorMat(self, *args)

    def setKappa(self, *args):
        r""" Set parameter for re-orthogonalization threshold."""
        return _Anasazi.BasicOrthoManagerEpetra_setKappa(self, *args)

    def getKappa(self, *args):
        r""" Return parameter for re-orthogonalization threshold."""
        return _Anasazi.BasicOrthoManagerEpetra_getKappa(self, *args)

# Register BasicOrthoManagerEpetra in _Anasazi:
_Anasazi.BasicOrthoManagerEpetra_swigregister(BasicOrthoManagerEpetra)
class SVQBOrthoManagerEpetra(MatOrthoManagerEpetra):
    r"""
    An implementation of the Anasazi::MatOrthoManager that performs orthogonalization
    using the SVQB iterative orthogonalization technique described by Stathapoulos and Wu. This orthogonalization routine,
    while not returning the upper triangular factors of the popular Gram-Schmidt method, has a communication
    cost (measured in number of communication calls) that is independent of the number of columns in the basis.

    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor specifying re-orthogonalization tolerance."""
        _Anasazi.SVQBOrthoManagerEpetra_swiginit(self, _Anasazi.new_SVQBOrthoManagerEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_SVQBOrthoManagerEpetra

    def orthonormErrorMat(self, *args):
        r"""
         This method computes the error in orthonormality of a multivector, measured
        as the Frobenius norm of the difference innerProd(X,Y) - I.
         The method has the option of exploiting a caller-provided ``MX``.
        """
        return _Anasazi.SVQBOrthoManagerEpetra_orthonormErrorMat(self, *args)

    def orthogErrorMat(self, *args):
        r"""
         This method computes the error in orthogonality of two multivectors, measured
        as the Frobenius norm of innerProd(X,Y).
         The method has the option of exploiting a caller-provided ``MX``.
        """
        return _Anasazi.SVQBOrthoManagerEpetra_orthogErrorMat(self, *args)

# Register SVQBOrthoManagerEpetra in _Anasazi:
_Anasazi.SVQBOrthoManagerEpetra_swigregister(SVQBOrthoManagerEpetra)
class EigensolverEpetra(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_EigensolverEpetra

    def iterate(self, *args):
        r"""
        This method performs eigensolvers iterations until the status test
           indicates the need to stop or an error occurs (in which case, an exception is thrown).
        """
        return _Anasazi.EigensolverEpetra_iterate(self, *args)

    def initialize(self, *args):
        r"""
        Initialize the solver with the initial vectors from the eigenproblem
        or random data.
        """
        return _Anasazi.EigensolverEpetra_initialize(self, *args)

    def getNumIters(self, *args):
        r""" Get the current iteration count."""
        return _Anasazi.EigensolverEpetra_getNumIters(self, *args)

    def resetNumIters(self, *args):
        r""" Reset the iteration count."""
        return _Anasazi.EigensolverEpetra_resetNumIters(self, *args)

    def getRitzVectors(self, *args):
        r"""
         Get the Ritz vectors from the previous iteration. These are indexed using getRitzIndex().

        For a description of the indexing scheme, see getRitzIndex().
        """
        return _Anasazi.EigensolverEpetra_getRitzVectors(self, *args)

    def getRitzValues(self, *args):
        r""" Get the Ritz values from the previous iteration."""
        return _Anasazi.EigensolverEpetra_getRitzValues(self, *args)

    def getRitzIndex(self, *args):
        r"""
        Get the index used for indexing the compressed storage used for Ritz vectors for real, non-Hermitian problems.

        index has length numVecs, where each entry is 0, +1, or -1. These have the following interpretation:
           - index[i] == 0: signifies that the corresponding eigenvector is stored as the i column of Evecs. This will usually be the
             case when ScalarType is complex, an eigenproblem is Hermitian, or a real, non-Hermitian eigenproblem has a real eigenvector.
           - index[i] == +1: signifies that the corresponding eigenvector is stored in two vectors: the real part in the i column of Evecs and the ***positive*** imaginary part in the i+1 column of Evecs.
           - index[i] == -1: signifies that the corresponding eigenvector is stored in two vectors: the real part in the i-1 column of Evecs and the ***negative*** imaginary part in the i column of Evecs
        """
        return _Anasazi.EigensolverEpetra_getRitzIndex(self, *args)

    def getResNorms(self, *args):
        r"""
         Get the current residual norms :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length blockSize containing the norms of the residuals,
                  according to the orthogonalization manager norm() method.
        """
        return _Anasazi.EigensolverEpetra_getResNorms(self, *args)

    def getRes2Norms(self, *args):
        r"""
         Get the current residual 2-norms :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length blockSize containing the 2-norms of the residuals.
        """
        return _Anasazi.EigensolverEpetra_getRes2Norms(self, *args)

    def getRitzRes2Norms(self, *args):
        r"""
         Get the 2-norms of the Ritz residuals. :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length blockSize containing the 2-norms of the Ritz residuals.
        """
        return _Anasazi.EigensolverEpetra_getRitzRes2Norms(self, *args)

    def getCurSubspaceDim(self, *args):
        r""" Get the dimension of the search subspace used to generate the current eigenvectors and eigenvalues."""
        return _Anasazi.EigensolverEpetra_getCurSubspaceDim(self, *args)

    def getMaxSubspaceDim(self, *args):
        r""" Get the maximum dimension allocated for the search subspace."""
        return _Anasazi.EigensolverEpetra_getMaxSubspaceDim(self, *args)

    def setStatusTest(self, *args):
        r""" Set a new StatusTest for the solver."""
        return _Anasazi.EigensolverEpetra_setStatusTest(self, *args)

    def getStatusTest(self, *args):
        r""" Get the current StatusTest used by the solver."""
        return _Anasazi.EigensolverEpetra_getStatusTest(self, *args)

    def getProblem(self, *args):
        r""" Get a constant reference to the eigenvalue problem."""
        return _Anasazi.EigensolverEpetra_getProblem(self, *args)

    def getBlockSize(self, *args):
        r""" Get the blocksize to be used by the iterative solver in solving this eigenproblem."""
        return _Anasazi.EigensolverEpetra_getBlockSize(self, *args)

    def setBlockSize(self, *args):
        r""" Set the blocksize to be used by the iterative solver in solving this eigenproblem."""
        return _Anasazi.EigensolverEpetra_setBlockSize(self, *args)

    def setAuxVecs(self, *args):
        r""" Set the auxiliary vectors for the solver."""
        return _Anasazi.EigensolverEpetra_setAuxVecs(self, *args)

    def getAuxVecs(self, *args):
        r""" Get the auxiliary vectors for the solver."""
        return _Anasazi.EigensolverEpetra_getAuxVecs(self, *args)

    def isInitialized(self, *args):
        r""" States whether the solver has been initialized or not."""
        return _Anasazi.EigensolverEpetra_isInitialized(self, *args)

    def currentStatus(self, *args):
        r""" This method requests that the solver print out its current status to screen."""
        return _Anasazi.EigensolverEpetra_currentStatus(self, *args)

# Register EigensolverEpetra in _Anasazi:
_Anasazi.EigensolverEpetra_swigregister(EigensolverEpetra)
class SolverManagerEpetra(object):
    r"""
     The Anasazi::SolverManager is a templated virtual base class that defines the
    basic interface that any solver manager will support.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Anasazi.delete_SolverManagerEpetra

    def getProblem(self, *args):
        r""" Return the eigenvalue problem."""
        return _Anasazi.SolverManagerEpetra_getProblem(self, *args)

    def getNumIters(self, *args):
        r""" Get the iteration count for the most recent call to ``solve()``."""
        return _Anasazi.SolverManagerEpetra_getNumIters(self, *args)

    def getTimers(self, *args):
        r""" Return the timers for this object."""
        return _Anasazi.SolverManagerEpetra_getTimers(self, *args)

    def solve(self, *args):
        r"""
         This method performs possibly repeated calls to the underlying eigensolver's iterate() routine
        until the problem has been solved (as decided by the solver manager) or the solver manager decides to
        quit.

        :rtype: int
        :return: ::ReturnType specifying:
               - ::Converged: the eigenproblem was solved to the specification required by the solver manager.
               - ::Unconverged: the eigenproblem was not solved to the specification desired by the solver manager
        """
        return _Anasazi.SolverManagerEpetra_solve(self, *args)

# Register SolverManagerEpetra in _Anasazi:
_Anasazi.SolverManagerEpetra_swigregister(SolverManagerEpetra)
class BlockDavidsonEpetra(EigensolverEpetra):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         %BlockDavidson constructor with eigenproblem, solver utilities, and parameter list of solver options.

        This constructor takes pointers required by the eigensolver, in addition
        to a parameter list of options for the eigensolver. These options include the following:
          - "Block Size" - an ``int`` specifying the block size used by the algorithm. This can also be specified using the setBlockSize() method.
          - "Num Blocks" - an ``int`` specifying the maximum number of blocks allocated for the solver basis.
        """
        _Anasazi.BlockDavidsonEpetra_swiginit(self, _Anasazi.new_BlockDavidsonEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BlockDavidsonEpetra

    def iterate(self, *args):
        r"""
         This method performs %BlockDavidson iterations until the status
        test indicates the need to stop or an error occurs (in which case, an
        appropriate exception is thrown).

        iterate() will first determine whether the solver is uninitialized; if
        not, it will call initialize(). After
        initialization, the solver performs block Davidson iterations until the
        status test evaluates as ::Passed, at which point the method returns to
        the caller.

        The block Davidson iteration proceeds as follows:
        -# The current residual (R) is preconditioned to form H
        -# H is orthogonalized against the auxiliary vectors and the previous basis vectors, and made orthonormal.
        -# The current basis is expanded with H and used to project the problem matrix.
        -# The projected eigenproblem is solved, and the desired eigenvectors and eigenvalues are selected.
        -# These are used to form the new eigenvector estimates (X).
        -# The new residual (R) is formed.

        The status test is queried at the beginning of the iteration.

        Possible exceptions thrown include std::invalid_argument or
        one of the BlockDavidson-specific exceptions.
        """
        return _Anasazi.BlockDavidsonEpetra_iterate(self, *args)

    def initialize(self, *args):
        r"""
        *Overload 1:*
         Initialize the solver to an iterate, optionally providing the
        current basis and projected problem matrix, the current Ritz vectors and values,
        and the current residual.

        The %BlockDavidson eigensolver contains a certain amount of state,
        including the current Krylov basis, the current eigenvectors,
        the current residual, etc. (see getState())

        initialize() gives the user the opportunity to manually set these,
        although this must be done with caution, as the validity of the
        user input will not be checked.

        Only the first newstate.curDim columns of newstate.V
        and newstate.KK and the first newstate.curDim rows of
        newstate.KK will be used.

        If newstate.V == getState().V, then the data is not copied. The
        same holds for newstate.KK, newstate.X,
        newstate.KX, newstate.MX, and newstate.R Only the
        upper triangular half of newstate.KK is used to initialize the
        state of the solver.

        The user has the option of specifying any component of the state using
        initialize(). However, these arguments are assumed to match the
        post-conditions specified under isInitialized(). Any component of the
        state (i.e., KX) not given to initialize() will be generated.

        Note, for any pointer in ``newstate`` which directly points to the multivectors in
        the solver, the data is not copied.

        |

        *Overload 2:*
         Initialize the solver with the initial vectors from the eigenproblem
         or random data.
        """
        return _Anasazi.BlockDavidsonEpetra_initialize(self, *args)

    def isInitialized(self, *args):
        r"""
         Indicates whether the solver has been initialized or not.

        :rtype: boolean
        :return: bool indicating the state of the solver.
        """
        return _Anasazi.BlockDavidsonEpetra_isInitialized(self, *args)

    def getState(self, *args):
        r"""
         Get access to the current state of the eigensolver.

        The data is only valid if isInitialized() == ``true``.

        The data for the preconditioned residual is only meaningful in the
        scenario that the solver throws a ::BlockDavidsonRitzFailure exception
        during iterate().

        :rtype: Anasazi::BlockDavidsonState< double,Epetra_MultiVector >
        :return: A BlockDavidsonState object containing const pointers to the current
            solver state. Note, these are direct pointers to the multivectors; they are not
            pointers to views of the multivectors.
        """
        return _Anasazi.BlockDavidsonEpetra_getState(self, *args)

    def getNumIters(self, *args):
        r""" Get the current iteration count."""
        return _Anasazi.BlockDavidsonEpetra_getNumIters(self, *args)

    def resetNumIters(self, *args):
        r""" Reset the iteration count."""
        return _Anasazi.BlockDavidsonEpetra_resetNumIters(self, *args)

    def getRitzVectors(self, *args):
        r"""
        Get access to the current Ritz vectors.

               :rtype: Teuchos::RCP< Epetra_MultiVector const >
               :return: A multivector with getBlockSize() vectors containing
                   the sorted Ritz vectors corresponding to the most significant Ritz values.
                   The i-th vector of the return corresponds to the i-th Ritz vector; there is no need to use
                   getRitzIndex().
        """
        return _Anasazi.BlockDavidsonEpetra_getRitzVectors(self, *args)

    def getRitzValues(self, *args):
        r"""
        Get the Ritz values for the previous iteration.

        :rtype: std::vector< Anasazi::Value< double >,std::allocator< Anasazi::Value< double > > >
        :return: A vector of length getCurSubspaceDim() containing the Ritz values from the
            previous projected eigensolve.
        """
        return _Anasazi.BlockDavidsonEpetra_getRitzValues(self, *args)

    def getRitzIndex(self, *args):
        r"""
         Get the index used for extracting individual Ritz vectors from getRitzVectors().

        Because BlockDavidson is a Hermitian solver, all Ritz values are real and all Ritz vectors can be represented in a
        single column of a multivector. Therefore, getRitzIndex() is not needed when using the output from getRitzVectors().

        :rtype: std::vector< int,std::allocator< int > >
        :return: An ``int`` vector of size getCurSubspaceDim() composed of zeros.
        """
        return _Anasazi.BlockDavidsonEpetra_getRitzIndex(self, *args)

    def getResNorms(self, *args):
        r"""
        Get the current residual norms, computing the norms if they are not up-to-date with the current residual vectors.

        :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length getCurSubspaceDim() containing the norms of the
            residuals, with respect to the orthogonalization manager's norm() method.
        """
        return _Anasazi.BlockDavidsonEpetra_getResNorms(self, *args)

    def getRes2Norms(self, *args):
        r"""
        Get the current residual 2-norms, computing the norms if they are not up-to-date with the current residual vectors.

        :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length getCurSubspaceDim() containing the 2-norms of the
            current residuals.
        """
        return _Anasazi.BlockDavidsonEpetra_getRes2Norms(self, *args)

    def getRitzRes2Norms(self, *args):
        r"""
         Get the 2-norms of the residuals.

        The Ritz residuals are not defined for the %LOBPCG iteration. Hence, this method returns the
        2-norms of the direct residuals, and is equivalent to calling getRes2Norms().

         :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
         :return: A vector of length getBlockSize() containing the 2-norms of the direct residuals.
        """
        return _Anasazi.BlockDavidsonEpetra_getRitzRes2Norms(self, *args)

    def getCurSubspaceDim(self, *args):
        r"""
        Get the dimension of the search subspace used to generate the current eigenvectors and eigenvalues.

        :rtype: int
        :return: An integer specifying the rank of the Krylov subspace currently in use by the eigensolver. If isInitialized() == ``false``,
            the return is 0. Otherwise, it will be some strictly positive multiple of getBlockSize().
        """
        return _Anasazi.BlockDavidsonEpetra_getCurSubspaceDim(self, *args)

    def getMaxSubspaceDim(self, *args):
        r""" Get the maximum dimension allocated for the search subspace. For %BlockDavidson, this always returns numBlocks*blockSize."""
        return _Anasazi.BlockDavidsonEpetra_getMaxSubspaceDim(self, *args)

    def setStatusTest(self, *args):
        r""" Set a new StatusTest for the solver."""
        return _Anasazi.BlockDavidsonEpetra_setStatusTest(self, *args)

    def getStatusTest(self, *args):
        r""" Get the current StatusTest used by the solver."""
        return _Anasazi.BlockDavidsonEpetra_getStatusTest(self, *args)

    def getProblem(self, *args):
        r""" Get a constant reference to the eigenvalue problem."""
        return _Anasazi.BlockDavidsonEpetra_getProblem(self, *args)

    def setBlockSize(self, *args):
        r"""
         Set the blocksize.

        This method is required to support the interface provided by Eigensolver. However, the preferred method
        of setting the allocated size for the BlockDavidson eigensolver is setSize(). In fact, setBlockSize()
        simply calls setSize(), maintaining the current number of blocks.

        The block size determines the number of Ritz vectors and values that are computed on each iteration, thereby
        determining the increase in the Krylov subspace at each iteration.
        """
        return _Anasazi.BlockDavidsonEpetra_setBlockSize(self, *args)

    def getBlockSize(self, *args):
        r""" Get the blocksize used by the iterative solver."""
        return _Anasazi.BlockDavidsonEpetra_getBlockSize(self, *args)

    def setAuxVecs(self, *args):
        r"""
        Set the auxiliary vectors for the solver.

        Because the current basis V cannot be assumed
        orthogonal to the new auxiliary vectors, a call to setAuxVecs() will
        reset the solver to the uninitialized state. This happens only in the
        case where the new auxiliary vectors have a combined dimension of
        greater than zero.

        In order to preserve the current state, the user will need to extract
        it from the solver using getState(), orthogonalize it against the
        new auxiliary vectors, and reinitialize using initialize().
        """
        return _Anasazi.BlockDavidsonEpetra_setAuxVecs(self, *args)

    def getAuxVecs(self, *args):
        r""" Get the auxiliary vectors for the solver."""
        return _Anasazi.BlockDavidsonEpetra_getAuxVecs(self, *args)

    def setSize(self, *args):
        r"""
         Set the blocksize and number of blocks to be used by the
        iterative solver in solving this eigenproblem.

         Changing either the block size or the number of blocks will reset the
         solver to an uninitialized state.

         The requested block size must be strictly positive; the number of blocks must be
         greater than one. Invalid arguments will result in a std::invalid_argument exception.
        """
        return _Anasazi.BlockDavidsonEpetra_setSize(self, *args)

    def currentStatus(self, *args):
        r""" This method requests that the solver print out its current status to the given output stream."""
        return _Anasazi.BlockDavidsonEpetra_currentStatus(self, *args)

# Register BlockDavidsonEpetra in _Anasazi:
_Anasazi.BlockDavidsonEpetra_swigregister(BlockDavidsonEpetra)
class BlockDavidsonSolMgrEpetra(SolverManagerEpetra):
    r"""
     The BlockDavidsonSolMgr provides a powerful solver manager over the BlockDavidson eigensolver.

    This solver manager implements a hard-locking mechanism, whereby eigenpairs designated to be locked are moved from the eigensolver and placed in
    auxilliary storage. The eigensolver is then restarted and continues to iterate, orthogonal to the locked eigenvectors.

    The solver manager provides to the solver a StatusTestCombo object constructed as follows:

          combo = globaltest OR lockingtest OR debugtest

    where
       - ``globaltest`` terminates computation when global convergence has been detected.

         It is encapsulated in a StatusTestWithOrdering object, to ensure that computation is terminated
         only after the most significant eigenvalues/eigenvectors have met the convergence criteria.

         If not specified via setGlobalStatusTest(), ``globaltest`` is a StatusTestResNorm object which tests the
         M-norms of the direct residuals relative to the Ritz values.
       - ``lockingtest`` halts BlockDavidson::iterate() in order to deflate converged eigenpairs for locking.

         It will query the underlying BlockDavidson eigensolver to determine when eigenvectors should be locked.

         If not specified via setLockingStatusTest(), ``lockingtest`` is a StatusTestResNorm object.
       - ``debugtest`` allows a user to specify additional monitoring of the iteration, encapsulated in a StatusTest object

         If not specified via setDebugStatusTest(), ``debugtest`` is ignored.

         In most cases, it should return ::Failed; if it returns ::Passed, solve() will throw an AnasaziError exception.

    Additionally, the solver manager will terminate solve() after a specified number of restarts.

    Much of this behavior is controlled via parameters and options passed to the
    solver manager. For more information, see BlockDavidsonSolMgr().



     Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Basic constructor for BlockDavidsonSolMgr.

        This constructor accepts the Eigenproblem to be solved in addition
        to a parameter list of options for the solver manager. These options include the following:
          - Solver parameters
             - ``"Which"`` - a ``string`` specifying the desired eigenvalues: SM, LM, SR or LR. Default: "SR"
             - ``"Block Size"`` - an ``int`` specifying the block size to be used by the underlying block Davidson solver. Default: problem->getNEV()
             - ``"Num Blocks"`` - an ``int`` specifying the number of blocks allocated for the Krylov basis. Default: 2
             - ``"Maximum Restarts"`` - an ``int`` specifying the maximum number of restarts the underlying solver is allowed to perform. Default: 20
             - ``"Verbosity"`` - a sum of MsgType specifying the verbosity. Default: ::Errors
             - ``"Output Stream"`` - a reference-counted pointer to the formatted output stream where all
                                    solver output is sent.  Default: Teuchos::getFancyOStream ( Teuchos::rcpFromRef (std::cout) )
             - ``"Output Processor"`` - an ``int`` specifying the MPI processor that will print solver/timer details.  Default: 0
          - Convergence parameters (if using default convergence test; see setGlobalStatusTest())
             - ``"Convergence Tolerance"`` - a ``MagnitudeType`` specifying the level that residual norms must reach to decide convergence. Default: machine precision.
             - ``"Relative Convergence Tolerance"`` - a ``bool`` specifying whether residuals norms should be scaled by their eigenvalues for the purposing of deciding convergence. Default: true
             - ``"Convergence Norm"`` - a ``string`` specifying the norm for convergence testing: "2" or "M"
          - Locking parameters (if using default locking test; see setLockingStatusTest())
             - ``"Use Locking"`` - a ``bool`` specifying whether the algorithm should employ locking of converged eigenpairs. Default: false
             - ``"Max Locked"`` - an ``int`` specifying the maximum number of eigenpairs to be locked. Default: problem->getNEV()
             - ``"Locking Quorum"`` - an ``int`` specifying the number of eigenpairs that must meet the locking criteria before locking actually occurs. Default: 1
             - ``"Locking Tolerance"`` - a ``MagnitudeType`` specifying the level that residual norms must reach to decide locking. Default: 0.1*convergence tolerance
             - ``"Relative Locking Tolerance"`` - a ``bool`` specifying whether residuals norms should be scaled by their eigenvalues for the purposing of deciding locking. Default: true
             - ``"Locking Norm"`` - a ``string`` specifying the norm for locking testing: "2" or "M"
        """
        _Anasazi.BlockDavidsonSolMgrEpetra_swiginit(self, _Anasazi.new_BlockDavidsonSolMgrEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BlockDavidsonSolMgrEpetra

    def getProblem(self, *args):
        r""" Return the eigenvalue problem."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_getProblem(self, *args)

    def getNumIters(self, *args):
        r""" Get the iteration count for the most recent call to ``solve()``."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_getNumIters(self, *args)

    def getTimers(self, *args):
        r"""
         Return the timers for this object.

        The timers are ordered as follows:
          - time spent in solve() routine
          - time spent restarting
          - time spent locking converged eigenvectors
        """
        return _Anasazi.BlockDavidsonSolMgrEpetra_getTimers(self, *args)

    def solve(self, *args):
        r"""
         This method performs possibly repeated calls to the underlying eigensolver's iterate() routine
        until the problem has been solved (as decided by the solver manager) or the solver manager decides to
        quit.

        This method calls BlockDavidson::iterate(), which will return either because a specially constructed status test evaluates to ::Passed
        or an exception is thrown.

        A return from BlockDavidson::iterate() signifies one of the following scenarios:
           - the maximum number of restarts has been exceeded. In this scenario, the solver manager will place

             all converged eigenpairs into the eigenproblem and return ::Unconverged.
           - the locking conditions have been met. In this scenario, some of the current eigenpairs will be removed

             from the eigensolver and placed into auxiliary storage. The eigensolver will be restarted with the remaining part of the Krylov subspace

             and some random information to replace the removed subspace.
           - global convergence has been met. In this case, the most significant NEV eigenpairs in the solver and locked storage

             have met the convergence criterion. (Here, NEV refers to the number of eigenpairs requested by the Eigenproblem.)

             In this scenario, the solver manager will return ::Converged.

        :rtype: int
        :return: ::ReturnType specifying:
                - ::Converged: the eigenproblem was solved to the specification required by the solver manager.
                - ::Unconverged: the eigenproblem was not solved to the specification desired by the solver manager.
        """
        return _Anasazi.BlockDavidsonSolMgrEpetra_solve(self, *args)

    def setGlobalStatusTest(self, *args):
        r""" Set the status test defining global convergence."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_setGlobalStatusTest(self, *args)

    def getGlobalStatusTest(self, *args):
        r""" Get the status test defining global convergence."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_getGlobalStatusTest(self, *args)

    def setLockingStatusTest(self, *args):
        r""" Set the status test defining locking."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_setLockingStatusTest(self, *args)

    def getLockingStatusTest(self, *args):
        r""" Get the status test defining locking."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_getLockingStatusTest(self, *args)

    def setDebugStatusTest(self, *args):
        r""" Set the status test for debugging."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_setDebugStatusTest(self, *args)

    def getDebugStatusTest(self, *args):
        r""" Get the status test for debugging."""
        return _Anasazi.BlockDavidsonSolMgrEpetra_getDebugStatusTest(self, *args)

# Register BlockDavidsonSolMgrEpetra in _Anasazi:
_Anasazi.BlockDavidsonSolMgrEpetra_swigregister(BlockDavidsonSolMgrEpetra)
class BlockKrylovSchurEpetra(EigensolverEpetra):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         %BlockKrylovSchur constructor with eigenproblem, solver utilities, and parameter list of solver options.

        This constructor takes pointers required by the eigensolver, in addition
        to a parameter list of options for the eigensolver. These options include the following:
          - "Block Size" - an ``int`` specifying the block size used by the algorithm. This can also be specified using the setBlockSize() method. Default: 1
          - "Num Blocks" - an ``int`` specifying the maximum number of blocks allocated for the solver basis. Default: 3*problem->getNEV()
          - "Step Size"  - an ``int`` specifying how many iterations are performed between computations of eigenvalues and eigenvectors.

            Note: This parameter is mandatory.
          - "Number of Ritz Vectors" - an ``int`` specifying how many Ritz vectors are computed on calls to getRitzVectors(). Default: 0
          - "Print Number of Ritz Values" - an ``int`` specifying how many Ritz values are printed on calls to currentStatus(). Default: "Block Size"
        """
        _Anasazi.BlockKrylovSchurEpetra_swiginit(self, _Anasazi.new_BlockKrylovSchurEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BlockKrylovSchurEpetra

    def iterate(self, *args):
        r"""
         This method performs Block Krylov-Schur iterations until the status
        test indicates the need to stop or an error occurs (in which case, an
        exception is thrown).

        iterate() will first determine whether the solver is inintialized; if
        not, it will call initialize() using default arguments. After
        initialization, the solver performs Block Krylov-Schur iterations until the
        status test evaluates as ::Passed, at which point the method returns to
        the caller.

        The Block Krylov-Schur iteration proceeds as follows:
        -# The operator problem->getOperator() is applied to the newest ``blockSize`` vectors in the Krylov basis.
        -# The resulting vectors are orthogonalized against the auxiliary vectors and the previous basis vectors, and made orthonormal.
        -# The Hessenberg matrix is updated.
        -# If we have performed ``stepSize`` iterations since the last update, update the Ritz values and Ritz residuals.

        The status test is queried at the beginning of the iteration.

        Possible exceptions thrown include the BlockKrylovSchurOrthoFailure.
        """
        return _Anasazi.BlockKrylovSchurEpetra_iterate(self, *args)

    def initialize(self, *args):
        r"""
        *Overload 1:*
         Initialize the solver to an iterate, providing a Krylov basis and Hessenberg matrix.

        The %BlockKrylovSchur eigensolver contains a certain amount of state,
        consisting of the current Krylov basis and the associated Hessenberg matrix.

        initialize() gives the user the opportunity to manually set these,
        although this must be done with caution, abiding by the rules given
        below. All notions of orthogonality and orthonormality are derived from
        the inner product specified by the orthogonalization manager.

        The user has the option of specifying any component of the state using
        initialize(). However, these arguments are assumed to match the
        post-conditions specified under isInitialized(). Any necessary component of the
        state not given to initialize() will be generated.

        Note, for any pointer in ``newstate`` which directly points to the multivectors in
        the solver, the data is not copied.

        |

        *Overload 2:*
         Initialize the solver with the initial vectors from the eigenproblem
         or random data.
        """
        return _Anasazi.BlockKrylovSchurEpetra_initialize(self, *args)

    def isInitialized(self, *args):
        r"""
         Indicates whether the solver has been initialized or not.

        :rtype: boolean
        :return: bool indicating the state of the solver.
        """
        return _Anasazi.BlockKrylovSchurEpetra_isInitialized(self, *args)

    def getState(self, *args):
        r"""
         Get the current state of the eigensolver.

        The data is only valid if isInitialized() == ``true``.

        :rtype: Anasazi::BlockKrylovSchurState< double,Epetra_MultiVector >
        :return: A BlockKrylovSchurState object containing const pointers to the current
            solver state.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getState(self, *args)

    def getNumIters(self, *args):
        r""" Get the current iteration count."""
        return _Anasazi.BlockKrylovSchurEpetra_getNumIters(self, *args)

    def resetNumIters(self, *args):
        r""" Reset the iteration count."""
        return _Anasazi.BlockKrylovSchurEpetra_resetNumIters(self, *args)

    def getRitzVectors(self, *args):
        r"""
        Get the Ritz vectors.

        :rtype: Teuchos::RCP< Epetra_MultiVector const >
        :return: A multivector of columns not exceeding the maximum dimension of the subspace
            containing the Ritz vectors from the most recent call to computeRitzVectors().

        Notes: To see if the returned Ritz vectors are current, call isRitzVecsCurrent().
        """
        return _Anasazi.BlockKrylovSchurEpetra_getRitzVectors(self, *args)

    def getRitzValues(self, *args):
        r"""
        Get the Ritz values.

        :rtype: std::vector< Anasazi::Value< double >,std::allocator< Anasazi::Value< double > > >
        :return: A vector of length not exceeding the maximum dimension of the subspace
            containing the Ritz values from the most recent Schur form update.

        Notes: To see if the returned Ritz values are current, call isRitzValsCurrent().
        """
        return _Anasazi.BlockKrylovSchurEpetra_getRitzValues(self, *args)

    def getRitzIndex(self, *args):
        r"""
        Get the Ritz index vector.

        :rtype: std::vector< int,std::allocator< int > >
        :return: A vector of length not exceeding the maximum dimension of the subspace
            containing the index vector for the Ritz values and Ritz vectors, if they are computed.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getRitzIndex(self, *args)

    def getResNorms(self, *args):
        r"""
        Get the current residual norms.

        Notes: Block Krylov-Schur cannot provide this so a zero length vector will be returned.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getResNorms(self, *args)

    def getRes2Norms(self, *args):
        r"""
        Get the current residual 2-norms

        Notes: Block Krylov-Schur cannot provide this so a zero length vector will be returned.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getRes2Norms(self, *args)

    def getRitzRes2Norms(self, *args):
        r"""
        Get the current Ritz residual 2-norms

        :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length blockSize containing the 2-norms of the Ritz residuals.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getRitzRes2Norms(self, *args)

    def setStatusTest(self, *args):
        r""" Set a new StatusTest for the solver."""
        return _Anasazi.BlockKrylovSchurEpetra_setStatusTest(self, *args)

    def getStatusTest(self, *args):
        r""" Get the current StatusTest used by the solver."""
        return _Anasazi.BlockKrylovSchurEpetra_getStatusTest(self, *args)

    def getProblem(self, *args):
        r""" Get a constant reference to the eigenvalue problem."""
        return _Anasazi.BlockKrylovSchurEpetra_getProblem(self, *args)

    def setSize(self, *args):
        r"""
         Set the blocksize and number of blocks to be used by the
        iterative solver in solving this eigenproblem.

         Changing either the block size or the number of blocks will reset the
         solver to an uninitialized state.
        """
        return _Anasazi.BlockKrylovSchurEpetra_setSize(self, *args)

    def setBlockSize(self, *args):
        r""" Set the blocksize."""
        return _Anasazi.BlockKrylovSchurEpetra_setBlockSize(self, *args)

    def setStepSize(self, *args):
        r""" Set the step size."""
        return _Anasazi.BlockKrylovSchurEpetra_setStepSize(self, *args)

    def setNumRitzVectors(self, *args):
        r""" Set the number of Ritz vectors to compute."""
        return _Anasazi.BlockKrylovSchurEpetra_setNumRitzVectors(self, *args)

    def getStepSize(self, *args):
        r""" Get the step size."""
        return _Anasazi.BlockKrylovSchurEpetra_getStepSize(self, *args)

    def getBlockSize(self, *args):
        r""" Get the blocksize to be used by the iterative solver in solving this eigenproblem."""
        return _Anasazi.BlockKrylovSchurEpetra_getBlockSize(self, *args)

    def getNumRitzVectors(self, *args):
        r""" Get the number of Ritz vectors to compute."""
        return _Anasazi.BlockKrylovSchurEpetra_getNumRitzVectors(self, *args)

    def getCurSubspaceDim(self, *args):
        r"""
        Get the dimension of the search subspace used to generate the current eigenvectors and eigenvalues.

        :rtype: int
        :return: An integer specifying the rank of the Krylov subspace currently in use by the eigensolver. If isInitialized() == ``false``,
            the return is 0.
        """
        return _Anasazi.BlockKrylovSchurEpetra_getCurSubspaceDim(self, *args)

    def getMaxSubspaceDim(self, *args):
        r""" Get the maximum dimension allocated for the search subspace."""
        return _Anasazi.BlockKrylovSchurEpetra_getMaxSubspaceDim(self, *args)

    def setAuxVecs(self, *args):
        r"""
        Set the auxiliary vectors for the solver.

        Because the current Krylov subspace cannot be assumed
        orthogonal to the new auxiliary vectors, a call to setAuxVecs() will
        reset the solver to the uninitialized state. This happens only in the
        case where the new auxiliary vectors have a combined dimension of
        greater than zero.

        In order to preserve the current state, the user will need to extract
        it from the solver using getState(), orthogonalize it against the
        new auxiliary vectors, and reinitialize using initialize().
        """
        return _Anasazi.BlockKrylovSchurEpetra_setAuxVecs(self, *args)

    def getAuxVecs(self, *args):
        r""" Get the auxiliary vectors for the solver."""
        return _Anasazi.BlockKrylovSchurEpetra_getAuxVecs(self, *args)

    def currentStatus(self, *args):
        r""" This method requests that the solver print out its current status to screen."""
        return _Anasazi.BlockKrylovSchurEpetra_currentStatus(self, *args)

    def isRitzVecsCurrent(self, *args):
        r""" Get the status of the Ritz vectors currently stored in the eigensolver."""
        return _Anasazi.BlockKrylovSchurEpetra_isRitzVecsCurrent(self, *args)

    def isRitzValsCurrent(self, *args):
        r""" Get the status of the Ritz values currently stored in the eigensolver."""
        return _Anasazi.BlockKrylovSchurEpetra_isRitzValsCurrent(self, *args)

    def isSchurCurrent(self, *args):
        r""" Get the status of the Schur form currently stored in the eigensolver."""
        return _Anasazi.BlockKrylovSchurEpetra_isSchurCurrent(self, *args)

    def computeRitzVectors(self, *args):
        r""" Compute the Ritz vectors using the current Krylov factorization."""
        return _Anasazi.BlockKrylovSchurEpetra_computeRitzVectors(self, *args)

    def computeRitzValues(self, *args):
        r""" Compute the Ritz values using the current Krylov factorization."""
        return _Anasazi.BlockKrylovSchurEpetra_computeRitzValues(self, *args)

    def computeSchurForm(self, *args):
        r""" Compute the Schur form of the projected eigenproblem from the current Krylov factorization."""
        return _Anasazi.BlockKrylovSchurEpetra_computeSchurForm(self, *args)

# Register BlockKrylovSchurEpetra in _Anasazi:
_Anasazi.BlockKrylovSchurEpetra_swigregister(BlockKrylovSchurEpetra)
class BlockKrylovSchurSolMgrEpetra(SolverManagerEpetra):
    r"""
     The Anasazi::BlockKrylovSchurSolMgr provides a flexible solver manager over the BlockKrylovSchur eigensolver.

    The solver manager provides to the solver a StatusTestCombo object constructed as follows:

          combo = globaltest OR debugtest

    where
       - ``globaltest`` terminates computation when global convergence has been detected.

         It is encapsulated in a StatusTestWithOrdering object, to ensure that computation is terminated
         only after the most significant eigenvalues/eigenvectors have met the convergence criteria.

         If not specified via setGlobalStatusTest(), this test is a StatusTestResNorm object which tests the
         2-norms of the Ritz residuals relative to the Ritz values.
       - ``debugtest`` allows a user to specify additional monitoring of the iteration, encapsulated in a StatusTest object

         If not specified via setDebugStatusTest(), ``debugtest`` is ignored.

         In most cases, it should return ::Failed; if it returns ::Passed, solve() will throw an AnasaziError exception.

    Additionally, the solver manager will terminate solve() after a specified number of restarts.

    Much of this behavior is controlled via parameters and options passed to the
    solver manager. For more information, see BlockKrylovSchurSolMgr().



     Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Basic constructor for BlockKrylovSchurSolMgr.

        This constructor accepts the Eigenproblem to be solved in addition
        to a parameter list of options for the solver manager. These options include the following:
          - Solver parameters
             - ``"Which"`` - a ``string`` specifying the desired eigenvalues: SM, LM, SR or LR. Default: "LM"
             - ``"Block Size"`` - an ``int`` specifying the block size to be used by the underlying block Krylov-Schur solver. Default: 1
             - ``"Num Blocks"`` - an ``int`` specifying the number of blocks allocated for the Krylov basis. Default: 3*nev
             - ``"Extra NEV Blocks"`` - an ``int`` specifying the number of extra blocks the solver should keep in addition to those
                     required to compute the number of eigenvalues requested.  Default: 0
             - ``"Maximum Restarts"`` - an ``int`` specifying the maximum number of restarts the underlying solver is allowed to perform. Default: 20
             - ``"Orthogonalization"`` - a ``string`` specifying the desired orthogonalization:  DGKS, ICGS, and SVQB. Default: "SVQB"
             - ``"Verbosity"`` - a sum of MsgType specifying the verbosity. Default: Anasazi::Errors
             - ``"Output Stream"`` - a reference-counted pointer to the formatted output stream where all
                                    solver output is sent.  Default: Teuchos::getFancyOStream ( Teuchos::rcpFromRef (std::cout) )
             - ``"Output Processor"`` - an ``int`` specifying the MPI processor that will print solver/timer details.  Default: 0
          - Convergence parameters
             - ``"Convergence Tolerance"`` - a ``MagnitudeType`` specifying the level that residual norms must reach to decide convergence. Default: machine precision.
             - ``"Relative Convergence Tolerance"`` - a ``bool`` specifying whether residuals norms should be scaled by their eigenvalues for the purposing of deciding convergence. Default: true
        """
        _Anasazi.BlockKrylovSchurSolMgrEpetra_swiginit(self, _Anasazi.new_BlockKrylovSchurSolMgrEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_BlockKrylovSchurSolMgrEpetra

    def getProblem(self, *args):
        r""" Return the eigenvalue problem."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getProblem(self, *args)

    def getNumIters(self, *args):
        r""" Get the iteration count for the most recent call to ``solve()``."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getNumIters(self, *args)

    def getRitzValues(self, *args):
        r""" Return the Ritz values from the most recent solve."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getRitzValues(self, *args)

    def getTimers(self, *args):
        r"""
         Return the timers for this object.

        The timers are ordered as follows:
          - time spent in solve() routine
          - time spent restarting
        """
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getTimers(self, *args)

    def solve(self, *args):
        r"""
         This method performs possibly repeated calls to the underlying eigensolver's iterate() routine
        until the problem has been solved (as decided by the solver manager) or the solver manager decides to
        quit.

        This method calls BlockKrylovSchur::iterate(), which will return either because a specially constructed status test evaluates to ::Passed
        or an exception is thrown.

        A return from BlockKrylovSchur::iterate() signifies one of the following scenarios:
           - the maximum number of restarts has been exceeded. In this scenario, the solver manager will place

             all converged eigenpairs into the eigenproblem and return ::Unconverged.
           - global convergence has been met. In this case, the most significant NEV eigenpairs in the solver and locked storage

             have met the convergence criterion. (Here, NEV refers to the number of eigenpairs requested by the Eigenproblem.)

             In this scenario, the solver manager will return ::Converged.

        :rtype: int
        :return: ::ReturnType specifying:
                - ::Converged: the eigenproblem was solved to the specification required by the solver manager.
                - ::Unconverged: the eigenproblem was not solved to the specification desired by the solver manager.
        """
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_solve(self, *args)

    def setGlobalStatusTest(self, *args):
        r""" Set the status test defining global convergence."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_setGlobalStatusTest(self, *args)

    def getGlobalStatusTest(self, *args):
        r""" Get the status test defining global convergence."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getGlobalStatusTest(self, *args)

    def setDebugStatusTest(self, *args):
        r""" Set the status test for debugging."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_setDebugStatusTest(self, *args)

    def getDebugStatusTest(self, *args):
        r""" Get the status test for debugging."""
        return _Anasazi.BlockKrylovSchurSolMgrEpetra_getDebugStatusTest(self, *args)

# Register BlockKrylovSchurSolMgrEpetra in _Anasazi:
_Anasazi.BlockKrylovSchurSolMgrEpetra_swigregister(BlockKrylovSchurSolMgrEpetra)
class LOBPCGEpetra(EigensolverEpetra):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         %LOBPCG constructor with eigenproblem, solver utilities, and parameter list of solver options.

        This constructor takes pointers required by the eigensolver, in addition
        to a parameter list of options for the eigensolver. These options include the following:
          - "Block Size" - an ``int`` specifying the block size used by the algorithm. This can also be specified using the setBlockSize() method.
          - "Full Ortho" - a ``bool`` specifying whether the solver should employ a full orthogonalization technique. This can also be specified using the setFullOrtho() method.
        """
        _Anasazi.LOBPCGEpetra_swiginit(self, _Anasazi.new_LOBPCGEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_LOBPCGEpetra

    def iterate(self, *args):
        r"""
         This method performs %LOBPCG iterations until the status test
        indicates the need to stop or an error occurs (in which case, an
        exception is thrown).

        iterate() will first determine whether the solver is initialized; if
        not, it will call initialize() using default arguments.  After
        initialization, the solver performs %LOBPCG iterations until the status
        test evaluates as Passed, at which point the method returns to the
        caller.

        The %LOBPCG iteration proceeds as follows:
        -# The current residual (R) is preconditioned to form H
        -# H is orthogonalized against the auxiliary vectors and, if full orthogonalization

           is enabled, against X and P.
        -# The basis [X H P] is used to project the problem matrices.
        -# The projected eigenproblem is solved, and the desired eigenvectors and eigenvalues are selected.
        -# These are used to form the new eigenvector estimates (X) and the search directions (P).

           If full orthogonalization is enabled, these are generated to be mutually orthogonal and with orthonormal columns.
        -# The new residual (R) is formed.

        The status test is queried at the beginning of the iteration.

        Possible exceptions thrown include std::logic_error, std::invalid_argument or
        one of the LOBPCG-specific exceptions.
        """
        return _Anasazi.LOBPCGEpetra_iterate(self, *args)

    def initialize(self, *args):
        r"""
        *Overload 1:*
         Initialize the solver to an iterate, optionally providing the
        Ritz values, residual, and search direction.

        Notes: LOBPCGState contains fields V, KV and MV: These are ignored by initialize()

        The %LOBPCG eigensolver contains a certain amount of state relating to
        the current iterate, including the current residual, the current search
        direction, and the images of these spaces under the eigenproblem operators.

        initialize() gives the user the opportunity to manually set these,
        although this must be done with caution, abiding by the rules
        given below. All notions of orthogonality and orthonormality are derived
        from the inner product specified by the orthogonalization manager.

        The user has the option of specifying any component of the state using
        initialize(). However, these arguments are assumed to match the
        post-conditions specified under isInitialized(). Any component of the
        state (i.e., KX) not given to initialize() will be generated.


        |

        *Overload 2:*
         Initialize the solver with the initial vectors from the eigenproblem
         or random data.
        """
        return _Anasazi.LOBPCGEpetra_initialize(self, *args)

    def isInitialized(self, *args):
        r"""
         Indicates whether the solver has been initialized or not.

        :rtype: boolean
        :return: bool indicating the state of the solver.
        """
        return _Anasazi.LOBPCGEpetra_isInitialized(self, *args)

    def getState(self, *args):
        r"""
         Get the current state of the eigensolver.

        The data is only valid if isInitialized() == ``true``. The
        data for the search directions P is only meaningful if hasP() ==
        ``true``. Finally, the data for the preconditioned residual (H) is only meaningful in the situation where
        the solver throws an ::LOBPCGRitzFailure exception during iterate().

        :rtype: Anasazi::LOBPCGState< double,Epetra_MultiVector >
        :return: An LOBPCGState object containing const views to the current
            solver state.
        """
        return _Anasazi.LOBPCGEpetra_getState(self, *args)

    def getNumIters(self, *args):
        r""" Get the current iteration count."""
        return _Anasazi.LOBPCGEpetra_getNumIters(self, *args)

    def resetNumIters(self, *args):
        r""" Reset the iteration count."""
        return _Anasazi.LOBPCGEpetra_resetNumIters(self, *args)

    def getRitzVectors(self, *args):
        r"""
        Get the Ritz vectors from the previous iteration.

               :rtype: Teuchos::RCP< Epetra_MultiVector const >
               :return: A multivector with getBlockSize() vectors containing
                   the sorted Ritz vectors corresponding to the most significant Ritz values.
                   The i-th vector of the return corresponds to the i-th Ritz vector; there is no need to use
                   getRitzIndex().
        """
        return _Anasazi.LOBPCGEpetra_getRitzVectors(self, *args)

    def getRitzValues(self, *args):
        r"""
        Get the Ritz values from the previous iteration.

        :rtype: std::vector< Anasazi::Value< double >,std::allocator< Anasazi::Value< double > > >
        :return: A vector of length getCurSubspaceDim() containing the Ritz values from the
            previous projected eigensolve.
        """
        return _Anasazi.LOBPCGEpetra_getRitzValues(self, *args)

    def getRitzIndex(self, *args):
        r"""
         Get the index used for extracting Ritz vectors from getRitzVectors().

        Because BlockDavidson is a Hermitian solver, all Ritz values are real and all Ritz vectors can be represented in a
        single column of a multivector. Therefore, getRitzIndex() is not needed when using the output from getRitzVectors().

        :rtype: std::vector< int,std::allocator< int > >
        :return: An ``int`` vector of size getCurSubspaceDim() composed of zeros.
        """
        return _Anasazi.LOBPCGEpetra_getRitzIndex(self, *args)

    def getResNorms(self, *args):
        r"""
        Get the current residual norms

        :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length getBlockSize() containing the norms of the
            residuals, with respect to the orthogonalization manager norm() method.
        """
        return _Anasazi.LOBPCGEpetra_getResNorms(self, *args)

    def getRes2Norms(self, *args):
        r"""
        Get the current residual 2-norms

        :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :return: A vector of length getBlockSize() containing the 2-norms of the
            residuals.
        """
        return _Anasazi.LOBPCGEpetra_getRes2Norms(self, *args)

    def getRitzRes2Norms(self, *args):
        r"""
         Get the 2-norms of the residuals.

        The Ritz residuals are not defined for the %LOBPCG iteration. Hence, this method returns the
        2-norms of the direct residuals, and is equivalent to calling getRes2Norms().

         :rtype: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
         :return: A vector of length getBlockSize() containing the 2-norms of the direct residuals.
        """
        return _Anasazi.LOBPCGEpetra_getRitzRes2Norms(self, *args)

    def getCurSubspaceDim(self, *args):
        r"""
        Get the dimension of the search subspace used to generate the current eigenvectors and eigenvalues.

        %LOBPCG employs a sequential subspace iteration, maintaining a fixed-rank basis, as opposed to an expanding subspace
        mechanism employed by Krylov-subspace solvers like BlockKrylovSchur and BlockDavidson.

        :rtype: int
        :return: An integer specifying the rank of the subspace generated by the eigensolver. If isInitialized() == ``false``,
            the return is 0. Otherwise, the return will be 2*getBlockSize() or 3*getBlockSize().
        """
        return _Anasazi.LOBPCGEpetra_getCurSubspaceDim(self, *args)

    def getMaxSubspaceDim(self, *args):
        r"""
        Get the maximum dimension allocated for the search subspace. For %LOBPCG, this always returns 3*getBlockSize(), the dimension of the
         subspace colspan([X H P]).
        """
        return _Anasazi.LOBPCGEpetra_getMaxSubspaceDim(self, *args)

    def setStatusTest(self, *args):
        r""" Set a new StatusTest for the solver."""
        return _Anasazi.LOBPCGEpetra_setStatusTest(self, *args)

    def getStatusTest(self, *args):
        r""" Get the current StatusTest used by the solver."""
        return _Anasazi.LOBPCGEpetra_getStatusTest(self, *args)

    def getProblem(self, *args):
        r""" Get a constant reference to the eigenvalue problem."""
        return _Anasazi.LOBPCGEpetra_getProblem(self, *args)

    def setBlockSize(self, *args):
        r"""
         Set the blocksize to be used by the iterative solver in solving
        this eigenproblem.

         If the block size is reduced, then the new iterate (and residual and
         search direction) are chosen as the subset of the current iterate
         preferred by the sort manager.  Otherwise, the solver state is set to
         uninitialized.
        """
        return _Anasazi.LOBPCGEpetra_setBlockSize(self, *args)

    def getBlockSize(self, *args):
        r""" Get the blocksize to be used by the iterative solver in solving this eigenproblem."""
        return _Anasazi.LOBPCGEpetra_getBlockSize(self, *args)

    def setAuxVecs(self, *args):
        r"""
        Set the auxiliary vectors for the solver.

        Because the current iterate X and search direction P cannot be assumed
        orthogonal to the new auxiliary vectors, a call to setAuxVecs() with a
        non-empty argument will reset the solver to the uninitialized state.

        In order to preserve the current state, the user will need to extract
        it from the solver using getState(), orthogonalize it against the new
        auxiliary vectors, and manually reinitialize the solver using
        initialize().
        """
        return _Anasazi.LOBPCGEpetra_setAuxVecs(self, *args)

    def getAuxVecs(self, *args):
        r""" Get the current auxiliary vectors."""
        return _Anasazi.LOBPCGEpetra_getAuxVecs(self, *args)

    def setFullOrtho(self, *args):
        r"""
        Instruct the LOBPCG iteration to use full orthogonality.

        If the getFullOrtho() == ``false`` and isInitialized() == ``true`` and hasP() == ``true``, then
        P will be invalidated by setting full orthogonalization to ``true``.
        """
        return _Anasazi.LOBPCGEpetra_setFullOrtho(self, *args)

    def getFullOrtho(self, *args):
        r""" Determine if the LOBPCG iteration is using full orthogonality."""
        return _Anasazi.LOBPCGEpetra_getFullOrtho(self, *args)

    def hasP(self, *args):
        r""" Indicates whether the search direction given by getState() is valid."""
        return _Anasazi.LOBPCGEpetra_hasP(self, *args)

    def currentStatus(self, *args):
        r""" This method requests that the solver print out its current status to screen."""
        return _Anasazi.LOBPCGEpetra_currentStatus(self, *args)

# Register LOBPCGEpetra in _Anasazi:
_Anasazi.LOBPCGEpetra_swigregister(LOBPCGEpetra)
class LOBPCGSolMgrEpetra(SolverManagerEpetra):
    r"""
    User interface for the LOBPCG eigensolver.

    This class provides a user interface for the LOBPCG (Locally
    Optimal Block Preconditioned Conjugate Gradient) eigensolver.  It
    provides the following features:


    *  Locking of converged eigenpairs
    *  Global convergence on only the significant eigenpairs (instead
         of any eigenpairs with low residual)
    *  recovery from orthogonalization failures (LOBPCGRitzFailure)
         when full orthogonalization is disabled


    Much of this behavior is controlled via parameters and options
    passed to the solver manager. For more information, see the default
    (zero-argument) constructor of this class.

    For an example that defines a custom StatusTest so that Anasazi's
    solver LOBPCG converges correctly with spectrum folding, see the
    LOBPCGCustomStatusTest.cpp example (associated with StatusTest).

    LOBPCG stops iterating if it has reached the maximum number of
    iterations, or ig lobal convergence is detected (uses
    StatusTestWithOrdering to ensure that only the most significant
    eigenvalues/eigenvectors have converged).  If not specified via
    setGlobalStatusTest(), the convergence test is a StatusTestResNorm
    instance which tests the M-norms of the direct residuals relative
    to the Ritz values.

    LOBPCG also includes a "locking test" which deflates converged
    eigenpairs for locking.  It will query the underlying LOBPCG
    eigensolver to determine when eigenvectors should be locked.  If
    not specified via setLockingStatusTest(), the locking test is a
    StatusTestResNorm object.

    Users may specify an optional "debug test."  This lets users
    specify additional monitoring of the iteration.  If not specified
    via setDebugStatusTest(), this is ignored.  In most cases, the
    user's debug test should return ::Failed; if it returns ::Passed,
    solve() will throw an AnasaziError exception.


    Author: Chris Baker, Ulrich Hetmaniuk, Rich Lehoucq, Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Basic constructor for LOBPCGSolMgr.

        This constructor accepts the Eigenproblem to be solved in addition
        to a parameter list of options for the solver manager. These options include the following:
          - Solver parameters
             - ``"Which"`` - a ``string`` specifying the desired eigenvalues: SM, LM, SR or LR. Default: "SR"
             - ``"Block Size"`` - an ``int`` specifying the block size to be used by the underlying LOBPCG solver. Default: problem->getNEV()
             - ``"Full Ortho"`` - a ``bool`` specifying whether the underlying solver should employ the full orthogonalization scheme. Default: true
             - ``"Recover"`` - a ``bool`` specifying whether the solver manager should attempt to recover in the case of a LOBPCGRitzFailure when full orthogonalization is disabled. Default: true
             - ``"Verbosity"`` - a sum of MsgType specifying the verbosity. Default: ::Errors
             - ``"Init"`` - a LOBPCGState<ScalarType,MV> struct used to initialize the LOBPCG eigensolver.
             - ``"Output Stream"`` - a reference-counted pointer to the formatted output stream where all
                                    solver output is sent.  Default: Teuchos::getFancyOStream ( Teuchos::rcpFromRef (std::cout) )
             - ``"Output Processor"`` - an ``int`` specifying the MPI processor that will print solver/timer details.  Default: 0
          - Convergence parameters (if using default convergence test; see setGlobalStatusTest())
             - ``"Maximum Iterations"`` - an ``int`` specifying the maximum number of iterations the underlying solver is allowed to perform. Default: 100
             - ``"Convergence Tolerance"`` - a ``MagnitudeType`` specifying the level that residual norms must reach to decide convergence. Default: machine precision.
             - ``"Relative Convergence Tolerance"`` - a ``bool`` specifying whether residuals norms should be scaled by their eigenvalues for the purposing of deciding convergence. Default: true
             - ``"Convergence Norm"`` - a ``string`` specifying the norm for convergence testing: "2" or "M"
          - Locking parameters (if using default locking test; see setLockingStatusTest())
             - ``"Use Locking"`` - a ``bool`` specifying whether the algorithm should employ locking of converged eigenpairs. Default: false
             - ``"Max Locked"`` - an ``int`` specifying the maximum number of eigenpairs to be locked. Default: problem->getNEV()
             - ``"Locking Quorum"`` - an ``int`` specifying the number of eigenpairs that must meet the locking criteria before locking actually occurs. Default: 1
             - ``"Locking Tolerance"`` - a ``MagnitudeType`` specifying the level that residual norms must reach to decide locking. Default: 0.1*convergence tolerance
             - ``"Relative Locking Tolerance"`` - a ``bool`` specifying whether residuals norms should be scaled by their eigenvalues for the purposing of deciding locking. Default: true
             - ``"Locking Norm"`` - a ``string`` specifying the norm for locking testing: "2" or "M"
        """
        _Anasazi.LOBPCGSolMgrEpetra_swiginit(self, _Anasazi.new_LOBPCGSolMgrEpetra(*args))
    __swig_destroy__ = _Anasazi.delete_LOBPCGSolMgrEpetra

    def getProblem(self, *args):
        r""" Return the eigenvalue problem."""
        return _Anasazi.LOBPCGSolMgrEpetra_getProblem(self, *args)

    def getNumIters(self, *args):
        r""" Get the iteration count for the most recent call to ``solve()``."""
        return _Anasazi.LOBPCGSolMgrEpetra_getNumIters(self, *args)

    def getTimers(self, *args):
        r"""
         Return the timers for this object.

        The timers are ordered as follows:
          - time spent in solve() routine
          - time spent locking converged eigenvectors
        """
        return _Anasazi.LOBPCGSolMgrEpetra_getTimers(self, *args)

    def solve(self, *args):
        r"""
         This method performs possibly repeated calls to the underlying eigensolver's iterate() routine
        until the problem has been solved (as decided by the solver manager) or the solver manager decides to
        quit.

        This method calls LOBPCG::iterate(), which will return either because a specially constructed status test evaluates to ::Passed
        or an exception is thrown.

        A return from LOBPCG::iterate() signifies one of the following scenarios:
           - the maximum number of iterations has been exceeded. In this scenario, the solver manager will place

             all converged eigenpairs into the eigenproblem and return ::Unconverged.
           - the locking conditions have been met. In this scenario, some of the current eigenpairs will be removed

             from the eigensolver and placed into auxiliary storage. The eigensolver will be restarted with the remaining

             eigenpairs and some random information to replace the removed eigenpairs.
           - global convergence has been met. In this case, the most significant NEV eigenpairs in the solver and locked storage

             have met the convergence criterion. (Here, NEV refers to the number of eigenpairs requested by the Eigenproblem.)

             In this scenario, the solver manager will return ::Converged.
           - an LOBPCGRitzFailure exception has been thrown. If full orthogonalization is enabled and recovery from this exception

             is requested, the solver manager will attempt to recover from this exception by gathering the current eigenvectors,

             preconditioned residual, and search directions from the eigensolver, orthogonormalizing the basis composed of these

             three, projecting the eigenproblem, and restarting the eigensolver with the solution of the project eigenproblem. Any

             additional failure that occurs during this recovery effort will result in the eigensolver returning ::Unconverged.

        :rtype: int
        :return: ::ReturnType specifying:
               - ::Converged: the eigenproblem was solved to the specification required by the solver manager.
               - ::Unconverged: the eigenproblem was not solved to the specification desired by the solver manager
        """
        return _Anasazi.LOBPCGSolMgrEpetra_solve(self, *args)

    def setGlobalStatusTest(self, *args):
        r""" Set the status test defining global convergence."""
        return _Anasazi.LOBPCGSolMgrEpetra_setGlobalStatusTest(self, *args)

    def getGlobalStatusTest(self, *args):
        r""" Get the status test defining global convergence."""
        return _Anasazi.LOBPCGSolMgrEpetra_getGlobalStatusTest(self, *args)

    def setLockingStatusTest(self, *args):
        r""" Set the status test defining locking."""
        return _Anasazi.LOBPCGSolMgrEpetra_setLockingStatusTest(self, *args)

    def getLockingStatusTest(self, *args):
        r""" Get the status test defining locking."""
        return _Anasazi.LOBPCGSolMgrEpetra_getLockingStatusTest(self, *args)

    def setDebugStatusTest(self, *args):
        r""" Set the status test for debugging."""
        return _Anasazi.LOBPCGSolMgrEpetra_setDebugStatusTest(self, *args)

    def getDebugStatusTest(self, *args):
        r""" Get the status test for debugging."""
        return _Anasazi.LOBPCGSolMgrEpetra_getDebugStatusTest(self, *args)

# Register LOBPCGSolMgrEpetra in _Anasazi:
_Anasazi.LOBPCGSolMgrEpetra_swigregister(LOBPCGSolMgrEpetra)
class EigensolutionEpetra(object):
    r"""  Struct for storing an eigenproblem solution."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    index = property(_Anasazi.EigensolutionEpetra_index_get, _Anasazi.EigensolutionEpetra_index_set, doc=r"""
    An index into Evecs to allow compressed storage of eigenvectors for real, non-Hermitian problems.

    index has length numVecs, where each entry is 0, +1, or -1. These have the following interpretation:
       - index[i] == 0: signifies that the corresponding eigenvector is stored as the i column of Evecs. This will usually be the
         case when ScalarType is complex, an eigenproblem is Hermitian, or a real, non-Hermitian eigenproblem has a real eigenvector.
       - index[i] == +1: signifies that the corresponding eigenvector is stored in two vectors: the real part in the i column of Evecs and the ***positive*** imaginary part in the i+1 column of Evecs.
       - index[i] == -1: signifies that the corresponding eigenvector is stored in two vectors: the real part in the i-1 column of Evecs and the ***negative*** imaginary part in the i column of Evecs
    """)
    numVecs = property(_Anasazi.EigensolutionEpetra_numVecs_get, _Anasazi.EigensolutionEpetra_numVecs_set, doc=r""" The number of computed eigenpairs""")

    def __init__(self, *args):
        _Anasazi.EigensolutionEpetra_swiginit(self, _Anasazi.new_EigensolutionEpetra(*args))

    def evals(self, *args):
        return _Anasazi.EigensolutionEpetra_evals(self, *args)

    def evecs(self, *args):
        return _Anasazi.EigensolutionEpetra_evecs(self, *args)

    def espace(self, *args):
        return _Anasazi.EigensolutionEpetra_espace(self, *args)
    __swig_destroy__ = _Anasazi.delete_EigensolutionEpetra

# Register EigensolutionEpetra in _Anasazi:
_Anasazi.EigensolutionEpetra_swigregister(EigensolutionEpetra)

EigensolutionEpetra.Evals  = EigensolutionEpetra.evals
EigensolutionEpetra.Evecs  = EigensolutionEpetra.evecs
EigensolutionEpetra.Espace = EigensolutionEpetra.espace

class VectorValueDouble(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def iterator(self, *args):
        return _Anasazi.VectorValueDouble_iterator(self, *args)
    def __iter__(self):
        return self.iterator()

    def __nonzero__(self, *args):
        return _Anasazi.VectorValueDouble___nonzero__(self, *args)

    def __bool__(self, *args):
        return _Anasazi.VectorValueDouble___bool__(self, *args)

    def __len__(self, *args):
        return _Anasazi.VectorValueDouble___len__(self, *args)

    def __getslice__(self, *args):
        return _Anasazi.VectorValueDouble___getslice__(self, *args)

    def __setslice__(self, *args):
        return _Anasazi.VectorValueDouble___setslice__(self, *args)

    def __delslice__(self, *args):
        return _Anasazi.VectorValueDouble___delslice__(self, *args)

    def __delitem__(self, *args):
        return _Anasazi.VectorValueDouble___delitem__(self, *args)

    def __getitem__(self, *args):
        return _Anasazi.VectorValueDouble___getitem__(self, *args)

    def __setitem__(self, *args):
        return _Anasazi.VectorValueDouble___setitem__(self, *args)

    def pop(self, *args):
        return _Anasazi.VectorValueDouble_pop(self, *args)

    def append(self, *args):
        return _Anasazi.VectorValueDouble_append(self, *args)

    def empty(self, *args):
        return _Anasazi.VectorValueDouble_empty(self, *args)

    def size(self, *args):
        return _Anasazi.VectorValueDouble_size(self, *args)

    def swap(self, *args):
        return _Anasazi.VectorValueDouble_swap(self, *args)

    def begin(self, *args):
        return _Anasazi.VectorValueDouble_begin(self, *args)

    def end(self, *args):
        return _Anasazi.VectorValueDouble_end(self, *args)

    def rbegin(self, *args):
        return _Anasazi.VectorValueDouble_rbegin(self, *args)

    def rend(self, *args):
        return _Anasazi.VectorValueDouble_rend(self, *args)

    def clear(self, *args):
        return _Anasazi.VectorValueDouble_clear(self, *args)

    def get_allocator(self, *args):
        return _Anasazi.VectorValueDouble_get_allocator(self, *args)

    def pop_back(self, *args):
        return _Anasazi.VectorValueDouble_pop_back(self, *args)

    def erase(self, *args):
        return _Anasazi.VectorValueDouble_erase(self, *args)

    def __init__(self, *args):
        _Anasazi.VectorValueDouble_swiginit(self, _Anasazi.new_VectorValueDouble(*args))

    def push_back(self, *args):
        return _Anasazi.VectorValueDouble_push_back(self, *args)

    def front(self, *args):
        return _Anasazi.VectorValueDouble_front(self, *args)

    def back(self, *args):
        return _Anasazi.VectorValueDouble_back(self, *args)

    def assign(self, *args):
        return _Anasazi.VectorValueDouble_assign(self, *args)

    def resize(self, *args):
        return _Anasazi.VectorValueDouble_resize(self, *args)

    def insert(self, *args):
        return _Anasazi.VectorValueDouble_insert(self, *args)

    def reserve(self, *args):
        return _Anasazi.VectorValueDouble_reserve(self, *args)

    def capacity(self, *args):
        return _Anasazi.VectorValueDouble_capacity(self, *args)
    __swig_destroy__ = _Anasazi.delete_VectorValueDouble

# Register VectorValueDouble in _Anasazi:
_Anasazi.VectorValueDouble_swigregister(VectorValueDouble)
class VectorInt(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def iterator(self, *args):
        return _Anasazi.VectorInt_iterator(self, *args)
    def __iter__(self):
        return self.iterator()

    def __nonzero__(self, *args):
        return _Anasazi.VectorInt___nonzero__(self, *args)

    def __bool__(self, *args):
        return _Anasazi.VectorInt___bool__(self, *args)

    def __len__(self, *args):
        return _Anasazi.VectorInt___len__(self, *args)

    def __getslice__(self, *args):
        return _Anasazi.VectorInt___getslice__(self, *args)

    def __setslice__(self, *args):
        return _Anasazi.VectorInt___setslice__(self, *args)

    def __delslice__(self, *args):
        return _Anasazi.VectorInt___delslice__(self, *args)

    def __delitem__(self, *args):
        return _Anasazi.VectorInt___delitem__(self, *args)

    def __getitem__(self, *args):
        return _Anasazi.VectorInt___getitem__(self, *args)

    def __setitem__(self, *args):
        return _Anasazi.VectorInt___setitem__(self, *args)

    def pop(self, *args):
        return _Anasazi.VectorInt_pop(self, *args)

    def append(self, *args):
        return _Anasazi.VectorInt_append(self, *args)

    def empty(self, *args):
        return _Anasazi.VectorInt_empty(self, *args)

    def size(self, *args):
        return _Anasazi.VectorInt_size(self, *args)

    def swap(self, *args):
        return _Anasazi.VectorInt_swap(self, *args)

    def begin(self, *args):
        return _Anasazi.VectorInt_begin(self, *args)

    def end(self, *args):
        return _Anasazi.VectorInt_end(self, *args)

    def rbegin(self, *args):
        return _Anasazi.VectorInt_rbegin(self, *args)

    def rend(self, *args):
        return _Anasazi.VectorInt_rend(self, *args)

    def clear(self, *args):
        return _Anasazi.VectorInt_clear(self, *args)

    def get_allocator(self, *args):
        return _Anasazi.VectorInt_get_allocator(self, *args)

    def pop_back(self, *args):
        return _Anasazi.VectorInt_pop_back(self, *args)

    def erase(self, *args):
        return _Anasazi.VectorInt_erase(self, *args)

    def __init__(self, *args):
        _Anasazi.VectorInt_swiginit(self, _Anasazi.new_VectorInt(*args))

    def push_back(self, *args):
        return _Anasazi.VectorInt_push_back(self, *args)

    def front(self, *args):
        return _Anasazi.VectorInt_front(self, *args)

    def back(self, *args):
        return _Anasazi.VectorInt_back(self, *args)

    def assign(self, *args):
        return _Anasazi.VectorInt_assign(self, *args)

    def resize(self, *args):
        return _Anasazi.VectorInt_resize(self, *args)

    def insert(self, *args):
        return _Anasazi.VectorInt_insert(self, *args)

    def reserve(self, *args):
        return _Anasazi.VectorInt_reserve(self, *args)

    def capacity(self, *args):
        return _Anasazi.VectorInt_capacity(self, *args)
    __swig_destroy__ = _Anasazi.delete_VectorInt

# Register VectorInt in _Anasazi:
_Anasazi.VectorInt_swigregister(VectorInt)

def Value(*args):
    """
    Factory function for class Value.  Currently, this returns a python
    wrapper around class Value<double>.
    """
    return ValueDouble(*args)


def OutputManager(*args):
    """
    Factory function for class OutputManager.  Currently, this returns a python
    wrapper around class OutputManager<double>.
    """
    return OutputManagerDouble(*args)


def BasicOutputManager(*args):
    """
    Factory function for class BasicOutputManager.  Currently, this returns a python
    wrapper around class BasicOutputManager<double>.
    """
    return BasicOutputManagerDouble(*args)


def MultiVec(*args):
    """
    Factory function for class MultiVec.  Currently, this returns a python
    wrapper around class MultiVec<double>.
    """
    return MultiVecDouble(*args)


def Operator(*args):
    """
    Factory function for class Operator.  Currently, this returns a python
    wrapper around class Operator<double>.
    """
    return OperatorDouble(*args)


def SortManager(*args):
    """
    Factory function for class SortManager.  Currently, this returns a python
    wrapper around class SortManager<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return SortManagerEpetra(*args)


def BasicSort(*args):
    """
    Factory function for class BasicSort.  Currently, this returns a python
    wrapper around class BasicSort<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BasicSortEpetra(*args)


def MultiVecTraits(*args):
    """
    Factory function for class MultiVecTraits.  Currently, this returns a python
    wrapper around class MultiVecTraits<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return MultiVecTraitsEpetra(*args)


def OperatorTraits(*args):
    """
    Factory function for class OperatorTraits.  Currently, this returns a python
    wrapper around class OperatorTraits<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return OperatorTraitsEpetra(*args)


def Eigenproblem(*args):
    """
    Factory function for class Eigenproblem.  Currently, this returns a python
    wrapper around class Eigenproblem<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return EigenproblemEpetra(*args)


def BasicEigenproblem(*args):
    """
    Factory function for class BasicEigenproblem.  Currently, this returns a python
    wrapper around class BasicEigenproblem<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BasicEigenproblemEpetra(*args)


def StatusTest(*args):
    """
    Factory function for class StatusTest.  Currently, this returns a python
    wrapper around class StatusTest<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return StatusTestEpetra(*args)


def StatusTestCombo(*args):
    """
    Factory function for class StatusTestCombo.  Currently, this returns a python
    wrapper around class StatusTestCombo<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return StatusTestComboEpetra(*args)


def StatusTestMaxIters(*args):
    """
    Factory function for class StatusTestMaxIters.  Currently, this returns a python
    wrapper around class StatusTestMaxIters<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return StatusTestMaxItersEpetra(*args)


def StatusTestOutput(*args):
    """
    Factory function for class StatusTestOutput.  Currently, this returns a python
    wrapper around class StatusTestOutput<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return StatusTestOutputEpetra(*args)


def StatusTestResNorm(*args):
    """
    Factory function for class StatusTestResNorm.  Currently, this returns a python
    wrapper around class StatusTestResNorm<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return StatusTestResNormEpetra(*args)


def OrthoManager(*args):
    """
    Factory function for class OrthoManager.  Currently, this returns a python
    wrapper around class OrthoManager<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return OrthoManagerEpetra(*args)


def MatOrthoManager(*args):
    """
    Factory function for class MatOrthoManager.  Currently, this returns a python
    wrapper around class MatOrthoManager<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return MatOrthoManagerEpetra(*args)


def SVQBOrthoManager(*args):
    """
    Factory function for class SVQBOrthoManager.  Currently, this returns a python
    wrapper around class SVQBOrthoManager<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return SVQBOrthoManagerEpetra(*args)


def Eigensolver(*args):
    """
    Factory function for class Eigensolver.  Currently, this returns a python
    wrapper around class Eigensolver<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return EigensolverEpetra(*args)


def SolverManager(*args):
    """
    Factory function for class SolverManager.  Currently, this returns a python
    wrapper around class SolverManager<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return SolverManagerEpetra(*args)


def BlockDavidson(*args):
    """
    Factory function for class BlockDavidson.  Currently, this returns a python
    wrapper around class BlockDavidson<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BlockDavidsonEpetra(*args)


def BlockDavidsonSolMgr(*args):
    """
    Factory function for class BlockDavidsonSolMgr.  Currently, this returns a python
    wrapper around class BlockDavidsonSolMgr<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BlockDavidsonSolMgrEpetra(*args)


def BlockKrylovSchur(*args):
    """
    Factory function for class BlockKrylovSchur.  Currently, this returns a python
    wrapper around class BlockKrylovSchur<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BlockKrylovSchurEpetra(*args)


def BlockKrylovSchurSolMgr(*args):
    """
    Factory function for class BlockKrylovSchurSolMgr.  Currently, this returns a python
    wrapper around class BlockKrylovSchurSolMgr<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return BlockKrylovSchurSolMgrEpetra(*args)


def LOBPCG(*args):
    """
    Factory function for class LOBPCG.  Currently, this returns a python
    wrapper around class LOBPCG<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return LOBPCGEpetra(*args)


def LOBPCGSolMgr(*args):
    """
    Factory function for class LOBPCGSolMgr.  Currently, this returns a python
    wrapper around class LOBPCGSolMgr<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return LOBPCGSolMgrEpetra(*args)


def Eigensolution(*args):
    """
    Factory function for class Eigensolution.  Currently, this returns a python
    wrapper around class Eigensolution<double,Epetra_MultiVector,Epetra_Operator>.
    """
    return EigensolutionEpetra(*args)


