# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.Galeri is the python interface to the Trilinos example
matrix package Galeri:

    https://trilinos.org/docs/dev/packages/galeri/doc/html/index.html

The purpose of Galeri is to provide a set of example matrices
distributed across a set of common processor decompositions for
testing purposes.

Galeri provides the following user-level functions:

    * CreateCartesianCoordinates  - Create cartesian coordinates
    * GetNeighboursCartesian2d    - Get neighbor nodes from a 2D grid
    * GetNeighboursCartesian3d    - Get neighbor nodes from a 3D grid
    * PrintStencil2D              - Output a 2D stencil
    * CreateMap                   - Create a Map object
    * CreateCrsMatrix             - Create a specified CrsMatrix
    * CreateVbrMatrix             - Create a specified VbrMatrix
    * ReadHB                      - Read a problem definition from an HB file

For examples of usage, please consult the following scripts in the
example subdirectory of the PyTrilinos package:

    * exGaleri.py
    * exGaleri_ReadHB.py
    * exAztecOO.py
    * exIFPACK.py
    * exMLAPI_Simple.py

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Galeri
else:
    import _Galeri

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Galeri.delete_SwigPyIterator

    def value(self):
        return _Galeri.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _Galeri.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _Galeri.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _Galeri.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _Galeri.SwigPyIterator_equal(self, x)

    def copy(self):
        return _Galeri.SwigPyIterator_copy(self)

    def next(self):
        return _Galeri.SwigPyIterator_next(self)

    def __next__(self):
        return _Galeri.SwigPyIterator___next__(self)

    def previous(self):
        return _Galeri.SwigPyIterator_previous(self)

    def advance(self, n):
        return _Galeri.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _Galeri.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _Galeri.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _Galeri.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _Galeri.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _Galeri.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _Galeri.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Galeri:
_Galeri.SwigPyIterator_swigregister(SwigPyIterator)
from . import Teuchos
from .Teuchos import Base
from . import Epetra

def Galeri_Version(*args):
    return _Galeri.Galeri_Version(*args)

__version__ = Galeri_Version().split()[2]


def CreateCartesianCoordinates(*args):
    return _Galeri.CreateCartesianCoordinates(*args)

def Solve(*args):
    return _Galeri.Solve(*args)

def ComputeNorm(*args):
    return _Galeri.ComputeNorm(*args)

def toString(*args):
    return _Galeri.toString(*args)

def GetNeighboursCartesian2d(*args):
    return _Galeri.GetNeighboursCartesian2d(*args)

def GetNeighboursCartesian3d(*args):
    return _Galeri.GetNeighboursCartesian3d(*args)

def PrintStencil2D(*args):
    return _Galeri.PrintStencil2D(*args)

def CreateMap(*args):
    return _Galeri.CreateMap(*args)

def CreateMap64(*args):
    return _Galeri.CreateMap64(*args)

def CreateCrsMatrix(*args):
    return _Galeri.CreateCrsMatrix(*args)

def CreateVbrMatrix(*args):
    return _Galeri.CreateVbrMatrix(*args)

def ReadHB(*args):
    r"""
    ReadHB(str filename, Epetra.Comm comm) -> (Epetra.Map map, Epetra.CrsMatrix A,
                                               Epetra.Vector x, Epetra.Vector b,
                                               Epetra.Vector exact)

    Given an HB filename and an Epetra communicator, return a tuple of
    Epetra objects generated from the problem described in the file.  This
    tuple contains an Epetra.Map, Epetra.CrsMatrix, and Epetra.Vectors for
    the solution, right-hand side and the exact solution.
    """
    return _Galeri.ReadHB(*args)

