# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Abstract is the python interface to namespace Abstract
of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Abstract is to provide abstract continuation
problem base classes.  The python version of LOCA.Abstract supports
the following classes:

    * Group                - Compatiblity class for AbstractGroup hierarchy
    * TransposeSolveGroup  - Abstract group interface class for solving the
                             transpose of the Jacobian
    * Iterator             - Abstract interface for implementing iteration
    * Factory              - Abstract interface for providing a user-defined
                             factory

"""

from sys import version_info as _swig_python_version_info

from . import _Abstract
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import MultiContinuation
from PyTrilinos.LOCA import Homotopy
from PyTrilinos.LOCA import TimeDependent
from PyTrilinos.LOCA import TurningPoint
from PyTrilinos.LOCA import Pitchfork
from PyTrilinos.LOCA import Hopf
from PyTrilinos.LOCA import PhaseTransition


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import Homotopy
import TimeDependent
import TurningPoint.MooreSpence
import TurningPoint.MinimallyAugmented
import Pitchfork.MooreSpence
import Pitchfork.MinimallyAugmented
import Hopf.MooreSpence
import Hopf.MinimallyAugmented
import PhaseTransition
class Group(Homotopy.AbstractGroup, TurningPoint.MinimallyAugmented.FiniteDifferenceGroup, Pitchfork.MinimallyAugmented.AbstractGroup, Hopf.MinimallyAugmented.FiniteDifferenceGroup, PhaseTransition.AbstractGroup):
    r"""
    Compatiblity class for AbstractGroup hierarchy.

    This class is derived from all %LOCA AbstractGroup abstract base
    classes as well as all FiniteDifference groups and any other groups
    that provided default implementations for AbstractGroup pure virtual
    methods.  This class provides definitions for all needed assignment
    operators and provides definitions for some pure virtual methods by
    printing error messages.  This class exists primarily for compatiblity
    to an older class hierarchy and will most likely be removed in the
    future.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Abstract.delete_Group

    def augmentJacobianForHomotopy(self, *args):
        r"""
        Replace Jacobian :math:`J` by :math:`aJ+bI` where :math:`I` is
        the identity matrix and :math:`p` is a scalar.

        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_augmentJacobianForHomotopy(self, *args)

    def computeShiftedMatrix(self, *args):
        r"""
         Compute the shifted matrix
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_computeShiftedMatrix(self, *args)

    def applyShiftedMatrix(self, *args):
        r"""
         Multiply the shifted matrix by a vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyShiftedMatrix(self, *args)

    def applyShiftedMatrixMultiVector(self, *args):
        r"""
         Multiply the shifted matrix by a multi-vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyShiftedMatrixMultiVector(self, *args)

    def applyShiftedMatrixInverseMultiVector(self, *args):
        r"""
        Apply the inverse of the shifted matrix by a multi-vector, as
        needed by the shift-and-invert and generalized Cayley transformations.

        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyShiftedMatrixInverseMultiVector(self, *args)

    def computeSecondShiftedMatrix(self, *args):
        r"""
         Compute the second shifted matrix. Can avoid recomputing if two are stored.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_computeSecondShiftedMatrix(self, *args)

    def applySecondShiftedMatrix(self, *args):
        r"""
         Multiply the shifted matrix by a vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applySecondShiftedMatrix(self, *args)

    def applySecondShiftedMatrixMultiVector(self, *args):
        r"""
         Multiply the shifted matrix by a multi-vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applySecondShiftedMatrixMultiVector(self, *args)

    def isComplex(self, *args):
        r"""
         Is  :math:`J+i\omega B` valid
        The implementation here always returns false.
        """
        return _Abstract.Group_isComplex(self, *args)

    def computeComplex(self, *args):
        r"""
         Compute :math:`J+i\omega B`
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_computeComplex(self, *args)

    def applyComplex(self, *args):
        r"""
         Compute :math:`(J+i\omega B)(y+iz)`
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyComplex(self, *args)

    def applyComplexMultiVector(self, *args):
        r"""
         Compute :math:`(J+i\omega B)(y+iz)`
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyComplexMultiVector(self, *args)

    def applyComplexInverseMultiVector(self, *args):
        r"""
         Solve :math:`(J+i\omega B)(y+iz) = a+ib`
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyComplexInverseMultiVector(self, *args)

    def applyComplexTranspose(self, *args):
        r"""
        Computes conjugate-tranpose matrix vector product
        :math:`(J+i\omega B)^H (x + iy)`.

        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _Abstract.Group_applyComplexTranspose(self, *args)

    def applyComplexTransposeMultiVector(self, *args):
        r"""
        Computes conjugate-tranpose matrix vector product
        :math:`(J+i\omega B)^H (x + iy)`.
        """
        return _Abstract.Group_applyComplexTransposeMultiVector(self, *args)

    def applyComplexTransposeInverseMultiVector(self, *args):
        r""" Solve :math:`(J+i\omega B)^H (x + iy) = a+ib`"""
        return _Abstract.Group_applyComplexTransposeInverseMultiVector(self, *args)

    def copy(self, *args):
        r""" Assignment operator"""
        return _Abstract.Group_copy(self, *args)

    def setParamsMulti(self, *args):
        r""" Set parameters indexed by (integer) paramIDs"""
        return _Abstract.Group_setParamsMulti(self, *args)

    def notifyCompletedStep(self, *args):
        r""" Notify group that the continuation step is completed The default implementation here is to do nothing."""
        return _Abstract.Group_notifyCompletedStep(self, *args)

    def computeFreeEnergy(self, *args):
        return _Abstract.Group_computeFreeEnergy(self, *args)

# Register Group in _Abstract:
_Abstract.Group_swigregister(Group)
class TransposeSolveGroup(PyTrilinos.NOX.Abstract.Group):
    r"""
    Abstract group interface class for solving the transpose
    of the Jacobian.

    This interface, derived from NOX::Abstract::Group, provides the
    additional interface for solving the transpose of the Jacobian.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Abstract.delete_TransposeSolveGroup

    def applyJacobianTransposeInverse(self, *args):
        r""" Solve Jacobian-tranpose system"""
        return _Abstract.TransposeSolveGroup_applyJacobianTransposeInverse(self, *args)

    def applyJacobianTransposeInverseMultiVector(self, *args):
        r""" Solve Jacobian-tranpose system with multiple right-hand sides"""
        return _Abstract.TransposeSolveGroup_applyJacobianTransposeInverseMultiVector(self, *args)

# Register TransposeSolveGroup in _Abstract:
_Abstract.TransposeSolveGroup_swigregister(TransposeSolveGroup)
class Iterator(object):
    r"""
    An abstract interface for implementing iteration.

    The %LOCA::Abstract::Iterator defines an interface for implementing
    many kinds of iterative processes.  In %LOCA, this is used to implement
    the %Stepper which computes points along a continuation curve.

    Many iterative processes can be abstracted in the following manner:


    *  Initialize iteration (start)
    *  Compute iteration (iterate)

         *  while iterator is not finished

              *  preprocess step (preprocess)
              *  compute step (compute)
          *  postprocess step (posprocess)
          *  check iterator status (stop)


    *  Finalize iteration (finish)


    The run method of the iterator implements this iterative process with
    start, finish, preprocess, compute and postprocess left as pure
    virtual methods to be implemented for the specific iterative process.

    The iterator has one parameter, "Max Steps" (default 100) giving the
    maximum number of steps the iterator should take.  The default
    implementation of stop only stops the iterator when this maximum
    number of steps has been reached.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    LastIteration = _Abstract.Iterator_LastIteration
    r""" This is the last iteration"""
    Finished = _Abstract.Iterator_Finished
    r""" The iterator is finished"""
    Failed = _Abstract.Iterator_Failed
    r""" The iterator has failed"""
    NotFinished = _Abstract.Iterator_NotFinished
    r""" The iterator is not finished"""
    Successful = _Abstract.Iterator_Successful
    r""" The last step was successful"""
    Unsuccessful = _Abstract.Iterator_Unsuccessful
    r""" The last step was unsuccessful"""
    Provisional = _Abstract.Iterator_Provisional
    r""" One more unsuccessful step means failure"""
    __swig_destroy__ = _Abstract.delete_Iterator

    def resetIterator(self, *args):
        r""" Reset the iterator to start a new iteration"""
        return _Abstract.Iterator_resetIterator(self, *args)

    def getIteratorStatus(self, *args):
        r""" Return the status of the iterator"""
        return _Abstract.Iterator_getIteratorStatus(self, *args)

    def getStepNumber(self, *args):
        r""" Returns the number of accepted steps"""
        return _Abstract.Iterator_getStepNumber(self, *args)

    def getNumFailedSteps(self, *args):
        r""" Returns the number of failed steps"""
        return _Abstract.Iterator_getNumFailedSteps(self, *args)

    def getNumTotalSteps(self, *args):
        r""" Returns the total number of steps attempted"""
        return _Abstract.Iterator_getNumTotalSteps(self, *args)

    def run(self, *args):
        r""" Run the iterator"""
        return _Abstract.Iterator_run(self, *args)

# Register Iterator in _Abstract:
_Abstract.Iterator_swigregister(Iterator)
class Factory(object):
    r"""
     %Abstract interface for providing a user-defined factory
    %LOCA::Abstract::Factory provides an abstract interface for providing
    user-defined factories to the LOCA::Factory.  The LOCA::Factory provides
    a mechanism for instantiating different strategies based on
    parameter list choices.  This class allows additional strategies to
    be instantiated by the factory without modifying the factory itself.
    This is done by deriving a user-defined factory from this interface,
    implementing any of the create methods for the user-defined strategies,
    and passing an instance of the derived factory to the LOCA::Factory
    object.  Any derived class must implement the
    ``init()`` method to set the global data object which the
    factory can then pass to any instantiated strategies.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Abstract.delete_Factory

    def init(self, *args):
        r"""
         Initialize factory
        The LOCA::Factory will call this method to initialize the
        user provided factory.  The user-provided factory should perform
        any needed initialization here that cannot occur at construction.
        """
        return _Abstract.Factory_init(self, *args)

    def createPredictorStrategy(self, *args):
        r""" Create predictor strategy"""
        return _Abstract.Factory_createPredictorStrategy(self, *args)

    def createContinuationStrategy(self, *args):
        r""" Create continuation strategy"""
        return _Abstract.Factory_createContinuationStrategy(self, *args)

    def createBifurcationStrategy(self, *args):
        r""" Create bifurcation strategy"""
        return _Abstract.Factory_createBifurcationStrategy(self, *args)

    def createStepSizeStrategy(self, *args):
        r""" Create step size strategy"""
        return _Abstract.Factory_createStepSizeStrategy(self, *args)

    def createBorderedSolverStrategy(self, *args):
        r""" Create bordered system solver strategy"""
        return _Abstract.Factory_createBorderedSolverStrategy(self, *args)

    def createEigensolverStrategy(self, *args):
        r""" Create eigensolver strategy"""
        return _Abstract.Factory_createEigensolverStrategy(self, *args)

    def createEigenvalueSortStrategy(self, *args):
        r""" Create eigenvalue sorting strategy"""
        return _Abstract.Factory_createEigenvalueSortStrategy(self, *args)

    def createSaveEigenDataStrategy(self, *args):
        r""" Create strategy to save eigenvector/value data"""
        return _Abstract.Factory_createSaveEigenDataStrategy(self, *args)

    def createAnasaziOperatorStrategy(self, *args):
        r""" Create Anasazi operator"""
        return _Abstract.Factory_createAnasaziOperatorStrategy(self, *args)

    def createMooreSpenceTurningPointSolverStrategy(self, *args):
        r""" Create Moore-Spence turning point solver strategy"""
        return _Abstract.Factory_createMooreSpenceTurningPointSolverStrategy(self, *args)

    def createMooreSpencePitchforkSolverStrategy(self, *args):
        r""" Create Moore-Spence pitchfork solver strategy"""
        return _Abstract.Factory_createMooreSpencePitchforkSolverStrategy(self, *args)

    def createMooreSpenceHopfSolverStrategy(self, *args):
        r""" Create Moore-Spence Hopf solver strategy"""
        return _Abstract.Factory_createMooreSpenceHopfSolverStrategy(self, *args)

# Register Factory in _Abstract:
_Abstract.Factory_swigregister(Factory)

