# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.AnasaziOperator is the python interface to namespace
AnasaziOperator of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.AnasaziOperator is to provide ***.  The python
version of LOCA.AnasaziOperator supports the following classes:

    * AbstractStrategy  - Abstract interface class for Anasazi operator
                          strategies
    * Factory           - Factory for creating Anasazi operator strategy
                          objects

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _AnasaziOperator
else:
    import _AnasaziOperator

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
class AbstractStrategy(object):
    r"""
     Abstract interface class for Anasazi operator strategies
    AbstractStrategy defines an abstract interface for anasazi operators.
    It is used by LOCA::Eigensolver::AnasaziStrategy to compute
    different kinds of eigenvalues of
    the steady-state solution after each continuation step.

    The interface currently defines several pure virtual methods,
    apply(), to apply the operator, transformEigenvalues() to transform
    the computed eigenvalues back to eigenvalues of untransformed state,
    rayleighQuotient to compute the rayleighQuotient for the operator, and
    label() to return the name of the operator.
    Derived classes should implement these method for a particular operator.
    Constructors for derived classes should be of the form:

    .. code-block:: c++

        class Derived : public AbstractStrategy {
        public:
          Derived(
          const Teuchos::RCP<LOCA::GlobalData>& global_data,
          const Teuchos::RCP<LOCA::Parameter::SublistParser>& topParams,
          const Teuchos::RCP<Teuchos::ParameterList>& eigenParams,
          const Teuchos::RCP<Teuchos::ParameterList>& solverParams,
          const Teuchos::RCP<NOX::Abstract::Group>& grp);
          ...
        };

    where ``global_data`` is the LOCA global data object, ``topParams`` is
    the parsed top-level parameter list, ``eigenParams``
    is a parameter list of eigensolver parameters, ``solverParams`` is a
    parameter list of linear solver parameters, and ``grp`` is the
    group representing the Jacobian and mass matrices.

    This class and its children follow the Strategy pattern as defined
    in Erich Gamma, et al. "Design Patterns:  Elements of Reusable
    Object-Oriented Software." Addison Wesley, Boston, MA, 1995.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == AbstractStrategy:
            _self = None
        else:
            _self = self
        _AnasaziOperator.AbstractStrategy_swiginit(self, _AnasaziOperator.new_AbstractStrategy(_self, *args))
    __swig_destroy__ = _AnasaziOperator.delete_AbstractStrategy

    def apply(self, *args):
        r"""Apply the operator to ``input`` with the result in ``output``"""
        return _AnasaziOperator.AbstractStrategy_apply(self, *args)

    def preProcessSeedVector(self, *args):
        r"""Give strategy an opportunit to massage the random seed vector"""
        return _AnasaziOperator.AbstractStrategy_preProcessSeedVector(self, *args)

    def beginPostProcessing(self, *args):
        r"""
        Hook to precompute info for subsequent repeated calls to
        tranformEigenvalue and rayleighQuotient
        """
        return _AnasaziOperator.AbstractStrategy_beginPostProcessing(self, *args)

    def transformEigenvalue(self, *args):
        r"""Transform eigenvalue in place"""
        return _AnasaziOperator.AbstractStrategy_transformEigenvalue(self, *args)

    def rayleighQuotient(self, *args):
        r"""Compute Rayleigh quotient"""
        return _AnasaziOperator.AbstractStrategy_rayleighQuotient(self, *args)

    def label(self, *args):
        return _AnasaziOperator.AbstractStrategy_label(self, *args)
    def __disown__(self):
        self.this.disown()
        _AnasaziOperator.disown_AbstractStrategy(self)
        return weakref.proxy(self)

# Register AbstractStrategy in _AnasaziOperator:
_AnasaziOperator.AbstractStrategy_swigregister(AbstractStrategy)
class Factory(object):
    r"""
     Factory for creating Anasazi operator strategy objects
    The parameters passed to the create() through the ``eigenParams``
    argument method should specify the
    "Operator" as described below, as well as any additional parameters
    for the particular strategy.

    *  "Operator" - Name of the Anasazi operator. Valid choices are

      *  "Jacobian Inverse" (LOCA::AnasaziOperator::JacobianInverse)
           [Default]
      *  "Shift-Invert" (LOCA::AnasaziOperator::ShiftInvert)
      *  "Cayley" (LOCA::AnasaziOperator::Cayley)



    There is also an %Epetra specific strategy that can
    be instantiated by the LOCA::Epetra::Factory.  See
    LOCA::Epetra::AnasaziOperator::Floquet.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _AnasaziOperator.Factory_swiginit(self, _AnasaziOperator.new_Factory(*args))
    __swig_destroy__ = _AnasaziOperator.delete_Factory

    def create(self, *args):
        r"""
         Create Anasazi operator strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type eigenParams: :py:class:`ParameterList`
        :param eigenParams: [in] %Eigensolver parameters as described above
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Linear solver parameters
        :type grp: Teuchos::RCP< NOX::Abstract::Group >
        :param grp: [in] Group representing Jacobian/mass matrices
        """
        return _AnasaziOperator.Factory_create(self, *args)

    def strategyName(self, *args):
        r""" Return strategy name given by ``eigenParams``"""
        return _AnasaziOperator.Factory_strategyName(self, *args)

# Register Factory in _AnasaziOperator:
_AnasaziOperator.Factory_swigregister(Factory)

