# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Extended is the python interface to namespace Extended
of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Extended is to provide classes that extend
NOX.Abstract classes to handle an arbitrary number of multi-vectors
and scalars.  The python version of LOCA.Extended supports the
following classes:

    * MultiVector         - Implemenatation of the NOX.Abstract.MultiVector
                            class for extended multi-vectors comprised of an
                            arbitrary number of multi-vectors and scalars
    * Vector              - Implemenatation of the NOX.Abstract.Vector class
                            for extended multi-vectors comprised of an
                            arbitrary number of multi-vectors and scalars
    * MultiAbstractGroup  - LOCA abstract interface for extended groups,
                            derived from the NOX.Abstract.Group, i.e., an
                            abstract interface for 'super' groups that have an
                            underlying group component

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Extended
else:
    import _Extended

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
class MultiVector(PyTrilinos.NOX.Abstract.MultiVector):
    r"""
    Implemenatation of the NOX::Abstract::MultiVector class for
    extended multi-vectors comprised of an arbitrary number of
    multi-vectors and scalars.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Copy constructor.

        |

        *Overload 2:*

        Copy constructor that creates a new multivector with
        *nColumns* columns.

        |

        *Overload 3:*

        Copy constructor that creates a sub copy or view of the
        given multivector
        """
        _Extended.MultiVector_swiginit(self, _Extended.new_MultiVector(*args))
    __swig_destroy__ = _Extended.delete_MultiVector

    def init(self, *args):
        r""" Initialize every element of this multi-vector with ``gamma``."""
        return _Extended.MultiVector_init(self, *args)

    def random(self, *args):
        r""" Initialize each element of this multi-vector with a random value"""
        return _Extended.MultiVector_random(self, *args)

    def setBlock(self, *args):
        return _Extended.MultiVector_setBlock(self, *args)

    def augment(self, *args):
        return _Extended.MultiVector_augment(self, *args)

    def scale(self, *args):
        r""" Scale each element of this multivector by ``gamma``."""
        return _Extended.MultiVector_scale(self, *args)

    def update(self, *args):
        return _Extended.MultiVector_update(self, *args)

    def clone(self, *args):
        r"""
        Create a new %MultiVector of the same underlying type by
        cloning "this", and return a pointer to the new vector.

        If type is NOX::DeepCopy, then we need to create an exact replica
        of "this". Otherwise, if type is NOX::ShapeCopy, we need only
        replicate the shape of "this". Note that there is
        **no assumption** that a vector created by ShapeCopy is
        initialized to zeros.

        :rtype: Teuchos::RCP< NOX::Abstract::MultiVector >
        :return: Pointer to newly created vector or NULL if clone is not
            supported.
        """
        return _Extended.MultiVector_clone(self, *args)

    def subCopy(self, *args):
        r"""
        Creates a new multi-vector with ``index.size()`` columns whose
        columns are copies of the columns of ``*this`` given by ``index``.
        """
        return _Extended.MultiVector_subCopy(self, *args)

    def subView(self, *args):
        r"""
        Creates a new multi-vector with ``index.size()`` columns that
        shares the columns of ``*this`` given by ``index``.
        """
        return _Extended.MultiVector_subView(self, *args)

    def norm(self, *args):
        r""" Norm."""
        return _Extended.MultiVector_norm(self, *args)

    def multiply(self, *args):
        return _Extended.MultiVector_multiply(self, *args)

    def length(self, *args):
        r""" Return the length of multi-vector."""
        return _Extended.MultiVector_length(self, *args)

    def numVectors(self, *args):
        r""" Return the number of vectors in the multi-vector."""
        return _Extended.MultiVector_numVectors(self, *args)

    def _print(self, *args):
        r""" Print the vector.  This is meant for debugging purposes only"""
        return _Extended.MultiVector__print(self, *args)

    def getMultiVector(self, *args):
        r"""
        *Overload 1:*
        Returns const ref-count pointer to the ith multi-vector

        |

        *Overload 2:*
        Returns ref-count pointer to the ith multi-vector
        """
        return _Extended.MultiVector_getMultiVector(self, *args)

    def getScalars(self, *args):
        r"""
        *Overload 1:*
        Returns const ref-count pointer to scalar matrix

        |

        *Overload 2:*
        Returns ref-count pointer to scalar matrix
        """
        return _Extended.MultiVector_getScalars(self, *args)

    def getScalarRows(self, *args):
        r"""
        *Overload 1:*

        Returns const ref-count pointer to ``num_rows`` rows of
        scalar matrix starting at row ``row``.

        |

        *Overload 2:*

        Returns ref-count pointer to ``num_rows`` rows of
        scalar matrix starting at row ``row``.
        """
        return _Extended.MultiVector_getScalarRows(self, *args)

    def getScalar(self, *args):
        r"""
        *Overload 1:*
        Returns const reference to the scalar for row i, column j

        |

        *Overload 2:*
        Returns reference to the scalar for row i, column j
        """
        return _Extended.MultiVector_getScalar(self, *args)

    def getVector(self, *args):
        r"""
        *Overload 1:*

        Return a ref-count pointer to the i-th column of the
        multivector as an abstract vector.

        |

        *Overload 2:*

        Return a const ref-count pointer to the i-th column of the
        multivector as an abstract vector.
        """
        return _Extended.MultiVector_getVector(self, *args)

    def getNumScalarRows(self, *args):
        r""" Returns number of scalars rows"""
        return _Extended.MultiVector_getNumScalarRows(self, *args)

    def getNumMultiVectors(self, *args):
        r""" Returns number of multi vectors"""
        return _Extended.MultiVector_getNumMultiVectors(self, *args)

# Register MultiVector in _Extended:
_Extended.MultiVector_swigregister(MultiVector)
class Vector(PyTrilinos.NOX.Abstract.Vector):
    r"""
    Implemenatation of the NOX::Abstract::Vector class for extended
    vectors comprised of an arbitrary number of vectors and scalars.

    Many continuation and bifurcation calculations can be viewed as the
    solution to an extended set of equations.  For example, calculating
    a turning point can be viewed as computing a solution to
    :math:`G(z) = 0` where :math:`z = [x, n, p]\in\Re^{2n+1}` and

    .. math::

        G(z) = \left[
              \begin{array}{c}
              F(x,p) \\
              Jn \\
              n^Tn-1
              \end{array}
              \right]
    The extended vector :math:`z` is comprised of the two vectors :math:`x` and
    :math:`n` as well as the scalar :math:`p`.  This class provides
    an implementation of the NOX::Abstract::Vector interface for such
    extended vectors.  It stores an array of pointers to
    NOX::Abstract::Vector's as well as an array of scalars using the
    STL vector class.

    The implementations of the NOX::Abstract::Vector methods are defined
    in terms of the implementations of each stored abstract vector.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Copy constructor."""
        _Extended.Vector_swiginit(self, _Extended.new_Vector(*args))
    __swig_destroy__ = _Extended.delete_Vector

    def clone(self, *args):
        r""" Clone function.  Applies clone to each stored vector"""
        return _Extended.Vector_clone(self, *args)

    def createMultiVector(self, *args):
        r"""
        *Overload 1:*

        Create a MultiVector with ``numVecs+1`` columns out of an array
        of Vectors.  The vector stored under ``this`` will be the first
        column with the remaining ``numVecs`` columns given by ``vecs``.

        |

        *Overload 2:*

        Create a MultiVector with ``numVecs`` columns.
        """
        return _Extended.Vector_createMultiVector(self, *args)

    def init(self, *args):
        r"""
        NOX::Abstract::Vector init function. Initializes each
        stored vector and scalar
        """
        return _Extended.Vector_init(self, *args)

    def random(self, *args):
        r""" Initialize every element of this vector with random values"""
        return _Extended.Vector_random(self, *args)

    def abs(self, *args):
        r"""
        NOX::Abstract::Vector abs function.  Compues absolute value
        of each stored vector and scalar
        """
        return _Extended.Vector_abs(self, *args)

    def reciprocal(self, *args):
        r"""
        NOX::Abstract::Vector reciprocal function.  Computes
        reciprocal of each stored vector and scalar
        """
        return _Extended.Vector_reciprocal(self, *args)

    def scale(self, *args):
        r"""
        *Overload 1:*

        NOX::Abstract::Vector scale function.  Scales each stored
        vector and scalar

        |

        *Overload 2:*

        NOX::Abstract::Vector scale function.  Scales each stored
        vector and scalar
        """
        return _Extended.Vector_scale(self, *args)

    def update(self, *args):
        r"""
        *Overload 1:*

        NOX::Abstract::Vector update function.  Applies vector
        update to each stored vector and scalar

        |

        *Overload 2:*

        NOX::Abstract::Vector update function.  Applies vector
        update to each stored vector and scalar
        """
        return _Extended.Vector_update(self, *args)

    def norm(self, *args):
        r"""
        *Overload 1:*

        NOX::Abstract::Vector norm function.  Computes norm of
        each stored vector and combines to compute appropriate norm

        |

        *Overload 2:*

        NOX::Abstract::Vector weighted norm function.  Computes
        weighted norm of each stored vector and combines to compute
        appropriate norm
        """
        return _Extended.Vector_norm(self, *args)

    def innerProduct(self, *args):
        r"""
        NOX::Abstract::Vector innerProduct function.
         Computes inner product * of each stored vector and combines to
         compute inner product
        """
        return _Extended.Vector_innerProduct(self, *args)

    def length(self, *args):
        r"""
        NOX::Abstract::Vector length function.  Computes sum of
        lengths of stored vectors plus number of scalars
        """
        return _Extended.Vector_length(self, *args)

    def _print(self, *args):
        r"""NOX::Abstract::Vector print function.  For debugging purposes"""
        return _Extended.Vector__print(self, *args)

    def setVector(self, *args):
        r""" Sets the ith vector"""
        return _Extended.Vector_setVector(self, *args)

    def setVectorView(self, *args):
        r""" Sets the ith vector as a view"""
        return _Extended.Vector_setVectorView(self, *args)

    def setScalar(self, *args):
        r""" Sets the ith scalar"""
        return _Extended.Vector_setScalar(self, *args)

    def setScalarArray(self, *args):
        r""" Sets the scalar array"""
        return _Extended.Vector_setScalarArray(self, *args)

    def getVector(self, *args):
        r"""
        *Overload 1:*
        Returns const ref-count pointer to the ith vector

        |

        *Overload 2:*
        Returns ref-count pointer to the ith vector
        """
        return _Extended.Vector_getVector(self, *args)

    def getScalar(self, *args):
        r""" Returns copy of the ith scalar"""
        return _Extended.Vector_getScalar(self, *args)

    def getScalars(self, *args):
        r"""
        *Overload 1:*
        Returns array of scalars

        |

        *Overload 2:*
        Returns array of scalars
        """
        return _Extended.Vector_getScalars(self, *args)

    def getNumScalars(self, *args):
        r""" Returns number of scalars"""
        return _Extended.Vector_getNumScalars(self, *args)

    def getNumVectors(self, *args):
        r""" Returns number of vectors"""
        return _Extended.Vector_getNumVectors(self, *args)

# Register Vector in _Extended:
_Extended.Vector_swigregister(Vector)
class MultiAbstractGroup(PyTrilinos.NOX.Abstract.Group):
    r"""
    %LOCA abstract interface for extended groups, derived from the
    NOX::Abstract::Group, i.e., an abstract interface for "super" groups
    that have an underlying group component.

    Concrete implemenations of this interface must provide implementations
    of all of the methods in the NOX::Abstract::Group interface as well as
    the additional interface defined here.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Extended.delete_MultiAbstractGroup

    def getUnderlyingGroup(self, *args):
        r"""
        *Overload 1:*
         Return underlying group
        This method should the underlying group data member.

        |

        *Overload 2:*
         Return underlying group
        This method should the underlying group data member.
        """
        return _Extended.MultiAbstractGroup_getUnderlyingGroup(self, *args)

    def getBaseLevelUnderlyingGroup(self, *args):
        r"""
        *Overload 1:*
         Return base-level underlying group
        This method is intended
        for composite groups (such as extended  %bifurcation groups) which
        have an underlying group as a data member.  This method is supposed
        to return the base level group and has a default recursive
        implementation that should work in most cases.

        |

        *Overload 2:*
         Return base-level underlying group
        This method is intended
        for composite groups (such as extended  %bifurcation groups) which
        have an underlying group as a data member.  This method is supposed
        to return the base level group and has a default recursive
        implementation that should work in most cases.
        """
        return _Extended.MultiAbstractGroup_getBaseLevelUnderlyingGroup(self, *args)

# Register MultiAbstractGroup in _Extended:
_Extended.MultiAbstractGroup_swigregister(MultiAbstractGroup)

