# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.SaveEigenData is the python interface to namespace
SaveEigenData of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.SaveEigenData is to provide the capability to save
eigenvectors and eigenvalues.  The python version of
LOCA.SaveEigenData supports the following classes:

    * Factory          - Factory for creating strategy objects to save
                         eigenvectors/values
    * AbstractStrategy - Abstract class for saving eigenvectors/values
    * DefaultStrategy  - Default class for saving eigenvectors/values

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _SaveEigenData
else:
    import _SaveEigenData

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
class Factory(object):
    r"""
     Factory for creating strategy objects to save eigenvectors/values
    The parameters passed to the create() through the ``eigenParams``
    argument method should specify the
    "Method" as described below, as well as any additional parameters
    for the particular strategy.

    *  "Save Eigen Data Method" - Name of the method. Valid choices are

      *  "Default" (LOCA::SaveEigenData::DefaultStrategy) [Default]
      *  "User-Defined" - User defined strategy


    User-defined strategies are defined by supplying the parameter
    "User-Defined Save Eigen Data Name" which is the std::string name of the
    strategy, and then a parameter with this name that is of the type
    Teuchos::RCP<LOCA::SaveEigenData::AbstractStrategy>.  This
    allows the user to supply a user-defined strategy without providing
    a factory to instantiate it.  By supplying the name of the parameter
    storing the strategy, the user can provide multiple strategies in the
    parameter list and select among them by setting
    "User-Defined Save Eigen Data Name" to be the name of the strategy.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _SaveEigenData.Factory_swiginit(self, _SaveEigenData.new_Factory(*args))
    __swig_destroy__ = _SaveEigenData.delete_Factory

    def create(self, *args):
        r"""
         Create strategy to save eigenvectors/values
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type eigenParams: :py:class:`ParameterList`
        :param eigenParams: [in] %Eigensolver parameters as described above
        """
        return _SaveEigenData.Factory_create(self, *args)

    def strategyName(self, *args):
        r""" Return strategy name given by ``eigenParams``"""
        return _SaveEigenData.Factory_strategyName(self, *args)

# Register Factory in _SaveEigenData:
_SaveEigenData.Factory_swigregister(Factory)
class AbstractStrategy(object):
    r"""
     Abstract interface class strategies to save eigenvector/value data
    AbstractStrategy defines an abstract interface for saving eigenvectors
    and eigenvalues that are computed at each continuation step.  This
    is important because this data is often useful for restarting
    continuations near bifurcation points and gives the user flexibility
    in how this data is stored.

    The interface currently defines one pure virtual method,
    save(), to save any eigenvectors or values as specified by the user.
    Derived classes should implement this method for a particular strategy
    to save this data, which is usually highly application code dependent.
    Constructors for derived classes should be of the form:

    .. code-block:: c++

        class Derived : public AbstractStrategy {
        public:
          Derived(
          const Teuchos::RCP<LOCA::GlobalData>& global_data,
          const Teuchos::RCP<LOCA::Parameter::SublistParser>& topParams,
             const Teuchos::RCP<Teuchos::ParameterList>& eigenParams);
          ...
        };

    where ``global_data`` is the LOCA global data object, ``topParams`` is
    the parsed top-level parameter list, and ``eigenParams``
    is a parameter list of eigensolver parameters.  This list should also
    specify which and how many eigenvectors/values to save as defined
    by the strategy.

    This class and its children follow the Strategy pattern as defined
    in Erich Gamma, et al. "Design Patterns:  Elements of Reusable
    Object-Oriented Software." Addison Wesley, Boston, MA, 1995.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _SaveEigenData.delete_AbstractStrategy

    def save(self, *args):
        r"""
         Save eigenvalues/eigenvectors
        :type evals_r: Teuchos::RCP< std::vector< double,std::allocator< double > > >
        :param evals_r: [out] Real eigenvalues
        :type evals_i: Teuchos::RCP< std::vector< double,std::allocator< double > > >
        :param evals_i: [out] Imaginary eigenvalues
        :type evecs_r: Teuchos::RCP< NOX::Abstract::MultiVector >
        :param evecs_r: [out] Real eigenvectors
        :type evecs_i: Teuchos::RCP< NOX::Abstract::MultiVector >
        :param evecs_i: [out] Imaginary eigenvectors
        :rtype: NOX::Abstract::Group::ReturnType
        :return: ReturnType code indicating success or failure
        """
        return _SaveEigenData.AbstractStrategy_save(self, *args)

# Register AbstractStrategy in _SaveEigenData:
_SaveEigenData.AbstractStrategy_swigregister(AbstractStrategy)
class DefaultStrategy(AbstractStrategy):
    r"""
     Default strategy for saving eigenvector/value data
    This class implements a default strategy for saving eigenvectors
    and eigenvalues that does nothing and exists so the LOCA::Stepper
    always has an object to pass eigen data to.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _SaveEigenData.DefaultStrategy_swiginit(self, _SaveEigenData.new_DefaultStrategy(*args))
    __swig_destroy__ = _SaveEigenData.delete_DefaultStrategy

    def save(self, *args):
        r"""
         Save eigenvalues/eigenvectors
        The implementation here does nothing and always returns
        NOX::Abstract::Group::Ok.
        """
        return _SaveEigenData.DefaultStrategy_save(self, *args)

# Register DefaultStrategy in _SaveEigenData:
_SaveEigenData.DefaultStrategy_swigregister(DefaultStrategy)

