# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.StatusTest is the python interface to namespace *** of
the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.StatusTest is to provide status checkers.  The
python version of LOCA.StatusTest supports the following classes:

    * Abstract  - Generic status test to check for convergence or failure of
                  the LOCA continuation
    * Wrapper   - A wrapper class for wrapping a NOX status test

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _StatusTest
else:
    import _StatusTest

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.StatusTest
Finished = _StatusTest.Finished
r""" The iterator is finished"""
Failed = _StatusTest.Failed
r""" The iterator has failed"""
NotFinished = _StatusTest.NotFinished
r""" The iterator is not finished"""
Unevaluated = _StatusTest.Unevaluated
r""" The iterator status has not been evaluated"""
Complete = _StatusTest.Complete
r""" Evaluate every test and subtest"""
Minimal = _StatusTest.Minimal
r""" Evaluate all tests and subtests that are necessary to determine the status"""
None_ = _StatusTest.None_
r""" Evaluation is entirely optional"""
class Abstract(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor."""
        if self.__class__ == Abstract:
            _self = None
        else:
            _self = self
        _StatusTest.Abstract_swiginit(self, _StatusTest.new_Abstract(_self, *args))
    __swig_destroy__ = _StatusTest.delete_Abstract

    def checkStatus(self, *args):
        r"""
        %Test the stopping criterion
           The test can (and should, if possible) be skipped if
           checkType is LOCA::StatusType::None.  If the test is skipped, then
           the status should be set to LOCA::StatusTest::Unevaluated.
        """
        return _StatusTest.Abstract_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call"""
        return _StatusTest.Abstract_getStatus(self, *args)
    def __disown__(self):
        self.this.disown()
        _StatusTest.disown_Abstract(self)
        return weakref.proxy(self)

# Register Abstract in _StatusTest:
_StatusTest.Abstract_swigregister(Abstract)

def __lshift__(*args):
    return _StatusTest.__lshift__(*args)
class Wrapper(PyTrilinos.NOX.StatusTest.Generic):
    r"""
    A %wrapper class for wrapping a %NOX status test.

    The %LOCA::StatusTest::Wrapper class provides a wrapper for %NOX
    status tests to change the solver passed to the wrapped status test.
    The solver passed through the checkStatus() method is wrapped via
    the LOCA::Solver::Wrapper class and then forwarded to the checkStatus()
    method of the wrapped status test.  The purpose of this is to allow
    status tests that use concrete group data to function correctly when
    the group is stored in an extended continuation or bifurcation group.
    (See LOCA::Solver::Wrapper for more details or the %LOCA status tests
    page for examples on how to effectively use this class.)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == Wrapper:
            _self = None
        else:
            _self = self
        _StatusTest.Wrapper_swiginit(self, _StatusTest.new_Wrapper(_self, *args))
    __swig_destroy__ = _StatusTest.delete_Wrapper

    def checkStatus(self, *args):
        r""" Calls checkStatus of underlying status test"""
        return _StatusTest.Wrapper_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Calls getStatus of underlying status test"""
        return _StatusTest.Wrapper_getStatus(self, *args)

    def getUnderlyingStatusTest(self, *args):
        r"""
        *Overload 1:*
        Returns underlying status test

        |

        *Overload 2:*
        Returns underlying status test
        """
        return _StatusTest.Wrapper_getUnderlyingStatusTest(self, *args)
    def __disown__(self):
        self.this.disown()
        _StatusTest.disown_Wrapper(self)
        return weakref.proxy(self)

# Register Wrapper in _StatusTest:
_StatusTest.Wrapper_swigregister(Wrapper)

