# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.StepSize is the python interface to namespace StepSize
of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.StepSize is to provide a collection of step size
control strategies.  The python version of LOCA.StepSize supports the
following classes:

    * Factory  - Factory for creating step size control strategy objects

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _StepSize
else:
    import _StepSize

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
from . import Parameter
class Factory(object):
    r"""
     Factory for creating step size control strategy objects
    The parameters passed to the create() through the ``stepsizeParams``
    argument method should specify the
    "Method" as described below, as well as any additional parameters
    for the particular strategy.

    *  "Method" - Name of the step size control method. Valid choices are

      *  "Constant" (LOCA::StepSize::Constant)
      *  "Adaptive" LOCA::StepSize::Adaptive) [Default]

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _StepSize.Factory_swiginit(self, _StepSize.new_Factory(*args))
    __swig_destroy__ = _StepSize.delete_Factory

    def create(self, *args):
        r"""
         Create step size control strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type stepsizeParams: :py:class:`ParameterList`
        :param stepsizeParams: [in] Step size parameters as described above
        """
        return _StepSize.Factory_create(self, *args)

    def strategyName(self, *args):
        r""" Return strategy name given by ``stepsizeParams``"""
        return _StepSize.Factory_strategyName(self, *args)

# Register Factory in _StepSize:
_StepSize.Factory_swigregister(Factory)

