# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.TurningPoint.MooreSpence is the python interface to
namespace TurningPoint::MooreSpence of the Trilinos continuation
algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.TurningPoint.MooreSpence is to provide groups and
vectors for locating turning point bifurcations using the Moore-
Spence formulation.  The python version of
LOCA.TurningPoint.MooreSpence supports the following classes:

    * AbstractGroup          - Interface to underlying groups for turning point
                               calculations using the Moore-Spence formulation
    * FiniteDifferenceGroup  - Concrete class that provides concrete
                               implementations of the derivative computation
                               methods of the LOCA.TurningPoint.MooreSpence.-
                               AbstractGroup using first-order finite
                               differencing
    * SolverFactory          - Factory for creating solver objects for solving
                               Moore-Spence turning point equations

"""

from sys import version_info as _swig_python_version_info

if not __package__:
    __package__ = 'PyTrilinos.LOCA.TurningPoint'
from . import _MooreSpence
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from   PyTrilinos.LOCA import MultiContinuation
import PyTrilinos.LOCA.Parameter


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base

import sys, os.path as op
parentDir = op.normpath(op.join(op.dirname(op.abspath(__file__)),".."))
if not parentDir in sys.path: sys.path.append(parentDir)
del sys, op

import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import PyTrilinos.LOCA.Parameter
class AbstractGroup(MultiContinuation.AbstractGroup):
    r"""
    Interface to underlying groups for turning point calculations
    using the Moore-Spence formulation.

    This abstract class provides the required interface for underlying
    groups to locate turning points using the bordering
    algorithm for the Moore-Spence turning point formulation (see
    LOCA::TurningPoint::MooreSpence::ExtendedGroup for a description of
    the governing equations).

    This class is derived from the LOCA::MultiContinuation::AbstractGroup
    and declares several pure virtual methods compute various
    derivatives of :math:`Jn` for a given :math:`n`.  Default implementations
    for the derivatives using finite differencing are implemented in the
    LOCA::TurningPoint::MooreSpence::FiniteDifferenceGroup.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_AbstractGroup

    def computeDJnDpMulti(self, *args):
        r"""Computes the derivative :math:`\partial Jn/\partial p`"""
        return _MooreSpence.AbstractGroup_computeDJnDpMulti(self, *args)

    def computeDJnDxaMulti(self, *args):
        r"""
        *Overload 1:*

        Computes the directional derivative
        :math:`\frac{\partial Jn}{\partial x} a` for the given direction
        :math:`a`.

        |

        *Overload 2:*

        Computes the directional derivative
        :math:`\frac{\partial Jn}{\partial x} a` for the given direction
        :math:`a`.
        """
        return _MooreSpence.AbstractGroup_computeDJnDxaMulti(self, *args)

    def computeDwtJnDxMulti(self, *args):
        r"""
        Computes the derivative
        :math:`\frac{\partial w^TJn}{\partial x}`.
        """
        return _MooreSpence.AbstractGroup_computeDwtJnDxMulti(self, *args)

# Register AbstractGroup in _MooreSpence:
_MooreSpence.AbstractGroup_swigregister(AbstractGroup)
class FiniteDifferenceGroup(AbstractGroup, MultiContinuation.FiniteDifferenceGroup):
    r"""
    Concrete class that provides concrete implementations of the
    derivative computation methods of the
    LOCA::TurningPoint::MooreSpence::AbstractGroup using first-order
    finite differencing.

    The finite-differencing calculations are actually implemented by
    the LOCA::DerivUtils class, and a custom DerivUtils object can be
    passed through the constructor of this class.  However, in the future
    the calculations encapsulated in the DerivUtils class may be
    incorporated directly into this class and other finite-differencing
    child classes.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_FiniteDifferenceGroup

    def computeDJnDpMulti(self, *args):
        r"""
        Computes the derivative :math:`\partial Jn/\partial p`

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDJnDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDJnDpMulti(self, *args)

    def computeDJnDxaMulti(self, *args):
        r"""
        *Overload 1:*

        Computes the directional derivative
        :math:`\frac{\partial Jn}{\partial x} a` for the given direction
        :math:`a`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDJnDxa() method of the passed
        LOCA::DerivUtils object.

        |

        *Overload 2:*

        Computes the directional derivative
        :math:`\frac{\partial Jn}{\partial x} a` for the given direction
        :math:`a`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDJnDxa() method of the passed
        LOCA::DerivUtils object.
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDJnDxaMulti(self, *args)

    def computeDwtJnDxMulti(self, *args):
        r"""
        Computes the derivative
        :math:`\frac{\partial w^TJn}{\partial x}`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtJnDx() method of the passed
        LOCA::DerivUtils object.
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDwtJnDxMulti(self, *args)

# Register FiniteDifferenceGroup in _MooreSpence:
_MooreSpence.FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)
class SolverFactory(object):
    r"""
    Factory for creating solver objects for solving Moore-Spence
    turning point equations

    The parameters passed to the create() through the ``solverParams``
    argument method should specify the "Solver Method"
    as described below, as well as any additional parameters
    for the particular strategy.

    *  "Solver Method" - Name of the method. Valid choices are

      *  "Salinger Bordering" (LOCA::TurningPoint::MooreSpence::SalingerBordering) [Default]
      *  "Phipps Bordering" (LOCA::TurningPoint::MooreSpence::PhippsBordering)

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _MooreSpence.SolverFactory_swiginit(self, _MooreSpence.new_SolverFactory(*args))
    __swig_destroy__ = _MooreSpence.delete_SolverFactory

    def create(self, *args):
        r"""
         Create solver strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Solver parameters as described above
        """
        return _MooreSpence.SolverFactory_create(self, *args)

    def strategyName(self, *args):
        r""" Return strategy name given by ``solverParams``"""
        return _MooreSpence.SolverFactory_strategyName(self, *args)

# Register SolverFactory in _MooreSpence:
_MooreSpence.SolverFactory_swigregister(SolverFactory)

