# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.ML is the python interface to the Trilinos multi-level
preconditioner package ML/MLAPI:

    https://trilinos.org/docs/dev/packages/ml/doc/html/index.html

The purpose of ML is to provide multilevel preconditioners to
Trilinos.

ML provides the following user-level classes:

    * BaseObject                - Base class for MLAPI objects
    * CompObject                - FLOP counting base class
    * TimeObject                - Timing base class
    * MultiLevelPreconditioner  - Black-box multilevel preconditioner
    * EpetraBaseOperator        - Base class for interface to Epetra
    * BaseOperator              - Base class for all MLAPI operators
    * Space                     - Defines number of elements and their distribution
    * MultiVector               - MLAPI multivector class
    * Operator                  - MLAPI operator class
    * InverseOperator           - MLAPI inverse operator class
    * PyMatrix                  - Python interface to MLAPI operators

For examples of usage, please consult the following scripts in the
example subdirectory of the PyTrilinos package:

    * exMLAPI.py
    * exMLAPI_Simple.py
    * exMLAPI_AztecOO.py
    * exMLAPI_Iterate.py
    * exMLAPI_PyMatrix.py
    * exMLAPI_Smoother.py

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _ML
else:
    import _ML

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

from . import Teuchos
from .Teuchos import Base
from . import Epetra
HAVE_INTTYPES_H = _ML.HAVE_INTTYPES_H
HAVE_STDINT_H = _ML.HAVE_STDINT_H

def GetML_Comm(*args):
    r""" Returns a pointer to the ML_Comm object defined on MPI_COMM_WORLD."""
    return _ML.GetML_Comm(*args)

def GetEpetra_Comm(*args):
    r""" Returns a reference to the Epetra_Comm object defined on MPI_COMM_WORLD."""
    return _ML.GetEpetra_Comm(*args)

def Barrier(*args):
    r""" Calls Mpi_Barrier() if MPI is enabled."""
    return _ML.Barrier(*args)

def GetMyPID(*args):
    r""" Returns the ID of the calling process."""
    return _ML.GetMyPID(*args)

def GetNumProcs(*args):
    r""" Returns the total number of processes in the computation."""
    return _ML.GetNumProcs(*args)

def GetPrintLevel(*args):
    r""" Retutns the level of output (always 0 if MyPID() != 0)."""
    return _ML.GetPrintLevel(*args)

def SetPrintLevel(*args):
    r""" Sets the level of output (from 0 to 10, 0 being verbose)."""
    return _ML.SetPrintLevel(*args)

def Init(*args):
    r""" Initialize the MLAPI workspace."""
    return _ML.Init(*args)

def Finalize(*args):
    r""" Destroys the MLAPI workspace."""
    return _ML.Finalize(*args)

def GetString(*args):
    return _ML.GetString(*args)

def GetMatrixType(*args):
    return _ML.GetMatrixType(*args)
class BaseObject(object):
    r"""
    Basic class for MLAPI objects

    BaseObject is the basic class for all MLAPI objects. Currently, it
    contains the label of the object and method Print().

    Author: Marzio Sala, SNL 9214

    Last updated on Feb-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _ML.delete_BaseObject

    def SetLabel(self, *args):
        r""" Sets the Label of this object to ``Label``."""
        return _ML.BaseObject_SetLabel(self, *args)

    def GetLabel(self, *args):
        r""" Returns the Label of this object."""
        return _ML.BaseObject_GetLabel(self, *args)

    def Print(self, *args):
        r"""
        Print(self, file=None)

        Print a description of the object to the given file object.  If no
        file object is provided, output is to stdout.
        """
        return _ML.BaseObject_Print(self, *args)

    def __str__(self, *args):
        r"""
        __str__(self) -> str

        Return the description of the object as a string.
        """
        return _ML.BaseObject___str__(self, *args)

# Register BaseObject in _ML:
_ML.BaseObject_swigregister(BaseObject)

def __lshift__(*args):
    return _ML.__lshift__(*args)
class Space(BaseObject):
    r"""
    Specifies the number and distribution among processes of elements.

    Author: Marzio Sala, SNL 9214

    Last updated on Feb-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Default constructor, defines an empty space.

        |

        *Overload 2:*
        Constructor with specified number of global and local elements.
           Constructs a space with linear distribution.

           :type NumGlobalElements: int
           :param NumGlobalElements: - (In) number of global elements.

           :type NumMyElements: int, optional
           :param NumMyElements: - (In) number of local elements. If different
                                      from -1, then eithere NumGlobalElements == -1,
                                      or the sum across of processors of NumMyElements
                                      equals NumGlobalElements

        |

        *Overload 3:*
        Constructor with specified Epetra_Map

        |

        *Overload 4:*
        Constructor for non-linear distributions
           :type NumGlobalElements: int
           :param NumGlobalElements: - (In) number of global elements. Set to
                                          -1 to compute it automatically.
           :type NumMyElements: int
           :param NumMyElements: - (In) number of local elements. Cannot be set
                                     to -1.
           :type MyGlobalElements: int
           :param MyGlobalElements: - (In) contains the global ID of each local node.

           Notes: Global ID always starts from 0.

        |

        *Overload 5:*
        Copy constructor.
        """
        _ML.Space_swiginit(self, _ML.new_Space(*args))
    __swig_destroy__ = _ML.delete_Space

    def Reshape(self, *args):
        r"""
        *Overload 1:*
        Resets ``this`` object.

        |

        *Overload 2:*
        Resets the dimension of the space by specifying the local number of elements.

        |

        *Overload 3:*
        Reset the dimension of the space by specifying the local number of elements and their global numbering (starting from 0).
        """
        return _ML.Space_Reshape(self, *args)

    def __eq__(self, *args):
        r""" Returns ``true`` if ``this`` Space is equivalent to ``RHS``."""
        return _ML.Space___eq__(self, *args)

    def __ne__(self, *args):
        r""" Returns ``true`` if ``this`` Space is not equivalent to ``RHS``."""
        return _ML.Space___ne__(self, *args)

    def __call__(self, *args):
        r""" Returns the global ID of local element ``i``."""
        return _ML.Space___call__(self, *args)

    def GetNumMyElements(self, *args):
        r""" Returns the local number of elements on the calling process."""
        return _ML.Space_GetNumMyElements(self, *args)

    def GetNumGlobalElements(self, *args):
        r""" Returns the global number of elements."""
        return _ML.Space_GetNumGlobalElements(self, *args)

    def GetOffset(self, *args):
        r""" Returns the global ID of the first element on the calling process (for linear distributions only)."""
        return _ML.Space_GetOffset(self, *args)

    def IsLinear(self, *args):
        r""" Returns ``true`` if the decomposition among processors is linear."""
        return _ML.Space_IsLinear(self, *args)

    def GetMyGlobalElements(self, *args):
        r"""
        GetMyGlobalElements(self) -> Epetra.SerialDenseVector

        Return an Epetra.SerialDenseVector of global indexes representing the
        elements on this processor.  If the Space is distributed linearly,
        this method returns None.
        """
        return _ML.Space_GetMyGlobalElements(self, *args)

# Register Space in _ML:
_ML.Space_swigregister(Space)

def Space_GetMyGlobalElements(*args):
    """
    GetMyGlobalElements(self) -> Epetra.SerialDenseVector

    Return an Epetra.SerialDenseVector of global indexes representing the
    elements on this processor.
    """
    result = _ML.Space_GetMyGlobalElements(*args)
    if result is None:
        offset = args[0].GetOffset()
        data   = range(offset, offset+args[0].GetNumMyElements())
        result = Epetra.IntSerialDenseVector(data)
    return result
Space.GetMyGlobalElements = Space_GetMyGlobalElements

class CompObject(object):
    r"""
    Class to count flops.

    Author: Marzio Sala, SNL 9214

    Last updated on Feb-05.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor, set counter to 0.0."""
        _ML.CompObject_swiginit(self, _ML.new_CompObject(*args))
    __swig_destroy__ = _ML.delete_CompObject

    def GetFlops(self, *args):
        r""" Returns the internal counter of flops."""
        return _ML.CompObject_GetFlops(self, *args)

    def SetFlops(self, *args):
        r""" Sets internal counter to ``Flops``."""
        return _ML.CompObject_SetFlops(self, *args)

    def UpdateFlops(self, *args):
        r""" Updates internal counter by summing ``Flops``."""
        return _ML.CompObject_UpdateFlops(self, *args)

# Register CompObject in _ML:
_ML.CompObject_swigregister(CompObject)
class TimeObject(object):
    r"""
    Class to track time spent in an object.

    Author: Marzio Sala, SNL 9214

    Last updated on Feb-05.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor, set counter to 0.0."""
        _ML.TimeObject_swiginit(self, _ML.new_TimeObject(*args))
    __swig_destroy__ = _ML.delete_TimeObject

    def ResetTimer(self, *args):
        r""" Resets the internal timer."""
        return _ML.TimeObject_ResetTimer(self, *args)

    def UpdateTime(self, *args):
        r"""
        *Overload 1:*
        Updates the internal timer with the time spent since the last call to ResetTimer().

        |

        *Overload 2:*
        Updates the internal timer with input value ``t``.
        """
        return _ML.TimeObject_UpdateTime(self, *args)

    def GetTime(self, *args):
        r""" Returns the internally stored counter."""
        return _ML.TimeObject_GetTime(self, *args)

# Register TimeObject in _ML:
_ML.TimeObject_swigregister(TimeObject)
class BaseOperator(BaseObject):
    r"""
    Base class for all MLAPI objects.

    Author: Marzio Sala, SNL 9214.

    Last modified on Feb-05.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _ML.delete_BaseOperator

    def Apply(self, *args):
        r""" Applies the operator to ``X``, using ``Y`` as starting solution. Returns the solution in ``Y``."""
        return _ML.BaseOperator_Apply(self, *args)

    def GetOperatorDomainSpace(self, *args):
        r""" Returns a copy of the domain space of ``this`` object."""
        return _ML.BaseOperator_GetOperatorDomainSpace(self, *args)

    def GetOperatorRangeSpace(self, *args):
        r""" Returns a copy of the range space of ``this`` object."""
        return _ML.BaseOperator_GetOperatorRangeSpace(self, *args)

    def __init__(self, *args):
        if self.__class__ == BaseOperator:
            _self = None
        else:
            _self = self
        _ML.BaseOperator_swiginit(self, _ML.new_BaseOperator(_self, *args))
    def __disown__(self):
        self.this.disown()
        _ML.disown_BaseOperator(self)
        return weakref.proxy(self)

# Register BaseOperator in _ML:
_ML.BaseOperator_swigregister(BaseOperator)
class DoubleVector(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _ML.DoubleVector_swiginit(self, _ML.new_DoubleVector(*args))
    __swig_destroy__ = _ML.delete_DoubleVector

    def Values(self, *args):
        return _ML.DoubleVector_Values(self, *args)

# Register DoubleVector in _ML:
_ML.DoubleVector_swigregister(DoubleVector)
class MultiVector(BaseObject, CompObject, TimeObject):
    r"""
    Basic class for distributed double-precision vectors.

    Author: Marzio Sala, SNL 9214.

    Last updated on Feb-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _ML.delete_MultiVector

    def Reshape(self, *args):
        r"""
        *Overload 1:*
        Resets ``this`` object.

        |

        *Overload 2:*
        Sets the space of this vector.
        """
        return _ML.MultiVector_Reshape(self, *args)

    def Append(self, *args):
        r"""
        *Overload 1:*
        Appends a new vector.

        |

        *Overload 2:*
        Appends a new vector.
        """
        return _ML.MultiVector_Append(self, *args)

    def Delete(self, *args):
        r""" Deletes the last vector."""
        return _ML.MultiVector_Delete(self, *args)

    def GetVectorSpace(self, *args):
        r"""
        *Overload 1:*
        Returns the Space on which ``this`` vector is defined.

        |

        *Overload 2:*
        Returns the Space on which ``this`` vector is defined (non-const)
        """
        return _ML.MultiVector_GetVectorSpace(self, *args)

    def GetNumVectors(self, *args):
        r""" Returns the number of vectors."""
        return _ML.MultiVector_GetNumVectors(self, *args)

    def GetMyLength(self, *args):
        r""" Returns the local length of each vector."""
        return _ML.MultiVector_GetMyLength(self, *args)

    def GetGlobalLength(self, *args):
        r""" Returns the global length of each vector."""
        return _ML.MultiVector_GetGlobalLength(self, *args)

    def GetValues(self, *args):
        r""" Returns a pointer to the double array (const version)"""
        return _ML.MultiVector_GetValues(self, *args)

    def Update(self, *args):
        r"""
        *Overload 1:*
        Sets this(v) = rhs

        |

        *Overload 2:*
        Sets this = rhs.

        |

        *Overload 3:*
        Sets this = alpha * rhs.

        |

        *Overload 4:*
        Sets this = alpha * x + beta * y.

        |

        *Overload 5:*
        Sets this = alpha * rhs + beta * this.
        """
        return _ML.MultiVector_Update(self, *args)

    def DotProduct(self, *args):
        r""" Computes the dot product between ``this`` vector and ``rhs``."""
        return _ML.MultiVector_DotProduct(self, *args)

    def Norm2(self, *args):
        r""" Computes the 2-norm of ``this`` vector."""
        return _ML.MultiVector_Norm2(self, *args)

    def NormInf(self, *args):
        r""" Computes the infinite norm of ``this`` vector."""
        return _ML.MultiVector_NormInf(self, *args)

    def NormOne(self, *args):
        r""" Computes the one norm of ``this`` vector."""
        return _ML.MultiVector_NormOne(self, *args)

    def Reciprocal(self, *args):
        r""" Replaces each element of the vector with its reciprocal."""
        return _ML.MultiVector_Reciprocal(self, *args)

    def Scale(self, *args):
        r""" Scales each element by the specified factor."""
        return _ML.MultiVector_Scale(self, *args)

    def Random(self, *args):
        r""" Populates the vector with random elements."""
        return _ML.MultiVector_Random(self, *args)

    def Sort(self, *args):
        r""" Sorts the component of the vector."""
        return _ML.MultiVector_Sort(self, *args)

    def IsAlias(self, *args):
        return _ML.MultiVector_IsAlias(self, *args)

    def __init__(self, *args):
        _ML.MultiVector_swiginit(self, _ML.new_MultiVector(*args))

    def __add__(self, *args):
        r"""
        __add__(self, MultiVector rhs) -> MultiVector

        Element-wise addition operator.
        """
        return _ML.MultiVector___add__(self, *args)

    def __sub__(self, *args):
        r"""
        __sub__(self, MultiVector rhs) -> MultiVector

        Element-wise subtraction operator.
        """
        return _ML.MultiVector___sub__(self, *args)

    def __mul__(self, *args):
        r"""
        __mul__(self, MultiVector rhs) -> float

          Dot-product multiplication operator.

        __mul__(self, rhs) -> MultiVector__mul__(self, int rhs) -> MultiVector

          Scalar multiplication operators.
        """
        return _ML.MultiVector___mul__(self, *args)

    def __rmul__(self, *args):
        r"""
        __rmul__(self, lhs) -> MultiVector__rmul__(self, int lhs) -> MultiVector

        Scalar 'reverse' multiplication operators.
        """
        return _ML.MultiVector___rmul__(self, *args)

    def __setitem__(self, *args):
        r"""
        __setitem__(self, PyObject index, int v, PyObject value)

        Argument index can be an integer or slice index into a vector.
        Argument v must be an integer specifying the desired vector within the
        MultiVector.  The value argument must have a shape that matches the
        shape of the index.
        """
        return _ML.MultiVector___setitem__(self, *args)

    def __getitem__(self, *args):
        r"""
        __getitem__(self, PyObject index, int v) -> PyObject

        Argument index can be an integer or slice index into a vector.
        Argument v must be an integer specifying the desired vector within the
        MultiVector.  The returned PyObject will be either a scalar or an
        array with the same shape as the index.
        """
        return _ML.MultiVector___getitem__(self, *args)

    def __call__(self, *args):
        r"""
        __call__(self, int i, int v=0) -> float

        Returns the i-th element of the v-th vector.
        """
        return _ML.MultiVector___call__(self, *args)

# Register MultiVector in _ML:
_ML.MultiVector_swigregister(MultiVector)

def Extract(*args):
    r""" Extracts a component from a vector."""
    return _ML.Extract(*args)

def Redistribute(*args):
    r""" Redistributes the entry of a vector as a multivector."""
    return _ML.Redistribute(*args)
class Operator(BaseOperator, CompObject, TimeObject):
    r"""
    Operator: basic class to define operators within MLAPI.

    Author: Marzio Sala, SNL 9214

    Last updated on Feb-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Default constructor.

        |

        *Overload 2:*
        Constructor with given already computed ML_Operator pointer.

        |

        *Overload 3:*
        Constructor with given already FillComplete()'d object.

        |

        *Overload 4:*
        Copy constructor.
        """
        _ML.Operator_swiginit(self, _ML.new_Operator(*args))
    __swig_destroy__ = _ML.delete_Operator

    def Reshape(self, *args):
        r"""
        *Overload 1:*
        Resets ``this`` object.

        |

        *Overload 2:*
        Reshape with given already computed ML_Operator pointer.

        |

        *Overload 3:*
        Reshape with given already FillComplete()'d object.
        """
        return _ML.Operator_Reshape(self, *args)

    def GetOperatorDomainSpace(self, *args):
        r""" Returns a reference to the internally stored domain space."""
        return _ML.Operator_GetOperatorDomainSpace(self, *args)

    def GetOperatorRangeSpace(self, *args):
        r""" Returns a reference to the internally stored range space."""
        return _ML.Operator_GetOperatorRangeSpace(self, *args)

    def GetDomainSpace(self, *args):
        r""" Returns a reference to the internally stored domain space."""
        return _ML.Operator_GetDomainSpace(self, *args)

    def GetRangeSpace(self, *args):
        r""" Returns a reference to the internally stored range space."""
        return _ML.Operator_GetRangeSpace(self, *args)

    def GetColumnSpace(self, *args):
        r""" Returns a reference to the internally stored column space."""
        return _ML.Operator_GetColumnSpace(self, *args)

    def GetNumGlobalRows(self, *args):
        r""" Returns the number of global rows."""
        return _ML.Operator_GetNumGlobalRows(self, *args)

    def GetNumMyRows(self, *args):
        r""" Returns the number of local rows."""
        return _ML.Operator_GetNumMyRows(self, *args)

    def GetNumGlobalCols(self, *args):
        r""" Returns the number of global columns."""
        return _ML.Operator_GetNumGlobalCols(self, *args)

    def GetNumMyCols(self, *args):
        r""" Returns the number of local columns."""
        return _ML.Operator_GetNumMyCols(self, *args)

    def GetNumGlobalNonzeros(self, *args):
        r""" Returns the global number of nonzeros."""
        return _ML.Operator_GetNumGlobalNonzeros(self, *args)

    def GetNumMyNonzeros(self, *args):
        r""" Returns the local number of nonzeros."""
        return _ML.Operator_GetNumMyNonzeros(self, *args)

    def GetRowMatrix(self, *args):
        r""" Returns the RefCountPtr of OperatorBox_."""
        return _ML.Operator_GetRowMatrix(self, *args)

    def GetML_Operator(self, *args):
        r""" Returns the RefCountPtr of OperatorBox_."""
        return _ML.Operator_GetML_Operator(self, *args)

    def GetRCPOperatorBox(self, *args):
        r""" Returns the RefCountPtr of OperatorBox_."""
        return _ML.Operator_GetRCPOperatorBox(self, *args)

    def GetRCPAuxOperatorBox(self, *args):
        r""" Returns the RefCountPtr of AuxOperatorBox_."""
        return _ML.Operator_GetRCPAuxOperatorBox(self, *args)

    def GetRCPRowMatrix(self, *args):
        r""" Returns the RefCountPtr of RowMatrix_"""
        return _ML.Operator_GetRCPRowMatrix(self, *args)

    def GetGRID(self, *args):
        r""" Returns the global ID of local row ID ``LRID``."""
        return _ML.Operator_GetGRID(self, *args)

    def GetGCID(self, *args):
        r""" Returns the global ID of local column ID ``LCID``."""
        return _ML.Operator_GetGCID(self, *args)

    def Apply(self, *args):
        r""" Applies ``this`` operator to LHS, returns the result in ``RHS``."""
        return _ML.Operator_Apply(self, *args)

    def BuildColumnSpace(self, *args):
        r""" Build the column space, by computing the GID of all local columns."""
        return _ML.Operator_BuildColumnSpace(self, *args)

    def __getitem__(self, *args):
        return _ML.Operator___getitem__(self, *args)

    def __add__(self, *args):
        return _ML.Operator___add__(self, *args)

    def __sub__(self, *args):
        return _ML.Operator___sub__(self, *args)

    def __mul__(self, *args):
        return _ML.Operator___mul__(self, *args)

    def __div__(self, *args):
        return _ML.Operator___div__(self, *args)

# Register Operator in _ML:
_ML.Operator_swigregister(Operator)
class PyMatrix(Operator):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor with given already computed ML_Operator pointer."""
        _ML.PyMatrix_swiginit(self, _ML.new_PyMatrix(*args))
    __swig_destroy__ = _ML.delete_PyMatrix

    def GetRowSpace(self, *args):
        return _ML.PyMatrix_GetRowSpace(self, *args)

    def SetElement(self, *args):
        return _ML.PyMatrix_SetElement(self, *args)

    def FillComplete(self, *args):
        return _ML.PyMatrix_FillComplete(self, *args)

    def GetMatrix(self, *args):
        return _ML.PyMatrix_GetMatrix(self, *args)

    def __setitem__(self, *args):
        return _ML.PyMatrix___setitem__(self, *args)

    def __getitem__(self, *args):
        return _ML.PyMatrix___getitem__(self, *args)

# Register PyMatrix in _ML:
_ML.PyMatrix_swigregister(PyMatrix)
ML_MEM_SIZE = _ML.ML_MEM_SIZE
ML_MEM_INITIAL = _ML.ML_MEM_INITIAL
ML_MEM_FINAL = _ML.ML_MEM_FINAL
ML_MEM_SMOOTHER = _ML.ML_MEM_SMOOTHER
ML_MEM_COARSE = _ML.ML_MEM_COARSE
ML_MEM_HIERARCHY = _ML.ML_MEM_HIERARCHY
ML_MEM_PREC_FIRST = _ML.ML_MEM_PREC_FIRST
ML_MEM_PREC_OTHER = _ML.ML_MEM_PREC_OTHER
ML_MEM_TOT1 = _ML.ML_MEM_TOT1
ML_MEM_TOT2 = _ML.ML_MEM_TOT2
ML_MEM_INITIAL_MALLOC = _ML.ML_MEM_INITIAL_MALLOC
ML_MEM_FINAL_MALLOC = _ML.ML_MEM_FINAL_MALLOC
ML_MEM_SMOOTHER_MALLOC = _ML.ML_MEM_SMOOTHER_MALLOC
ML_MEM_COARSE_MALLOC = _ML.ML_MEM_COARSE_MALLOC
ML_MEM_HIERARCHY_MALLOC = _ML.ML_MEM_HIERARCHY_MALLOC
ML_MEM_PREC_FIRST_MALLOC = _ML.ML_MEM_PREC_FIRST_MALLOC
ML_MEM_PREC_OTHER_MALLOC = _ML.ML_MEM_PREC_OTHER_MALLOC
ML_MEM_TOT1_MALLOC = _ML.ML_MEM_TOT1_MALLOC
ML_MEM_TOT2_MALLOC = _ML.ML_MEM_TOT2_MALLOC

def SetDefaults(*args):
    r"""
    Sets default parameters for aggregation-based preconditioners. This function, defined in the namespace ML_Epetra, can be used to set
       default values in a user's defined Teuchos::ParameterList.
       :type ProblemType: string
       :param ProblemType: (In) : a std::string, whose possible values are:
              - "SA" : classical smoothed aggregation preconditioners;
              - "NSSA" : default values for Petrov-Galerkin preconditioner for nonsymmetric systems
              - "maxwell" : default values for aggregation preconditioner for eddy current systems
              - "DD" : defaults for 2-level domain decomposition preconditioners based
              on aggregation;
              - "DD-LU" : Like "DD", but use exact LU decompositions on each subdomain;
              - "DD-ML" : 3-level domain decomposition preconditioners, with coarser
              spaces defined by aggregation;
             - "DD-ML-LU" : Like "DD-ML", but with LU decompositions on each subdomain.
       :type List: :py:class:`ParameterList`
       :param List: (Out) : list which will populated by the default parameters
       :type options: int, optional
       :param options: (In/Out) : integer array, of size ``AZ_OPTIONS_SIZE``, that will be
           populated with suitable values. A pointer to ``options`` will be stick into
           the parameters list. Note that this array is still required to apply the
           preconditioner! Do not delete options, nor let it go out of scope. The default value is
           0, meaning that ``SetDefaults()`` will allocate the array.
       :type params: float, optional
       :param params: (In/Out) : double array, of size ``AZ_PARAMS_SIZE``. See comments
           for ``options``.
       :type OverWrite: boolean, optional
       :param OverWrite: (In) : boolean.  If false, any pre-existing values in the
           parameter list will be preserved.  Default value is true, i.e., any
           pre-existing values may be overwritten.
    """
    return _ML.SetDefaults(*args)

def SetDefaultsDD(*args):
    r""" Sets default parameters for aggregation-based 2-level domain decomposition preconditioners."""
    return _ML.SetDefaultsDD(*args)

def SetDefaultsDD_LU(*args):
    r""" Sets default parameters for aggregation-based 2-level domain decomposition preconditioners, using LU on each subdomain"""
    return _ML.SetDefaultsDD_LU(*args)

def SetDefaultsDD_3Levels(*args):
    r""" Sets default parameters for aggregation-based 3-level domain decomposition preconditioners."""
    return _ML.SetDefaultsDD_3Levels(*args)

def SetDefaultsDD_3Levels_LU(*args):
    r""" Sets default parameters for aggregation-based 3-level domain decomposition preconditioners with LU."""
    return _ML.SetDefaultsDD_3Levels_LU(*args)

def SetDefaultsMaxwell(*args):
    r""" Sets default parameters for the eddy current equations equations."""
    return _ML.SetDefaultsMaxwell(*args)

def SetDefaultsSA(*args):
    r""" Sets default parameters for classical smoothed aggregation."""
    return _ML.SetDefaultsSA(*args)

def SetDefaultsNSSA(*args):
    r""" Sets defaults for energy minimization preconditioning for nonsymmetric problems."""
    return _ML.SetDefaultsNSSA(*args)

def SetDefaultsClassicalAMG(*args):
    r""" Sets defaults for classical amg"""
    return _ML.SetDefaultsClassicalAMG(*args)

def ReadXML(*args):
    r""" Reads in parameter list options from file."""
    return _ML.ReadXML(*args)
ML_SA_FAMILY = _ML.ML_SA_FAMILY
ML_MAXWELL = _ML.ML_MAXWELL
ML_COMPOSITE = _ML.ML_COMPOSITE
ML_CLASSICAL_FAMILY = _ML.ML_CLASSICAL_FAMILY
class MultiLevelPreconditioner(Epetra.Operator):
    r"""
    MultiLevelPreconditioner: a class to define black-box multilevel preconditioners using aggregation methods.

    Class ML_Epetra::MultiLevelPreconditioner defined black-box algebraic
    multilevel preconditioners of matrices defined as Epetra_RowMatrix derived
    objects. The resulting preconditioner can be used in AztecOO, and in any
    other solver that accepts Epetra_Operator derived objects, and apply the
    action of the given Epetra_Operator using ApplyInverse().

    Please refer to the user's guide for a detailed introduction to
    this class, examples, and description of input parameters.

     This file requires ML to be configured with the following options:
     - ``--enable-epetra``
     - ``--enable-teuchos``

     The following option is suggested:
     - ``--enable-amesos``
     - ``--enable-ifpack``

     Some part of this class needs the following options:
     - ``--enable-aztecoo``
     - ``--enable-anasazi``

     It is important to note that ML is more restrictive than Epetra for
     the definition of maps. It is required that RowMatrixRowMap() is equal
     to OperatorRangeMap(). This is because ML needs to perform matrix-std::vector
     product, as well as getrow() functions, on the same data distribution.

     Also, for square matrices, OperatorDomainMap() must be as
     OperatorRangeMap().

     Several examples are provided in the ``examples`` subdirectories:
     - 'ml_preconditioner_cpp' is an introductory
       example;
     - 'ml_2level_DD_cpp' shows how to
       define a 2-level domain decomposition preconditioner using
       this class;
     - 'ml_viz_cpp' details how to visualize the aggregates;
     - 'ml_maxwell_cpp' reports how to
       use this class for Maxwell problems.

    Notes: 
    Namespace ML_Epetra contains another Epetra_Operator derived class,
    ML_Epetra::MultiLevelOperator.
    - you should use MultiLevelOperator
      when your code already defines the required ML objects, with the optimal
      choice of parameters, and you just want to wrap the already defined ML
      preconditioners for AztecOO problems;
    - you should use MultiLevelPreconditioner
      when you have an Epetra_RowMatrix, and you don't want to code the
      conversion to ML_Operator, the creation of the hierarchy and the
      aggregates, and/or you want to experiment various combinations of the
      parameters, simply changing some parameters in a Teuchos::ParameterList.

    Defaults parameters can be specified using function SetDefaults().

     Author: Marzio Sala, SNL 9214
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructs a MultiLevelPreconditioner with default values.

        |

        *Overload 2:*
        Constructs a MultiLevelPreconditioner. Retrieves parameters from ``List``.

        |

        *Overload 3:*
        Constructs a MultiLevelPreconditioner from an ML_Operator. Retrieves parameters from ``List``.

        |

        *Overload 4:*
        Constructs a MultiLevelPreconditioner which is actually a composite AMG hierarchy using an array of ML_Operator's and an array of parameter lists.

        |

        *Overload 5:*
        MultiLevelPreconditioner constructor for Maxwell's equations. Takes the stiffness and mass terms of the matrix combined.

             :type EdgeMatrix: :py:class:`Epetra_RowMatrix`
             :param EdgeMatrix: - (In) Linear matrix to be solved.
             :type GradMatrix: :py:class:`Epetra_RowMatrix`
             :param GradMatrix: - (In) Node-to-edge connectivity matrix, a.k.a,
                                          topological gradient
             :type NodeMatrix: :py:class:`Epetra_RowMatrix`
             :param NodeMatrix: - (In) Auxiliary nodal finite element matrix
             :type List: :py:class:`ParameterList`
             :param List: - (In) Teuchos parameter list containing solver options.
             :type ComputePrec: boolean, optional
             :param ComputePrec: - (In) Optional argument that specifies whether to
                                           create preconditioner immediately.
                                           Default is true.
             :type UseNodeMatrixForSmoother: boolean, optional
             :param UseNodeMatrixForSmoother: - (In) Use the nodal matrix for the nodal
                                       portion of the Hipmair smoother (if used).

        |

        *Overload 6:*
        MultiLevelPreconditioner constructor for Maxwell's equations. Takes the stiffness and mass terms of the matrix separately.

             :type CurlCurlMatrix: :py:class:`Epetra_RowMatrix`
             :param CurlCurlMatrix: - (In) The curl-curl (stiffness) term of the
                                              matrix to be solved.
             :type MassMatrix: :py:class:`Epetra_RowMatrix`
             :param MassMatrix: - (In) The mass term of the matrix to be solved.
             :param GradMatrix: - (In) Node-to-edge connectivity matrix, a.k.a,
                                          topological gradient
             :type NodeMatrix: :py:class:`Epetra_RowMatrix`
             :param NodeMatrix: - (In) Auxiliary nodal finite element matrix
             :type List: :py:class:`ParameterList`
             :param List: - (In) Teuchos parameter list containing solver options.
             :type ComputePrec: boolean, optional
             :param ComputePrec: - (In) Optional argument that specifies whether to
                                           create preconditioner immediately.
                                           Default is true.

        |

        *Overload 7:*
        Constructs a MultiLevelPreconditioner for multiphysics with variable dofs per node

        |

        *Overload 8:*
        Constructor for scalar PDE problems based on applying AMG to the distance
        Laplacian operator when constructing grid transfers. The main unique
        feature is that there may be some dofs that correspond to the same node
        location. These shared dofs fall into two categories. If these dofs are
        strongly connected to each other (as determined by tol), they are
        explicitly elminated from the Laplacian (merged into a supernode). Once
        a P is obtained, this P is then expanded to account for shared nodes
        by simply duplicating the supernodes row of P for each of the individual
        vertices that contribute to the supernode. If share dofs are weakly
        connected (or not connected at all), nothing special is done (other than
        the ususal ignoring of weak connections). One last trick is employed,
        connections between supernodes and non-supernodes (i.e., regular nodes)
        are always assumed to be weak. Shared nodes are often used to capture
        interfaces or other features. By breaking these connections, the AMG
        can better maintain these features throughout the hierarchy. Finally, the
        constructor also allows for *  the removal of column nonzeros associated
        with Dirichlet points. To use this option the rhs and initial guess must be
        provided. Modification of the matrix, rhs, and initial guess must be
        allowable to use this option.

        |

        *Overload 9:*
        MultiLevelPreconditioner constructor for Maxwell's equations. Takes the stiffness and mass terms of the matrix combined.  The edge
             matrix is of type Epetra_Msr, a light-weight wrapper for old-style Aztec
             MSR matrices.  This is intended as transition code for Aztec users.

             :type EdgeMatrix: Epetra_MsrMatrix
             :param EdgeMatrix: - (In) Linear matrix to be solved.
             :type GradMatrix: ML_Operator
             :param GradMatrix: - (In) Node-to-edge connectivity matrix, a.k.a,
                                          topological gradient
             :type NodeMatrix: AZ_MATRIX
             :param NodeMatrix: - (In) Auxiliary nodal finite element matrix
             :type proc_config: int
             :param proc_config: - (In) Aztec array specifying processor layout.
             :type List: :py:class:`ParameterList`
             :param List: - (In) Teuchos parameter list containing solver options.
             :type ComputePrec: boolean, optional
             :param ComputePrec: - (In) Optional argument that specifies whether to
                                           create preconditioner immediately.
                                           Default is true.
        """
        _ML.MultiLevelPreconditioner_swiginit(self, _ML.new_MultiLevelPreconditioner(*args))
    __swig_destroy__ = _ML.delete_MultiLevelPreconditioner

    def Label(self, *args):
        r""" Prints label associated to this object."""
        return _ML.MultiLevelPreconditioner_Label(self, *args)

    def PrintUnused(self, *args):
        r"""
        *Overload 1:*
         Prints unused parameters in the input ParameterList on standard output.

        |

        *Overload 2:*
         Prints unused parameters in the input ParameterList on the specified stream.

        |

        *Overload 3:*
         Prints unused parameters in the input ParameterList to std::cout on proc ``MyPID``. Mispelled parameters are simply ignored. Therefore, it is often the best
        choice to print out the parameters that have not been used in the
        construction phase.
        - :type MyPID: int
        :param MyPID: (In) : ID of process that should print the unused parameters.
        """
        return _ML.MultiLevelPreconditioner_PrintUnused(self, *args)

    def GetList(self, *args):
        r""" Gets a reference to the internally stored parameters' list."""
        return _ML.MultiLevelPreconditioner_GetList(self, *args)

    def GetOutputList(self, *args):
        return _ML.MultiLevelPreconditioner_GetOutputList(self, *args)

    def PrintList(self, *args):
        r""" Prints on ``std::cout`` the values of the internally stored parameter list"""
        return _ML.MultiLevelPreconditioner_PrintList(self, *args)

    def SetParameterList(self, *args):
        r""" Copies ``List`` into the internally stored parameter list object."""
        return _ML.MultiLevelPreconditioner_SetParameterList(self, *args)

    def Apply(self, *args):
        r""" Apply the inverse of the preconditioner to an Epetra_MultiVector (NOT AVAILABLE)"""
        return _ML.MultiLevelPreconditioner_Apply(self, *args)

    def ApplyInverse(self, *args):
        r""" Apply the preconditioner to an Epetra_MultiVector X, puts the result in Y"""
        return _ML.MultiLevelPreconditioner_ApplyInverse(self, *args)

    def ComputePreconditioner(self, *args):
        r"""
        Computes the multilevel hierarchy. Computes the multilevel hierarchy. This function retrives the user's defines parameters (as
           specified in the input ParameterList), or takes default values otherwise, and creates the ML
           objects for aggregation and hierarchy. Allocated data can be freed used DestroyPreconditioner(),
           or by the destructor,

           In a Newton-type procedure, several linear systems have to be solved, Often, these systems
           are not too different. In this case, it might be convenient to keep the already
           computed preconditioner (with hierarchy, coarse solver, smoothers), and use it to
           precondition the next linear system. ML offers a way to determine whether the
           already available preconditioner is "good enough" for the next linear system.
           The user should proceed as follows:
           - define ``"reuse: enable"`` == ``true``
           - solve the first linear system. ML tries to estimate the rate of convergence, and record it;
           - change the values of the linear system matrix (but NOT its structure)
           - compute the new preconditioner as ``ComputePreconditioner(true)``
           It is supposed that the pointer to the Epetra_RowMatrix remains constant. Currently,
           it is not possible to modify this pointer (other than creating a new preconditioner)
        """
        return _ML.MultiLevelPreconditioner_ComputePreconditioner(self, *args)

    def ReComputePreconditioner(self, *args):
        r"""
        Recompute the preconditioner (not implemented for Maxwell).

           :type keepFineLevelSmoother: boolean, optional
           :param keepFineLevelSmoother: (In) : If true, the fine level
               smoother is not recomputed.  This is useful if the smoother is
               expensive to create, e.g., an incomplete factorization, and the
               fine level matrix has not changed.
        """
        return _ML.MultiLevelPreconditioner_ReComputePreconditioner(self, *args)

    def ComputeAdaptivePreconditioner(self, *args):
        return _ML.MultiLevelPreconditioner_ComputeAdaptivePreconditioner(self, *args)

    def IsPreconditionerComputed(self, *args):
        r""" Queries whether multilevel hierarchy has been computed or not."""
        return _ML.MultiLevelPreconditioner_IsPreconditionerComputed(self, *args)

    def SetOwnership(self, *args):
        r""" Sets ownership."""
        return _ML.MultiLevelPreconditioner_SetOwnership(self, *args)

    def SetUseTranspose(self, *args):
        r""" Sets use transpose (not implemented)."""
        return _ML.MultiLevelPreconditioner_SetUseTranspose(self, *args)

    def NormInf(self, *args):
        r""" Returns the infinity norm (not implemented)."""
        return _ML.MultiLevelPreconditioner_NormInf(self, *args)

    def UseTranspose(self, *args):
        r""" Returns the current UseTranspose setting."""
        return _ML.MultiLevelPreconditioner_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _ML.MultiLevelPreconditioner_HasNormInf(self, *args)

    def Comm(self, *args):
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _ML.MultiLevelPreconditioner_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _ML.MultiLevelPreconditioner_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _ML.MultiLevelPreconditioner_OperatorRangeMap(self, *args)

    def DestroyPreconditioner(self, *args):
        r""" Destroys all structures allocated in ``ComputePreconditioner()`` if the preconditioner has been computed."""
        return _ML.MultiLevelPreconditioner_DestroyPreconditioner(self, *args)

    def RowMatrix(self, *args):
        r""" Returns a reference to the internally stored RowMatrix."""
        return _ML.MultiLevelPreconditioner_RowMatrix(self, *args)

    def Map(self, *args):
        r""" Returns a reference to RowMatrix->Map()."""
        return _ML.MultiLevelPreconditioner_Map(self, *args)

    def NumGlobalRows(self, *args):
        r""" Returns the global number of rows in the matrix."""
        return _ML.MultiLevelPreconditioner_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        r""" Returns the global number of columns in the matrix."""
        return _ML.MultiLevelPreconditioner_NumGlobalCols(self, *args)

    def NumMyRows(self, *args):
        r""" Returns the local number of rows in the matrix."""
        return _ML.MultiLevelPreconditioner_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        r""" Returns the local number of columns in the matrix."""
        return _ML.MultiLevelPreconditioner_NumMyCols(self, *args)

    def PrintStencil2D(self, *args):
        r"""
         Prints the computational stencil for the specified row and equation (for 2D Cartesian grids only) For problems defined on 2D Cartesian grids (with node numbering increasing
        along the x-axis), this function prints out the stencil in an intelligible
        form.
        :type nx: int
        :param nx: (In) : number of nodes along the X-axis
        :type ny: int
        :param ny: (In) : number of nodes along the Y-axis
        :type NodeID: int, optional
        :param NodeID: (In) : (local) ID of node that will be used to print the
              stencil. If set to -1, the code will automatically chose an internal node.
              Default: -1.
        :type EquationID: int, optional
        :param EquationID: (In) : ID of the equation that will be used to print the
              stencil (default = 0)
        """
        return _ML.MultiLevelPreconditioner_PrintStencil2D(self, *args)

    def AnalyzeHierarchy(self, *args):
        r""" Cheap analysis of each level matrix."""
        return _ML.MultiLevelPreconditioner_AnalyzeHierarchy(self, *args)

    def AnalyzeSmoothers(self, *args):
        r""" Analyze the effect of each level's smoother on a random std::vector."""
        return _ML.MultiLevelPreconditioner_AnalyzeSmoothers(self, *args)

    def AnalyzeCoarse(self, *args):
        r""" Analyze the effect of the coarse solver on a random std::vector."""
        return _ML.MultiLevelPreconditioner_AnalyzeCoarse(self, *args)

    def AnalyzeCycle(self, *args):
        r""" Analyze the effect of the ML cycle on a random std::vector."""
        return _ML.MultiLevelPreconditioner_AnalyzeCycle(self, *args)

    def TestSmoothers(self, *args):
        r"""
        *Overload 1:*
        Test several smoothers on fine-level matrix.

        |

        *Overload 2:*
        Test several smoothers on fine-level matrix using the current parameters.
        """
        return _ML.MultiLevelPreconditioner_TestSmoothers(self, *args)

    def GetML(self, *args):
        r""" Returns a pointer to the internally stored ml pointer"""
        return _ML.MultiLevelPreconditioner_GetML(self, *args)

    def GetML_Aggregate(self, *args):
        r""" Returns a pointer to the internally stored agg pointer"""
        return _ML.MultiLevelPreconditioner_GetML_Aggregate(self, *args)

    def Visualize(self, *args):
        r""" Generic interface to visualization methods."""
        return _ML.MultiLevelPreconditioner_Visualize(self, *args)

    def VisualizeAggregates(self, *args):
        r""" Visualizes the shape of the aggregates."""
        return _ML.MultiLevelPreconditioner_VisualizeAggregates(self, *args)

    def VisualizeSmoothers(self, *args):
        r""" Visualizes the effect of smoothers on a random std::vector."""
        return _ML.MultiLevelPreconditioner_VisualizeSmoothers(self, *args)

    def VisualizeCycle(self, *args):
        r""" Visualizes the effect of the ML cycle on a random std::vector."""
        return _ML.MultiLevelPreconditioner_VisualizeCycle(self, *args)

    def CreateLabel(self, *args):
        r"""
        Creates label for this object (printed out by AztecOO).  This does not
             allocate/reallocate any memory.
        """
        return _ML.MultiLevelPreconditioner_CreateLabel(self, *args)

    def ReportTime(self, *args):
        return _ML.MultiLevelPreconditioner_ReportTime(self, *args)

    def Complexities(self, *args):
        r""" Return operator complexity and #nonzeros in fine grid matrix."""
        return _ML.MultiLevelPreconditioner_Complexities(self, *args)

    def SetParameterListAndNullSpace(self, *args):
        return _ML.MultiLevelPreconditioner_SetParameterListAndNullSpace(self, *args)

# Register MultiLevelPreconditioner in _ML:
_ML.MultiLevelPreconditioner_swigregister(MultiLevelPreconditioner)
useFree = _ML.useFree
useDelete = _ML.useDelete
neither = _ML.neither
epetraType = _ML.epetraType
mlType = _ML.mlType
mueluType = _ML.mueluType
class wrappedCommStruct(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    whichOne = property(_ML.wrappedCommStruct_whichOne_get, _ML.wrappedCommStruct_whichOne_set)
    data = property(_ML.wrappedCommStruct_data_get, _ML.wrappedCommStruct_data_set)
    nProcs = property(_ML.wrappedCommStruct_nProcs_get, _ML.wrappedCommStruct_nProcs_set)
    myPid = property(_ML.wrappedCommStruct_myPid_get, _ML.wrappedCommStruct_myPid_set)
    maxDofPerNode = property(_ML.wrappedCommStruct_maxDofPerNode_get, _ML.wrappedCommStruct_maxDofPerNode_set)
    vecSize = property(_ML.wrappedCommStruct_vecSize_get, _ML.wrappedCommStruct_vecSize_set)

    def __init__(self, *args):
        _ML.wrappedCommStruct_swiginit(self, _ML.new_wrappedCommStruct(*args))
    __swig_destroy__ = _ML.delete_wrappedCommStruct

# Register wrappedCommStruct in _ML:
_ML.wrappedCommStruct_swigregister(wrappedCommStruct)

def dofCommUsingMlNodalMatrix(*args):
    return _ML.dofCommUsingMlNodalMatrix(*args)

def MLsortCols(*args):
    return _ML.MLsortCols(*args)

def MLnMyGhost(*args):
    return _ML.MLnMyGhost(*args)

def MLfillNodalMaps(*args):
    return _ML.MLfillNodalMaps(*args)

def MLcolGlobalIds(*args):
    return _ML.MLcolGlobalIds(*args)

def MLassignGhostLocalNodeIds(*args):
    return _ML.MLassignGhostLocalNodeIds(*args)

def MLextractDiag(*args):
    return _ML.MLextractDiag(*args)

def MLfindDirichlets(*args):
    return _ML.MLfindDirichlets(*args)

def MLrmDirichletCols(*args):
    return _ML.MLrmDirichletCols(*args)

def MLsqueezeOutNnzs(*args):
    return _ML.MLsqueezeOutNnzs(*args)

def MLbuildMap(*args):
    return _ML.MLbuildMap(*args)

def MLvariableDofAmalg(*args):
    return _ML.MLvariableDofAmalg(*args)

def MLrmDifferentDofsCrossings(*args):
    return _ML.MLrmDifferentDofsCrossings(*args)

def MLbuildLaplacian(*args):
    return _ML.MLbuildLaplacian(*args)

def MLunamalgP(*args):
    return _ML.MLunamalgP(*args)

def MLfindEmptyRows(*args):
    return _ML.MLfindEmptyRows(*args)

def MLreplaceEmptyByDirichlet(*args):
    return _ML.MLreplaceEmptyByDirichlet(*args)

def MLfineStatus(*args):
    return _ML.MLfineStatus(*args)

def MLcoarseStatus(*args):
    return _ML.MLcoarseStatus(*args)

def MLShove(*args):
    return _ML.MLShove(*args)

def ZeroDist(*args):
    return _ML.ZeroDist(*args)

def MergeShared(*args):
    return _ML.MergeShared(*args)

def BuildNonSharedMap(*args):
    return _ML.BuildNonSharedMap(*args)

def buildCompressedA(*args):
    return _ML.buildCompressedA(*args)
class InverseOperator(BaseOperator, CompObject, TimeObject):
    r"""
    InverseOperator: basic class to define smoother and coarse solvers.


    Author: Marzio Sala, D-INFK/ETHZ.

    Last updated on Mar-06.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Empty constructor.

        |

        *Overload 2:*
        Constructor for a given Operator and type, and default parameters.

        |

        *Overload 3:*
        Constructor for a given Operator, type and parameters.

        |

        *Overload 4:*
        Copy constructor.
        """
        _ML.InverseOperator_swiginit(self, _ML.new_InverseOperator(*args))
    __swig_destroy__ = _ML.delete_InverseOperator

    def GetOperatorRangeSpace(self, *args):
        r""" Returns a reference to the range space of ``this`` object."""
        return _ML.InverseOperator_GetOperatorRangeSpace(self, *args)

    def GetOperatorDomainSpace(self, *args):
        r""" Returns a reference to the domain space of ``this`` object."""
        return _ML.InverseOperator_GetOperatorDomainSpace(self, *args)

    def GetRangeSpace(self, *args):
        r""" Returns a reference to the range space of ``this`` object."""
        return _ML.InverseOperator_GetRangeSpace(self, *args)

    def GetDomainSpace(self, *args):
        r""" Returns a reference to the domain space of ``this`` object."""
        return _ML.InverseOperator_GetDomainSpace(self, *args)

    def RCPRowMatrix(self, *args):
        r""" Returns pointer of the internally stored ML_Epetra::RowMatrix object."""
        return _ML.InverseOperator_RCPRowMatrix(self, *args)

    def RowMatrix(self, *args):
        r""" Returns pointer of the internally stored ML_Epetra::RowMatrix object."""
        return _ML.InverseOperator_RowMatrix(self, *args)

    def GetOperator(self, *args):
        r""" Returns a reference to the Operator of which ``this`` object defines the inverse."""
        return _ML.InverseOperator_GetOperator(self, *args)

    def GetRCPData(self, *args):
        r"""
        *Overload 1:*
        Returns a pointer to the internally stored IFPACK preconditioner.

        |

        *Overload 2:*
        Returns a pointer to the internally stored IFPACK preconditioner.
        """
        return _ML.InverseOperator_GetRCPData(self, *args)

    def GetRCPMLPrec(self, *args):
        r"""
        *Overload 1:*
        Returns a pointer to the internally stored IFPACK preconditioner.

        |

        *Overload 2:*
        Returns a pointer to the internally stored ML preconditioner.
        """
        return _ML.InverseOperator_GetRCPMLPrec(self, *args)

    def Apply(self, *args):
        r""" Applies ``this`` object to vector ``lhs``, returns values in ``rhs``."""
        return _ML.InverseOperator_Apply(self, *args)

    def __call__(self, *args):
        r"""
        *Overload 1:*
        Applies the operator to LHS, returns the results.

        |

        *Overload 2:*
        Applies the operator to LHS using RHS as initial solution, returns the results.
        """
        return _ML.InverseOperator___call__(self, *args)

    def __mul__(self, *args):
        return _ML.InverseOperator___mul__(self, *args)

    def Reshape(self, *args):
        return _ML.InverseOperator_Reshape(self, *args)

# Register InverseOperator in _ML:
_ML.InverseOperator_swigregister(InverseOperator)

def GetRAP(*args):
    r""" Performs a triple matrix-matrix product, res = R * A *P."""
    return _ML.GetRAP(*args)

def GetTranspose(*args):
    r""" Returns a newly created transpose of ``A``."""
    return _ML.GetTranspose(*args)

def GetIdentity(*args):
    r""" Returns the identity matrix."""
    return _ML.GetIdentity(*args)

def GetDiagonal(*args):
    r"""
    *Overload 1:*
    Returns a vector containing the diagonal elements of ``A``.

    |

    *Overload 2:*
    Returns a vector containing the diagonal elements of ``A``.

    |

    *Overload 3:*
    Returns a newly created operator, containing D on the diagonal.
    """
    return _ML.GetDiagonal(*args)

def GetJacobiIterationOperator(*args):
    r""" Returns an operator defined as (I - Damping A)."""
    return _ML.GetJacobiIterationOperator(*args)

def GetPtent1D(*args):
    r""" Returns a newly created operator, containing D on the diagonal."""
    return _ML.GetPtent1D(*args)

def ML_Operator_Add2(*args):
    return _ML.ML_Operator_Add2(*args)

def AnalyzeCheap(*args):
    r""" Performs a cheap analysis of the properties of the input operator."""
    return _ML.AnalyzeCheap(*args)

def PrintSparsity(*args):
    r""" Prints on file the sparsity structure of input operator."""
    return _ML.PrintSparsity(*args)

def GetScaledOperator(*args):
    r""" Multiply A by a double value, ``alpha``."""
    return _ML.GetScaledOperator(*args)

def Duplicate(*args):
    r"""
    *Overload 1:*
    Creates a new vector, x, such that x = y.

    |

    *Overload 2:*
    Creates a new vector, x, such that x = y(:,v)

    |

    *Overload 3:*
    Duplicates a given operator.
    """
    return _ML.Duplicate(*args)
class EpetraBaseOperator(Epetra.Operator):
    r"""
    Basic class to wrap MLAPI::InverseOperator into Epetra_Operator.

    Author: Marzio Sala, SNL 9214.

    Last updated on Feb-05.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor."""
        _ML.EpetraBaseOperator_swiginit(self, _ML.new_EpetraBaseOperator(*args))
    __swig_destroy__ = _ML.delete_EpetraBaseOperator

    def ApplyInverse(self, *args):
        r""" Applies the operator to ``X``, returns the results in ``Y``. Notes: Apply() and ApplyInverse() are the SAME function!"""
        return _ML.EpetraBaseOperator_ApplyInverse(self, *args)

    def SetUseTranspose(self, *args):
        r""" Sets the use of tranpose (NOT IMPLEMENTED)."""
        return _ML.EpetraBaseOperator_SetUseTranspose(self, *args)

    def Apply(self, *args):
        r""" Applies the operator to ``X``, returns the results in ``Y``."""
        return _ML.EpetraBaseOperator_Apply(self, *args)

    def NormInf(self, *args):
        r""" NOT IMPLEMENTED."""
        return _ML.EpetraBaseOperator_NormInf(self, *args)

    def Label(self, *args):
        r""" Returns the label of ``this`` object."""
        return _ML.EpetraBaseOperator_Label(self, *args)

    def UseTranspose(self, *args):
        r""" Returns ``false``."""
        return _ML.EpetraBaseOperator_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        r""" NOT IMPLEMENTED."""
        return _ML.EpetraBaseOperator_HasNormInf(self, *args)

    def Comm(self, *args):
        r""" Returns a reference to the communicator object."""
        return _ML.EpetraBaseOperator_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        r""" Returns a reference to the OperatorDomainMap."""
        return _ML.EpetraBaseOperator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        r""" Returns a reference to the OperatorRangeMap."""
        return _ML.EpetraBaseOperator_OperatorRangeMap(self, *args)

    def Map(self, *args):
        r""" Returns a reference to the Map of ``this`` object."""
        return _ML.EpetraBaseOperator_Map(self, *args)

    def GetBaseOperator(self, *args):
        return _ML.EpetraBaseOperator_GetBaseOperator(self, *args)

# Register EpetraBaseOperator in _ML:
_ML.EpetraBaseOperator_swigregister(EpetraBaseOperator)

def Krylov(*args):
    return _ML.Krylov(*args)

def __add__(*args):
    r"""
    *Overload 1:*
    Creates a new MultiVector, defined as x + y

    |

    *Overload 2:*
    Creates a new MultiVector, defined as x + alpha

    |

    *Overload 3:*
    Creates a new MultiVector, defined as alpha + x

    |

    *Overload 4:*
    Creates a new Operator, defined as A + B
    """
    return _ML.__add__(*args)

def __sub__(*args):
    r"""
    *Overload 1:*
    Creates a new MultiVector, defined as x - alpha

    |

    *Overload 2:*
    Creates a new MultiVector, defined as alpha - y

    |

    *Overload 3:*
    Creates a new Operator, defined as A - B
    """
    return _ML.__sub__(*args)

def __truediv__(*args):
    r"""
    *Overload 1:*
    Creates a new Operator, defined as A / alpha

    |

    *Overload 2:*
    Creates a new MultiVector y, such that y = x / alpha
    """
    return _ML.__truediv__(*args)

def __mul__(*args):
    r"""
    *Overload 1:*
    Creates a new Operator, defined as A * B

    |

    *Overload 2:*
    Creates a new Operator, defined as A * alpha

    |

    *Overload 3:*
    Creates a new Operator, defined as alpha * A

    |

    *Overload 4:*
    Creates a new MultiVector, defined as x * alpha

    |

    *Overload 5:*
    Computes the dot product between the first vector in x and y
    """
    return _ML.__mul__(*args)

def GetPtent(*args):
    r"""
    *Overload 1:*
     Builds the tentative prolongator using aggregation.

    |

    *Overload 2:*
     Builds the tentative prolongator with default null space.

    |

    *Overload 3:*

    Builds the tentative prolongator using aggregation.

    Build Ptent and NextNS as usual but as Epetra objects.

    :type A: :py:class:`Epetra_RowMatrix`
    :param A: (in): Matrix to be aggregated on
    :type List: :py:class:`ParameterList`
    :param List: (in): ParameterList containing ML options
    :type thisns: float
    :param thisns: (in): nullspace in format ML accepts
    :param Ptent(out):: Matrix containing tentative prolongator
    :type NextNS: Teuchos::RCP< Epetra_MultiVector >
    :param NextNS: (out): MultiVector containing next level nullspace.
    :type domainoffset: int, optional
    :param domainoffset: (in,optional): give an offset such that the domainmap
                                           of Ptent starts global numbering from domainoffset
                                           instead from zero. This is useful to
                                           create block matrices.

    Author: Michael Gee (gee@lnm.mw.tum.de)


    |

    *Overload 4:*

    Builds the tentative prolongator using aggregation.

    Build Ptent and NextNS as usual but as Epetra objects.

    :type A: :py:class:`Epetra_RowMatrix`
    :param A: (in): Matrix to be aggregated on
    :type List: :py:class:`ParameterList`
    :param List: (in): ParameterList containing ML options
    :type thisns: float
    :param thisns: (in): nullspace in format ML accepts
    :param Ptent(out):: Matrix containing tentative prolongator
    :type domainoffset: int, optional
    :param domainoffset: (in,optional): give an offset such that the domainmap
                                           of Ptent starts global numbering from domainoffset
                                           instead from zero. This is useful to
                                           create block matrices.

    Author: Michael Gee (gee@lnm.mw.tum.de)
    """
    return _ML.GetPtent(*args)

def GetAggregates(*args):
    r"""
    Call ML aggregation on A according to parameters supplied in List. Return
           aggregates in aggrinfo

           On input, map of aggrinfo has to map row map of A. On output, aggrinfo[i]
           contains number of aggregate the row belongs to, where aggregates are
           numbered starting from 0.
           Return value is the processor-local number of aggregates build.
           If aggrinfo[i] >= return-value, then i is a processor local row
           of a row that ML has detected to be on a Dirichlet BC.

    :type A: :py:class:`Epetra_RowMatrix`
    :param A: (in): Matrix to be aggregated on
    :type List: :py:class:`ParameterList`
    :param List: (in): ParameterList containing ML options
    :type thisns: float
    :param thisns: (in): nullspace
    :param aggrinfo(out):: vector containing aggregation information

    Notes: Map of aggrinfo has to match rowmap of A on input.

    :rtype: int
    :return: returns processor-local number of aggregates

    Author: Michael Gee (gee@lnm.mw.tum.de)
    """
    return _ML.GetAggregates(*args)

def GetGlobalAggregates(*args):
    r"""
    Call ML aggregation on A according to parameters supplied in List. Return
           aggregates in aggrinfo

           On input, map of aggrinfo has to map row map of A. On output, aggrinfo[i]
           contains number of global aggregate the row belongs to, where aggregates are
           numbered starting from 0 globally.
           Return value is the processor-local number of aggregates build.
           If aggrinfo[i] < 0, then i is a processor local row
           that ML has detected to be on a Dirichlet BC.
           if aggrinfo[i] >= 0, then i is a processor local row and aggrinfo[i] is
           a global aggregate id.

    :type A: :py:class:`Epetra_RowMatrix`
    :param A: (in): Matrix to be aggregated on
    :type List: :py:class:`ParameterList`
    :param List: (in): ParameterList containing ML options
    :type thisns: float
    :param thisns: (in): nullspace
    :param aggrinfo(out):: vector containing aggregation information in global numbering

    Notes: Map of aggrinfo has to match rowmap of A on input.

    :rtype: int
    :return: returns processor-local number of aggregates

    Author: Michael Gee (gee@lnm.mw.tum.de)
    """
    return _ML.GetGlobalAggregates(*args)

def MaxEigAnorm(*args):
    r""" Computes the maximum eigenvalue of ``Op`` using the A-norm of the operator."""
    return _ML.MaxEigAnorm(*args)

def MaxEigCG(*args):
    r""" Computes the maximum eigenvalue of ``Op`` using the CG method."""
    return _ML.MaxEigCG(*args)

def MaxEigPowerMethod(*args):
    r""" Computes the maximum eigenvalue of ``Op`` using the power method."""
    return _ML.MaxEigPowerMethod(*args)

def MaxEigAnasazi(*args):
    r""" Computes the maximum eigenvalue of ``Op`` using Anasazi"""
    return _ML.MaxEigAnasazi(*args)

def Eig(*args):
    r""" Computes eigenvalues and eigenvectors using LAPACK (w/ one process only)."""
    return _ML.Eig(*args)

def Eigs(*args):
    return _ML.Eigs(*args)

def Gallery(*args):
    r""" Creates a matrix using the TRIUTILS gallery."""
    return _ML.Gallery(*args)

def GetShiftedLaplacian1D(*args):
    r""" Creates a 1D shifted Laplacian."""
    return _ML.GetShiftedLaplacian1D(*args)

def GetShiftedLaplacian2D(*args):
    r""" Creates a 2D shifted Laplacian."""
    return _ML.GetShiftedLaplacian2D(*args)

def ReadMatrix(*args):
    r""" Reads a matrix in MATLAB format."""
    return _ML.ReadMatrix(*args)

def GetRecirc2D(*args):
    r""" Creates a recirculation problem in 2D."""
    return _ML.GetRecirc2D(*args)

def ReadParameterList(*args):
    r""" Populates a list from specified file."""
    return _ML.ReadParameterList(*args)

def GetPNonSmoothed(*args):
    return _ML.GetPNonSmoothed(*args)

def Iterate(*args):
    return _ML.Iterate(*args)

