# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.NOX.StatusTest is the python interface to the namespace
StatusTest in Trilinos package NOX:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of NOX.StatusTest is to provide clompletely flexible
specification of stopping tests for NOX algorithms.

NOX.StatusTest provides the following user-level classes:

    * Generic      - Base class for all stopping tests
    * Combo        - Allows combining of stopping tests with AND or OR
    * NormF        - Stopping test based on norm of F
    * NormUpdate   - Stopping test based on norm of update
    * NormWRMS     - Stopping test based on norm of weighted RMS of F
    * MaxIters     - Stopping test based on maximum iterations
    * Stagnation   - Stopping test based on algorithm stagnation
    * FiniteValue  - Stopping test based on detecting NaNs

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _StatusTest
else:
    import _StatusTest

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _StatusTest.delete_SwigPyIterator

    def value(self):
        return _StatusTest.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _StatusTest.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _StatusTest.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _StatusTest.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _StatusTest.SwigPyIterator_equal(self, x)

    def copy(self):
        return _StatusTest.SwigPyIterator_copy(self)

    def next(self):
        return _StatusTest.SwigPyIterator_next(self)

    def __next__(self):
        return _StatusTest.SwigPyIterator___next__(self)

    def previous(self):
        return _StatusTest.SwigPyIterator_previous(self)

    def advance(self, n):
        return _StatusTest.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _StatusTest.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _StatusTest.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _StatusTest.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _StatusTest.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _StatusTest.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _StatusTest.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _StatusTest:
_StatusTest.SwigPyIterator_swigregister(SwigPyIterator)
import PyTrilinos.Teuchos.Base
Unevaluated = _StatusTest.Unevaluated
r""" Unevaluated"""
Unconverged = _StatusTest.Unconverged
r""" Neither Converged nor Failed"""
Converged = _StatusTest.Converged
r""" Converged"""
Failed = _StatusTest.Failed
r""" Failed"""
Complete = _StatusTest.Complete
r""" Evaluate every test and subtest"""
Minimal = _StatusTest.Minimal
r""" Evaluate all tests and subtests that are necessary to determine the status"""
StatusTest_None = _StatusTest.StatusTest_None
r""" Evaluation is entirely optional"""
class Generic(object):
    r"""
    %Generic status test to check for convergence or failure of
    the nonlinear solver.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _StatusTest.delete_Generic

    def checkStatus(self, *args):
        r"""
        %Test the stopping criterion
           The test can (and should, if possible) be skipped if
           checkType is NOX::StatusType::None.  If the test is skipped, then
           the status should be set to NOX::StatusTest::Unevaluated.
        """
        return _StatusTest.Generic_checkStatus(self, *args)

    def getStatus(self, *args):
        r""" Return the result of the most recent checkStatus call"""
        return _StatusTest.Generic_getStatus(self, *args)

    def __str__(self, *args):
        return _StatusTest.Generic___str__(self, *args)

# Register Generic in _StatusTest:
_StatusTest.Generic_swigregister(Generic)

def __lshift__(*args):
    return _StatusTest.__lshift__(*args)
class Combo(Generic):
    r"""
      Arbitrary combination of status tests.

      In the ``AND`` (see NOX::StatusTest::Combo::ComboType) combination, the
      result is ``Unconverged`` (see NOX::StatusTest::StatusType) if *any* of
      the tests is ``Unconverged``. Otherwise, the result is equal to the
      result of the *first* test in the list that is either ``Converged``
      or ``Failed``. It is not recommended to mix ``Converged`` and
    ``Failed`` tests in an ``AND`` combination.

      In the ``OR`` combination, the result is ``Unconverged`` if *all* of
      the tests are ``Unconverged``. Otherwise, it is the result of the
    *first* test in the list that is either ``Converged`` or
    ``Failed``. Therefore, it will generally make sense to put the ``Failed``
      -type tests at the end of the ``OR`` list.

      Notes: We call checkStatus on *every* convergence test, though some
      may be called with the NOX::StatusTest::None option.

      Author: Tammy Kolda (SNL 8950) and Roger Pawlowski (SNL 1416)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    AND = _StatusTest.Combo_AND
    r""" Logically "AND" together the results of the tests in this combination"""
    OR = _StatusTest.Combo_OR
    r""" Logically "OR" together the results of the tests in this combination"""

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.  Optional argument is the error stream for output.

        |

        *Overload 2:*
        Constructor with a single test.

        |

        *Overload 3:*
        Constructor with two tests.
        """
        _StatusTest.Combo_swiginit(self, _StatusTest.new_Combo(*args))

    def addStatusTest(self, *args):
        r"""
        Add another test to this combination.
           Calls isSafe() to determine if it is safe to add ``a`` to the combination.
        """
        return _StatusTest.Combo_addStatusTest(self, *args)
    __swig_destroy__ = _StatusTest.delete_Combo

    def checkStatus(self, *args):
        r"""
        Tests stopping criterion.

        See addOp() and orOp() for details.
        """
        return _StatusTest.Combo_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.Combo_getStatus(self, *args)

# Register Combo in _StatusTest:
_StatusTest.Combo_swigregister(Combo)
class NormF(Generic):
    r"""
    Various convergence tests based on the norm of the residual.

     Use the constructor to define the test based on the type
     of scaling (see ScaleType) and the type of Tolerance (see
     Tolerance).

     If checkStatus is called with the type set to NOX::StatusTest::None,
     then the status is set to NOX::StatusTest::Unevaluated and returned.
     (Also #normF is set to 0.0.)

     If checkStatus is called on a problem where the solution group does
     not have F evaluated (i.e., problem.getSolutionGroup().isF() is
     false), then the status is set to NOX::StatusTest::Unconverged and
     returned.   (Also #normF is set to -1.0.)

     Finally, we return NOX::StatusTest::Converged if :math:`\alpha <  \beta`, and NOX::StatusTest::Unconverged otherwise.
     Here :math:`\alpha`
     represents the norm of :math:`F(x)` and :math:`\beta` represents the
     tolerance, as described below.

     Let :math:`\gamma` denote an optional scale factor defined as

     - :math:`\gamma = \frac{1}{n}` if ``sType`` in the constructor is NOX::NormF::Scaled, and


     Then :math:`\alpha` is defined as follows:

     - If ``nType`` in the constructor is Abstract::Vector::TWO, then

       .. math::

           \alpha = \sqrt{ \gamma \sum_{i=1}^n F_i^2 }

     - If ``nType`` in the constructor is Abstract::Vector::ONE, then

       .. math::

           \alpha = \gamma \sum_{i=1}^n | F_i |

     - If ``nType`` in the constructor is Abstract::Vector::INF, then

       .. math::

           \alpha = \gamma \max_{i} | F_i |

     We set :math:`\beta` as follows, based on the value of ``tolerance`` in
     the constructor.

     - If an initial guess is provided, we use a relative tolerance
     defined by.. math::

       \beta = \alpha_0 * \mbox{tolerance} Here
     :math:`\alpha_0` is the :math:`\alpha` (as defined above) associated with
     the initial guess.

     - Otherwise, we use an absolute tolerance defined by

     .. math::

         \beta  = \mbox{tolerance}

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    Unscaled = _StatusTest.NormF_Unscaled
    r""" No norm scaling"""
    Scaled = _StatusTest.NormF_Scaled
    r""" Scale the norm by the length of the vector"""
    Relative = _StatusTest.NormF_Relative
    r""" Relative to starting guess"""
    Absolute = _StatusTest.NormF_Absolute
    r""" Absolute"""

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor for absolute norm. This constructor defaults to the ``Absolute`` tolerance type.

        |

        *Overload 2:*
        Constructor for absolute norm This constructor defaults to the ``Absolute`` ToleranceType and ``TWO`` NormType.

        |

        *Overload 3:*
        Constructor with initial guess (for relative norms) This constructor defaults to the ``Relative`` tolerance type.

        |

        *Overload 4:*
        Constructor with initial guess (for relative norms) This constructor defaults to the ``Relative`` ToleranceType and ``TWO`` NormType.
        """
        _StatusTest.NormF_swiginit(self, _StatusTest.new_NormF(*args))
    __swig_destroy__ = _StatusTest.delete_NormF

    def checkStatus(self, *args):
        return _StatusTest.NormF_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.NormF_getStatus(self, *args)

    def reset(self, *args):
        r"""
        *Overload 1:*
        Resets the user specified absolute or relative tolerance.

        |

        *Overload 2:*
        Resets the user specified relative tolerance.
        """
        return _StatusTest.NormF_reset(self, *args)

    def getNormF(self, *args):
        r""" Returns the value of the F-norm computed in the last call to checkStatus."""
        return _StatusTest.NormF_getNormF(self, *args)

    def getTrueTolerance(self, *args):
        r""" Returns the true tolerance."""
        return _StatusTest.NormF_getTrueTolerance(self, *args)

    def getSpecifiedTolerance(self, *args):
        r""" Returns the specified tolerance set in the constructor."""
        return _StatusTest.NormF_getSpecifiedTolerance(self, *args)

    def getInitialTolerance(self, *args):
        r""" Returns the initial tolerance."""
        return _StatusTest.NormF_getInitialTolerance(self, *args)

# Register NormF in _StatusTest:
_StatusTest.NormF_swigregister(NormF)
class NormUpdate(Generic):
    r"""
    Various convergence tests based on the norm of the change in
    the solution vector, :math:`x`, between outer iterations.

    If checkStatusEfficiently is called with the type set to NOX::StatusTest::None,
    then the status is set to NOX::StatusTest::Unevaluated and returned.
    (Also #normUpdate is set to -1.0.)

    If checkStatusEfficiently is called on the first iteration, then the status is
    set to NOX::StatusTest::Unconverged and returned.  (Also #normUpdate is
    set to -1.0.)

    If checkStatusEfficiently is called on a problem where the solution group does
    not have F evaluated (i.e., problem.getSolutionGroup().isF() is
    false), then the status is set to NOX::StatusTest::Unconverged and
    returned.   (Also #normUpdate is set to -1.0.)


    Finally, we return NOX::StatusTest::Converged if :math:`\alpha <  \beta` and NOX::StatusTest::Uncoverged otherwise.
    Here
    :math:`\alpha` represents the norm of :math:`\Delta x` and :math:`\beta`
    represents the tolerance.  We define:

    .. math::

        \Delta x = x_k - x_{k-1}

    where :math:`x_k` is the solution vector of the :math:`k`-th nonlinear iterate.

    Let :math:`\gamma` denote an optional scale factor defined as

    - :math:`\gamma = \frac{1}{n}` if ``sType`` in the constructor is NOX::NormF::Scaled, and

    - :math:`\gamma = 1` if ``sType`` in the constructor is NOX::NormF::Unscaled.

    Then :math:`\alpha` is defined as follows:

    - If ``nType`` in the constructor is Abstract::Vector::TWO, then

      .. math::

          \alpha = \sqrt{ \gamma \sum_{i=1}^n \Delta x_i^2 }

    - If ``nType`` in the constructor is Abstract::Vector::ONE, then

      .. math::

          \alpha = \gamma \sum_{i=1}^n | \Delta x_i |

    - If ``nType`` in the constructor is Abstract::Vector::INF, then

      .. math::

          \alpha = \gamma \max_{i} | \Delta x_i |

    Finally, :math:`\beta` is set to the ``tolerance`` in the constructor, i.e.,

    .. math::

        \beta  = \mbox{tolerance}
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    Unscaled = _StatusTest.NormUpdate_Unscaled
    r""" No norm scaling"""
    Scaled = _StatusTest.NormUpdate_Scaled
    r""" Scale the norm by the length of the vector"""

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor for absolute norm. This constructor defaults to the ``Absolute`` tolerance type.

        |

        *Overload 2:*
        Constructor for absolute norm This constructor defaults to the ``Absolute`` ToleranceType and ``TWO`` NormType.
        """
        _StatusTest.NormUpdate_swiginit(self, _StatusTest.new_NormUpdate(*args))
    __swig_destroy__ = _StatusTest.delete_NormUpdate

    def checkStatus(self, *args):
        return _StatusTest.NormUpdate_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.NormUpdate_getStatus(self, *args)

    def getNormUpdate(self, *args):
        r""" Returns the value of the Update-norm computed in the last call to checkStatus."""
        return _StatusTest.NormUpdate_getNormUpdate(self, *args)

    def getTolerance(self, *args):
        r""" Returns the true tolerance."""
        return _StatusTest.NormUpdate_getTolerance(self, *args)

# Register NormUpdate in _StatusTest:
_StatusTest.NormUpdate_swigregister(NormUpdate)
class NormWRMS(Generic):
    r"""
     Convergence test based on the weighted root mean square norm fo the solution update between iterations.

    ` If the number of iterations is zero, then the status is set to
      NOX::StatusTest::Unconverged and returned. (Also, #value is set to
      1.0e+12.)

      Otherwise, returns NOX::StatusTest::Converged if the three criteria
      listed below are satisfied. Note that use of Criteria #2 and #3
      depend on the options set in the solver.


      *  Weigthed root mean square norm is less than a specified tolerance:

      .. math::

          ||\delta x^k||_{wrms} < \mbox{tolerance}

      where

     .. math::

         ||\delta x^k||_{wrms} \equiv C \sqrt{ \frac{1}{N} \sum_{i=1}^N \left( \frac
             {(x^k_i-x^{k-1}_i)}{RTOL |x^{k-1}_i| + ATOL_i} \right) ^2 }

      Here:

      - :math:`x_i^k` denotes component :math:`i` of nonlinear iterate :math:`k`.
      - :math:`N` denotes the number of unknowns
      - :math:`RTOL` denotes the relative error tolerance, specified via
    ``rtol`` in the constructor
      - :math:`ATOL` denotes the absolution error tolerance, specified via
        ``atol`` in the constructor. This can be a vector or a scalar.
      - :math:`C` denotes a weight, specified via the parameter
    ``BDFMultiplier`` in the constructor.

      *  **If a line search based solver is used**, the line search
      step size, :math:`\lambda`, must be greater than a specified step
      size value, :math:`\alpha`:

      .. math::

          \lambda > \alpha

      The motivation for this test is to avoid detecting stagnation
      when in fact the true problem is that the step size is just small.

      The value of :math:`\alpha` is set in the constructor via the argument
      ``alpha``. Setting :math:`\alpha` to zero effectively eliminates this
      part of the test.

      *  The achieved linear solver tolerance, :math:`\eta^k` for
      nonlinear iteration :math:`k`, must be less than a specified
      tolerance value, :math:`\beta`; i.e.,

      .. math::

          \eta^k < \beta

      The motivation for this test is to avoid detecting stagnation when
      in fact the true problem is that the linear solve tolerance was not
      accurate enough.

      The value of :math:`\beta` is set in the constructor via the argument
      ``beta``. Setting :math:`\beta` to 1.0 effectively eliminates this
      part of the test.

      Notes: This criteria will only be used if the "Achieved Tolerance"
      parameter (the value of :math:`\eta^k`) is set by the linear solver
      in the "Newton"/"Linear Solver"/"Output" sublist.  The
      checkStatus() method will search for this parameter.



      References:



      *  K. E. Brennam, S. L. Cambell, L. R. Petzold, **Numerical
      Solution of Initial-Value Problems in Differential-Algebraic
      Equations**, Classics in Applied Mathematics 14, SIAM 1996.

      *  G. D. Byrne and A. C. Hindmarch, **PVODE, an ODE %Solver for
      Parallel Computers**, Technical Report UCRL-JC-132361, Rev. 1,
      Center for Applied Scientific Computing (CASC), Lawrence Livermore
      National Lab, May 1999.



    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor where ATOL is a scalar

        |

        *Overload 2:*
        Constructor where ATOL is a vector
        """
        _StatusTest.NormWRMS_swiginit(self, _StatusTest.new_NormWRMS(*args))
    __swig_destroy__ = _StatusTest.delete_NormWRMS

    def checkStatus(self, *args):
        return _StatusTest.NormWRMS_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.NormWRMS_getStatus(self, *args)

    def getNormWRMS(self, *args):
        r""" Returns the value of WRMS norm."""
        return _StatusTest.NormWRMS_getNormWRMS(self, *args)

    def getTolerance(self, *args):
        r""" Returns the requested tolerance set in the constructor."""
        return _StatusTest.NormWRMS_getTolerance(self, *args)

    def getRTOL(self, *args):
        r""" Returns the realative tolerance set in the constructor."""
        return _StatusTest.NormWRMS_getRTOL(self, *args)

    def getATOL(self, *args):
        r""" Returns the absolute tolerance set in the constructor.  If ATOL is a vector, this will return a value of -1.0."""
        return _StatusTest.NormWRMS_getATOL(self, *args)

    def getBDFMultiplier(self, *args):
        r""" Returns the value of the BDFMultiplier set in the constructor."""
        return _StatusTest.NormWRMS_getBDFMultiplier(self, *args)

    def getAlpha(self, *args):
        r""" Returns the value of 'alpha' set in the constructor."""
        return _StatusTest.NormWRMS_getAlpha(self, *args)

    def getBeta(self, *args):
        r""" Returns the value of 'beta' set in the constructor."""
        return _StatusTest.NormWRMS_getBeta(self, *args)

    def getDisableImplicitWeighting(self, *args):
        r""" Returns true if implicit weighting is disabled during norm computation"""
        return _StatusTest.NormWRMS_getDisableImplicitWeighting(self, *args)

# Register NormWRMS in _StatusTest:
_StatusTest.NormWRMS_swigregister(NormWRMS)
class MaxIters(Generic):
    r"""
    Failure test based on the maximum number of nonlinear solver iterations.
     Let :math:`k` denote the current number of iterations (accessed via
     NOX::Solver::getNumIterations) and :math:`k_{\max}` denote the
     tolerance set in the constructor of this status test.
     This test returns NOX::StatusTest::Failed if
     :math:`k \geq k_{\rm max}.`
     Otherwise, it returns NOX::StatusTest::Unconverged.

     Notes: If checkStatus is called with the type set to
     NOX::StatusTest::None, it then the status is set to to
     NOX::Status::Unevaluated and returned. (Also #niters is set to -1.)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor. Specify the maximum number of nonlinear solver iterations, :math:`k_{\max}` ands optinally an error stream for printing errors."""
        _StatusTest.MaxIters_swiginit(self, _StatusTest.new_MaxIters(*args))
    __swig_destroy__ = _StatusTest.delete_MaxIters

    def checkStatus(self, *args):
        return _StatusTest.MaxIters_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.MaxIters_getStatus(self, *args)

    def getMaxIters(self, *args):
        r""" Returns the Maximum number of iterations set in the constructor."""
        return _StatusTest.MaxIters_getMaxIters(self, *args)

    def getNumIters(self, *args):
        r"""
        Returns the current number of iterations taken by the solver.

        Returns -1 if the status of this test is NOX::StatusTest::Unevaluated.
        """
        return _StatusTest.MaxIters_getNumIters(self, *args)

# Register MaxIters in _StatusTest:
_StatusTest.MaxIters_swigregister(MaxIters)
class Stagnation(Generic):
    r"""
    Failure test based on the convergence rate between nonlinear iterations.

     This status test returns NOX::StatusTest::Failed if we fail to
     reduce the norm of :math:`F` by a specified tolerance for n
     *consecutive* iterations.
     In other words, if

     .. math::

         \frac{\| F_k \|}{\| F_{k-1} \|} \geq {\rm tolerance}

     for n *consecutive* iterations, the status is set to
     NOX::StatusTest::Failed and returned. Otherwise, the status is set
     to NOX::StatusTest::Uncoverged and returned.  Both n and the
     tolerance are specified in the constructor, by ``n`` and ``tol``,
     respectively.

     Based on experience the following values are recommended:


     *  For Newton solves:  n = 50, tolerance = 1.0

     *  For Newton solves with a line search: n = 15, tolerance = 0.99

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor.
           :type n: int, optional
           :param n: - Number of consecutive nonlinear iterations
           :type tol: float, optional
           :param tol: - Tolerance for stagnation test
        """
        _StatusTest.Stagnation_swiginit(self, _StatusTest.new_Stagnation(*args))
    __swig_destroy__ = _StatusTest.delete_Stagnation

    def checkStatus(self, *args):
        r"""
        Tests the stopping criterion.

        Notes: 
        The nature of this test is such that it *must* be executed at
        every nonlinear iteration, so we don't use the checkType argument.
        """
        return _StatusTest.Stagnation_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.Stagnation_getStatus(self, *args)

    def getMaxNumSteps(self, *args):
        r"""
        Returns the used specified number of steps that can
        consecutively fail the tolerance test before the test returns a
        failed status.
        """
        return _StatusTest.Stagnation_getMaxNumSteps(self, *args)

    def getCurrentNumSteps(self, *args):
        r""" Returns the current number of steps that have consecutively failed the tolerance test."""
        return _StatusTest.Stagnation_getCurrentNumSteps(self, *args)

    def getTolerance(self, *args):
        r""" Returns the user specified tolerance."""
        return _StatusTest.Stagnation_getTolerance(self, *args)

    def getConvRate(self, *args):
        r""" Returns the current convergence rate."""
        return _StatusTest.Stagnation_getConvRate(self, *args)

# Register Stagnation in _StatusTest:
_StatusTest.Stagnation_swigregister(Stagnation)
class FiniteValue(Generic):
    r"""
    Failure test based on whether the norm of a vector has a finite value.

     This test returns NOX::StatusTest::Failed if the norm of a vector is
     calssified as a NaN or Inf.  Otherwise, it returns
     NOX::StatusTest::Unconverged.  The user can specify whether to use
     the F vector or the solution vector from the current solution group
     for the check.  NOX does not have access to vector entries so the
     number used in the NaN/Inf check is based on the norm of a vector.

     Notes: If checkStatus is called with the type set to
     NOX::StatusTest::None, then the status is set to
     NOX::Status::Unevaluated and returned.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    FVector = _StatusTest.FiniteValue_FVector
    SolutionVector = _StatusTest.FiniteValue_SolutionVector

    def __init__(self, *args):
        r""" Constructor. Specify which vector to check and with what norm to use."""
        _StatusTest.FiniteValue_swiginit(self, _StatusTest.new_FiniteValue(*args))
    __swig_destroy__ = _StatusTest.delete_FiniteValue

    def checkStatus(self, *args):
        return _StatusTest.FiniteValue_checkStatus(self, *args)

    def getStatus(self, *args):
        return _StatusTest.FiniteValue_getStatus(self, *args)

    def finiteNumberTest(self, *args):
        r"""
        The finite number test algorithm.

           Autoconf will test to see if the compiler implements the isnan()
           and isinf() functions in the cmath or math.h headers.  If so, we
           will use these.  If not, we supply a default implementation. The
           default implementation is only guaranteed to work if the code is
           IEEE 748/754 compliant.  The checks for isnan and isinf are
           separate because compilers like the old sgi platforms support one
           but not the other.  See bug 2019 for more details.

           This method is public so that other objects (solvers, line
           searches, and directions) can use this test on their own values.

           Return Values:
           - 0 = Finite Number
           - -1 = NaN
           - -2 = Inf
        """
        return _StatusTest.FiniteValue_finiteNumberTest(self, *args)

# Register FiniteValue in _StatusTest:
_StatusTest.FiniteValue_swigregister(FiniteValue)

