# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.Pliris is the python interface to the Trilinos package
Pliris, an LU solver for dense matrices:

    https://trilinos.org/docs/dev/packages/pliris/doc/html/index.html

The purpose of Pliris is to provide an object-oriented interface to an
LU solver for dense matrices on parallel platforms. These matrices are
double precision real matrices distributed on a parallel machine.  The
python version of the Pliris package supports the following class:

    * Pliris  - Primary solver class.

"""

from sys import version_info as _swig_python_version_info

from . import _Pliris


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)



def Version():
    return _Pliris.Version()

__version__ = Version()

class Pliris(object):
    r""" Pliris: An Obect-Oriented Interface to a Dense LU Solver. The Pliris class : Provides the functionality to interface to a dense LU"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Pliris Default constructor."""
        _Pliris.Pliris_swiginit(self, _Pliris.new_Pliris(*args))

    def SetLHS(self, X):
        r"""
        Pliris LHS Set Associates an already defined Epetra_MultiVector (or Epetra_Vector) as the initial guess
             and location where the solution will be return.
        """
        return _Pliris.Pliris_SetLHS(self, X)

    def SetRHS(self, B):
        r"""
        Pliris RHS Set Associates an already defined Epetra_MultiVector (or Epetra_Vector) as the right-hand-side of
             the linear system.
        """
        return _Pliris.Pliris_SetRHS(self, B)

    def SetMatrix(self, *args):
        r"""
        *Overload 1:*
        Pliris Matrix Set Associates an already defined  Epetra_Vector as the matrix (column ordered) of
             the linear system.

        |

        *Overload 2:*
        Pliris Matrix Set Associates an already defined  Epetra_SerialDenseVector as the matrix (column ordered) of
             the linear system.
        """
        return _Pliris.Pliris_SetMatrix(self, *args)

    def GetDistribution(self, nprocs_row, number_of_unknowns, nrhs, my_rows, my_cols, my_first_row, my_first_col, my_rhs, my_row, my_col):
        r"""
        Pliris GetDistirbution Gives the distribution information that is required by the dense solver

            :param nprocs_row(In):   - number of processors for a row
            :param number_of_unknowns(In):  - order of the dense matrix
            :param nrhs(In):  - number of right hand sides
            :param my_rows(Out):  - number of rows of the matrix on this processor
            :type my_cols: int
            :param my_cols: (Out)  - number of columns of the matrix on this processor
            :param my_first_row(Out):  - first (global) row number on this processor (array starts at index 1)
            :type my_first_col: int
            :param my_first_col: (Out)  - first (global) column number on this processor (array starts at index 1)
            :param my_rhs(Out):  - number of Right hand sides on this processor
            :param my_row(Out):  - row number in processor mesh, 0 to the  number of processors for a column -1
            :param my_col(Out):  - column  number in processor mesh, 0 to the  number of processors for a row -1
        """
        return _Pliris.Pliris_GetDistribution(self, nprocs_row, number_of_unknowns, nrhs, my_rows, my_cols, my_first_row, my_first_col, my_rhs, my_row, my_col)

    def FactorSolve(self, *args):
        r"""
        *Overload 1:*
        Pliris FactorSolve Factors and solves the dense matrix

            :param A(InOut): --  Epetra Vector that has the matrix and rhs packed( Note: matrix is overwritten)
            :param my_rows(In): --  number of rows of the matrix on this processor
            :param my_cols(In): --  number of columns of the matrix on this processor
            :param matrix_size(In): -- order of the dense matrix
            :param num_procsr(In): --  number of processors for a row
            :param num_rhs(In): --  number of right hand sides
            :param secs(Out): -- factor and solve time in seconds

        |

        *Overload 2:*
        Pliris FactorSolve Factors and solves the dense matrix

            :param AA(In): --  Epetra Serial Dense Vector that has the matrix and rhs packed
            :param my_rows(In): --  number of rows of the matrix on this processor
            :param my_cols(In): --  number of columns of the matrix on this processor
            :param matrix_size(In): -- order of the dense matrix
            :param num_procsr(In): --  number of processors for a row
            :param num_rhs(In): --  number of right hand sides
            :param secs(Out): -- factor and solve time in seconds
        """
        return _Pliris.Pliris_FactorSolve(self, *args)

    def Factor(self, A, matrix_size, num_procsr, permute, secs):
        r"""
        Pliris Factor Factors the dense matrix

            :param A(In): --  Epetra Vector that has the matrix packed
            :param matrix_size(In): -- order of the dense matrix
            :param num_procsr(In): --  number of processors for a row
            :param permute(In): -- permutation matrix
            :param secs(Out): -- factor and solve time in seconds
        """
        return _Pliris.Pliris_Factor(self, A, matrix_size, num_procsr, permute, secs)

    def Solve(self, permute, num_rhs):
        r"""
        Pliris Solve Solves the previously factored dense matrix

            :param permute(In): -- permutation matrix
            :param num_rhs(In): -- factor and solve time in seconds
                \ Note that the matrix has been previously factored by Factor
                \ The RHS has been set by SetRHS(Epetra_MultiVector * B)
                \ On output the result is in the RHS
        """
        return _Pliris.Pliris_Solve(self, permute, num_rhs)
    __swig_destroy__ = _Pliris.delete_Pliris

# Register Pliris in _Pliris:
_Pliris.Pliris_swigregister(Pliris)

