# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""

PyTrilinos.Teuchos.RCP is a special PyTrilinos module designed to
provide access to RCP methods for PyTrilinos variables that are
stored internally via Teuchos::RCP reference counted pointers.

Inspired by the python function sys.getrefcount(object), this module
provides a number of Teuchos::RCP methods as python functions that
take a PyTrilinos object as their argument. These functions include:

    * is_null(obj)        - Return True if underlying pointer is NULL
    * is_valid_ptr(obj)   - Return True if underlying pointer is valid
    * has_ownership(obj)  - Return True if this RCP owns the object
    * strong_count(obj)   - Return the strong reference count
    * weak_count(obj)     - Return the weak reference count
    * total_count(obj)    - Return the total reference count

"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _RCP
else:
    import _RCP

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _RCP.delete_SwigPyIterator

    def value(self):
        return _RCP.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _RCP.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _RCP.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _RCP.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _RCP.SwigPyIterator_equal(self, x)

    def copy(self):
        return _RCP.SwigPyIterator_copy(self)

    def next(self):
        return _RCP.SwigPyIterator_next(self)

    def __next__(self):
        return _RCP.SwigPyIterator___next__(self)

    def previous(self):
        return _RCP.SwigPyIterator_previous(self)

    def advance(self, n):
        return _RCP.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _RCP.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _RCP.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _RCP.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _RCP.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _RCP.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _RCP.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _RCP:
_RCP.SwigPyIterator_swigregister(SwigPyIterator)
class ios_base(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    erase_event = _RCP.ios_base_erase_event
    imbue_event = _RCP.ios_base_imbue_event
    copyfmt_event = _RCP.ios_base_copyfmt_event

    def register_callback(self, __fn, __index):
        return _RCP.ios_base_register_callback(self, __fn, __index)

    def flags(self, *args):
        return _RCP.ios_base_flags(self, *args)

    def setf(self, *args):
        return _RCP.ios_base_setf(self, *args)

    def unsetf(self, __mask):
        return _RCP.ios_base_unsetf(self, __mask)

    def precision(self, *args):
        return _RCP.ios_base_precision(self, *args)

    def width(self, *args):
        return _RCP.ios_base_width(self, *args)

    @staticmethod
    def sync_with_stdio(__sync=True):
        return _RCP.ios_base_sync_with_stdio(__sync)

    def imbue(self, __loc):
        return _RCP.ios_base_imbue(self, __loc)

    def getloc(self):
        return _RCP.ios_base_getloc(self)

    @staticmethod
    def xalloc():
        return _RCP.ios_base_xalloc()

    def iword(self, __ix):
        return _RCP.ios_base_iword(self, __ix)

    def pword(self, __ix):
        return _RCP.ios_base_pword(self, __ix)
    __swig_destroy__ = _RCP.delete_ios_base

# Register ios_base in _RCP:
_RCP.ios_base_swigregister(ios_base)
cvar = _RCP.cvar
ios_base.boolalpha = _RCP.cvar.ios_base_boolalpha
ios_base.dec = _RCP.cvar.ios_base_dec
ios_base.fixed = _RCP.cvar.ios_base_fixed
ios_base.hex = _RCP.cvar.ios_base_hex
ios_base.internal = _RCP.cvar.ios_base_internal
ios_base.left = _RCP.cvar.ios_base_left
ios_base.oct = _RCP.cvar.ios_base_oct
ios_base.right = _RCP.cvar.ios_base_right
ios_base.scientific = _RCP.cvar.ios_base_scientific
ios_base.showbase = _RCP.cvar.ios_base_showbase
ios_base.showpoint = _RCP.cvar.ios_base_showpoint
ios_base.showpos = _RCP.cvar.ios_base_showpos
ios_base.skipws = _RCP.cvar.ios_base_skipws
ios_base.unitbuf = _RCP.cvar.ios_base_unitbuf
ios_base.uppercase = _RCP.cvar.ios_base_uppercase
ios_base.adjustfield = _RCP.cvar.ios_base_adjustfield
ios_base.basefield = _RCP.cvar.ios_base_basefield
ios_base.floatfield = _RCP.cvar.ios_base_floatfield
ios_base.badbit = _RCP.cvar.ios_base_badbit
ios_base.eofbit = _RCP.cvar.ios_base_eofbit
ios_base.failbit = _RCP.cvar.ios_base_failbit
ios_base.goodbit = _RCP.cvar.ios_base_goodbit
ios_base.app = _RCP.cvar.ios_base_app
ios_base.ate = _RCP.cvar.ios_base_ate
ios_base.binary = _RCP.cvar.ios_base_binary
ios_base.ios_base_in = _RCP.cvar.ios_base_ios_base_in
ios_base.out = _RCP.cvar.ios_base_out
ios_base.trunc = _RCP.cvar.ios_base_trunc
ios_base.beg = _RCP.cvar.ios_base_beg
ios_base.cur = _RCP.cvar.ios_base_cur
ios_base.end = _RCP.cvar.ios_base_end

class ios(ios_base):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def rdstate(self):
        return _RCP.ios_rdstate(self)

    def clear(self, *args):
        return _RCP.ios_clear(self, *args)

    def setstate(self, __state):
        return _RCP.ios_setstate(self, __state)

    def good(self):
        return _RCP.ios_good(self)

    def eof(self):
        return _RCP.ios_eof(self)

    def fail(self):
        return _RCP.ios_fail(self)

    def bad(self):
        return _RCP.ios_bad(self)

    def exceptions(self, *args):
        return _RCP.ios_exceptions(self, *args)

    def __init__(self, __sb):
        _RCP.ios_swiginit(self, _RCP.new_ios(__sb))
    __swig_destroy__ = _RCP.delete_ios

    def tie(self, *args):
        return _RCP.ios_tie(self, *args)

    def rdbuf(self, *args):
        return _RCP.ios_rdbuf(self, *args)

    def copyfmt(self, __rhs):
        return _RCP.ios_copyfmt(self, __rhs)

    def fill(self, *args):
        return _RCP.ios_fill(self, *args)

    def imbue(self, __loc):
        return _RCP.ios_imbue(self, __loc)

    def narrow(self, __c, __dfault):
        return _RCP.ios_narrow(self, __c, __dfault)

    def widen(self, __c):
        return _RCP.ios_widen(self, __c)

# Register ios in _RCP:
_RCP.ios_swigregister(ios)
class ostream(ios):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, __sb):
        _RCP.ostream_swiginit(self, _RCP.new_ostream(__sb))
    __swig_destroy__ = _RCP.delete_ostream

    def __lshift__(self, *args):
        return _RCP.ostream___lshift__(self, *args)

    def put(self, __c):
        return _RCP.ostream_put(self, __c)

    def write(self, __s, __n):
        return _RCP.ostream_write(self, __s, __n)

    def flush(self):
        return _RCP.ostream_flush(self)

    def tellp(self):
        return _RCP.ostream_tellp(self)

    def seekp(self, *args):
        return _RCP.ostream_seekp(self, *args)

# Register ostream in _RCP:
_RCP.ostream_swigregister(ostream)
cin = cvar.cin
cout = cvar.cout
cerr = cvar.cerr
clog = cvar.clog

class istream(ios):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, __sb):
        _RCP.istream_swiginit(self, _RCP.new_istream(__sb))
    __swig_destroy__ = _RCP.delete_istream

    def __rshift__(self, *args):
        return _RCP.istream___rshift__(self, *args)

    def gcount(self):
        return _RCP.istream_gcount(self)

    def get(self, *args):
        return _RCP.istream_get(self, *args)

    def getline(self, *args):
        return _RCP.istream_getline(self, *args)

    def ignore(self, *args):
        return _RCP.istream_ignore(self, *args)

    def peek(self):
        return _RCP.istream_peek(self)

    def read(self, __s, __n):
        return _RCP.istream_read(self, __s, __n)

    def readsome(self, __s, __n):
        return _RCP.istream_readsome(self, __s, __n)

    def putback(self, __c):
        return _RCP.istream_putback(self, __c)

    def unget(self):
        return _RCP.istream_unget(self)

    def sync(self):
        return _RCP.istream_sync(self)

    def tellg(self):
        return _RCP.istream_tellg(self)

    def seekg(self, *args):
        return _RCP.istream_seekg(self, *args)

# Register istream in _RCP:
_RCP.istream_swigregister(istream)
class iostream(istream, ostream):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, __sb):
        _RCP.iostream_swiginit(self, _RCP.new_iostream(__sb))
    __swig_destroy__ = _RCP.delete_iostream

# Register iostream in _RCP:
_RCP.iostream_swigregister(iostream)
endl_cb_ptr = _RCP.endl_cb_ptr
endl = _RCP.endl
ends_cb_ptr = _RCP.ends_cb_ptr
ends = _RCP.ends
flush_cb_ptr = _RCP.flush_cb_ptr
flush = _RCP.flush
class MultiVecDouble(object):
    r"""
    Interface for multivectors used by Anasazi's linear solvers.
    Author: Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist

    :param ScalarType: The type of entries of the multivector.

    Anasazi accesses multivectors through a traits interface called
    MultiVecTraits.  If you want to use Anasazi with your own
    multivector class MV, you may either specialize MultiVecTraits for
    MV, or you may wrap MV in your own class that implements MultiVec.
    Specializing MultiVecTraits works via compile-time polymorphism,
    whereas implementing the MultiVec interface works via run-time
    polymorphism.  You may pick whichever option you like.  However,
    specializing MultiVecTraits is the preferred method.  This is
    because Anasazi's linear solvers always use a specialization of
    MultiVecTraits to access multivector operations.  They only use
    MultiVec through a specialization of the MultiVecTraits traits
    class, which is implemented below in this header file.

    If you want your multivector class (or a wrapper thereof) to
    implement the MultiVec interface, you should inherit from
    MultiVec<ScalarType>, where ScalarType is the type of entries in
    the multivector.  For example, a multivector with entries of type
    double would inherit from MultiVec<double>.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _RCP.delete_MultiVecDouble

    def Clone(self, numvecs):
        r"""
        Create a new MultiVec with ``numvecs`` columns.
        :rtype: Anasazi::MultiVec< double >
        :return: Pointer to the new multivector with uninitialized values.
        """
        return _RCP.MultiVecDouble_Clone(self, numvecs)

    def CloneCopy(self, *args):
        r"""
        *Overload 1:*
        Create a new MultiVec and copy contents of ``*this`` into it (deep copy).
        :rtype: Anasazi::MultiVec< double >
        :return: Pointer to the new multivector	

        |

        *Overload 2:*
        Creates a new Anasazi::MultiVec and copies the selected contents of ``*this``
           into the new vector (deep copy).  The copied
           vectors from ``*this`` are indicated by the ``index.size()`` indices in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _RCP.MultiVecDouble_CloneCopy(self, *args)

    def CloneViewNonConst(self, index):
        r"""
        Creates a new Anasazi::MultiVec that shares the selected contents of ``*this``.
           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _RCP.MultiVecDouble_CloneViewNonConst(self, index)

    def CloneView(self, index):
        r"""
        Creates a new Anasazi::MultiVec that shares the selected contents of ``*this``.
           The index of the ``numvecs`` vectors shallow copied from ``*this`` are indicated by the
           indices given in ``index``.

           :rtype: Anasazi::MultiVec< double >
           :return: Pointer to the new multivector	
        """
        return _RCP.MultiVecDouble_CloneView(self, index)

    def GetGlobalLength(self):
        r""" The number of rows in the multivector."""
        return _RCP.MultiVecDouble_GetGlobalLength(self)

    def GetNumberVecs(self):
        r""" The number of vectors (i.e., columns) in the multivector."""
        return _RCP.MultiVecDouble_GetNumberVecs(self)

    def MvTimesMatAddMv(self, alpha, A, B, beta):
        r""" Update ``*this`` with ``alpha`` * ``A`` * ``B`` + ``beta`` * (``*this)``."""
        return _RCP.MultiVecDouble_MvTimesMatAddMv(self, alpha, A, B, beta)

    def MvAddMv(self, alpha, A, beta, B):
        r""" Replace ``*this`` with ``alpha`` * ``A`` + ``beta`` * ``B``."""
        return _RCP.MultiVecDouble_MvAddMv(self, alpha, A, beta, B)

    def MvScale(self, *args):
        r"""
        *Overload 1:*
        Scale each element of the vectors in ``*this`` with ``alpha``.

        |

        *Overload 2:*
        Scale each element of the i-th vector in ``*this`` with alpha[i].
        """
        return _RCP.MultiVecDouble_MvScale(self, *args)

    def MvTransMv(self, alpha, A, B):
        r"""
        Compute a dense matrix ``B`` through the matrix-matrix multiply
           ``alpha`` * ``A^T`` * (``*this)``.
        """
        return _RCP.MultiVecDouble_MvTransMv(self, alpha, A, B)

    def MvDot(self, A, b):
        r"""
        Compute the dot product of each column of *this with the corresponding column of A.

        Compute a vector ``b`` whose entries are the individual
        dot-products.  That is, b[i] = A[i]^H * (*this)[i]
        where A[i] is the i-th column of A.
        """
        return _RCP.MultiVecDouble_MvDot(self, A, b)

    def MvNorm(self, normvec):
        r"""
        Compute the 2-norm of each vector in ``*this``.

        :type normvec: std::vector< Teuchos::ScalarTraits< double >::magnitudeType,std::allocator< Teuchos::ScalarTraits< double >::magnitudeType > >
        :param normvec: [out] On output, normvec[i] holds the 2-norm of the
              ``i-th`` vector of ``*this``.
        """
        return _RCP.MultiVecDouble_MvNorm(self, normvec)

    def SetBlock(self, A, index):
        r"""
        Copy the vectors in ``A`` to a set of vectors in ``*this``.

        The ``numvecs`` vectors in ``A`` are copied to a subset of vectors
        in ``*this`` indicated by the indices given in ``index``.
        """
        return _RCP.MultiVecDouble_SetBlock(self, A, index)

    def MvRandom(self):
        r""" Fill all the vectors in ``*this`` with random numbers."""
        return _RCP.MultiVecDouble_MvRandom(self)

    def MvInit(self, alpha):
        r""" Replace each element of the vectors in ``*this`` with ``alpha``."""
        return _RCP.MultiVecDouble_MvInit(self, alpha)

    def MvPrint(self, os):
        r""" Print ``*this`` multivector to the ``os`` output stream."""
        return _RCP.MultiVecDouble_MvPrint(self, os)

# Register MultiVecDouble in _RCP:
_RCP.MultiVecDouble_swigregister(MultiVecDouble)
class OperatorDouble(object):
    r"""
    Anasazi's templated virtual class for constructing an operator that can interface with the
    OperatorTraits class used by the eigensolvers.

    A concrete implementation of this class is necessary.  The user can create their own implementation
    if those supplied are not suitable for their needs.

    Author: Ulrich Hetmaniuk, Rich Lehoucq, and Heidi Thornquist
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _RCP.delete_OperatorDouble

    def Apply(self, x, y):
        r"""
        This method takes the Anasazi::MultiVec ``x`` and
             applies the operator to it resulting in the Anasazi::MultiVec ``y``.
        """
        return _RCP.OperatorDouble_Apply(self, x, y)

# Register OperatorDouble in _RCP:
_RCP.OperatorDouble_swigregister(OperatorDouble)

def is_null(*args):
    r"""
    is_null(obj) -> bool

    Return true if obj is a python wrapper for a C++ object stored as a
    Teuchos::RCP and the underlying pointer is NULL
    """
    return _RCP.is_null(*args)

def is_valid_ptr(*args):
    r"""
    is_valid_ptr(obj) -> bool

    Return true if obj is a python wrapper for a C++ object stored as a
    Teuchos::RCP and the underlying pointer is valid
    """
    return _RCP.is_valid_ptr(*args)

def has_ownership(*args):
    r"""
    has_ownership(obj) -> bool

    Return true if obj is a python wrapper for a C++ object stored as a
    Teuchos::RCP that has ownership of the underlying pointer
    """
    return _RCP.has_ownership(*args)

def strong_count(*args):
    r"""
    strong_count(obj) -> int

    If obj is a python wrapper for a C++ object stored as a Teuchos::RCP,
    return the strong reference count
    """
    return _RCP.strong_count(*args)

def weak_count(*args):
    r"""
    weak_count(obj) -> int

    If obj is a python wrapper for a C++ object stored as a Teuchos::RCP,
    return the weak reference count
    """
    return _RCP.weak_count(*args)

def total_count(*args):
    r"""
    total_count(obj) -> int

    If obj is a python wrapper for a C++ object stored as a Teuchos::RCP,
    return the total reference count
    """
    return _RCP.total_count(*args)

