# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info

if not __package__:
    __package__ = 'PyTrilinos.Isorropia'
from . import _Base


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base

def Isorropia_Version(*args):
    return _Base.Isorropia_Version(*args)

__version__ = Isorropia_Version().split()[3]

class Operator(object):
    r"""
    Interface (abstract base class) for computing a new partitioning/coloring/
       ordering and exploiting their results.

     If the accessor methods are called before the computation of the
     result (by a method like compute()) has been called, behavior is not
     well defined.  Implementations will either return empty/erroneous
     data, or throw an exception. In most cases, implementations will
     probably call compute_partitioning() internally in a constructor or
     factory method, so this won't usually be an issue.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_Operator

    def setParameters(self, *args):
        r"""
        Set parameters for the Operator instance. The contents of the
             input paramlist object are copied into an internal ParameterList
             attribute. Instances of this interface should not retain a
             reference to the input ParameterList after this method returns.

             :type paramlist: :py:class:`ParameterList`
             :param paramlist: [in] List of parameters that the user wants to use.
        """
        return _Base.Operator_setParameters(self, *args)

    def compute(self, *args):
        r"""
        Method which does the work of computing a new
            partitioning/coloring/ordering, depending on the child class
            used.

            :type forceRecomputing: boolean, optional
            :param forceRecomputing: Optional argument defaults to false.
                Depending on the implementation, compute() should
                only perform a computation the first time it is called, and
                subsequent repeated calls are no-ops. If the user's intent is
                to re-compute the results (e.g., if parameters or other
                inputs have been changed), then setting this flag to true
                will force a new result to be computed.
        """
        return _Base.Operator_compute(self, *args)

    def alreadyComputed(self, *args):
        r"""
        Query whether the computation has already been called.

             :rtype: boolean
             :return: ``True`` if the computation has already been done,
           ``False`` otherwise.
        """
        return _Base.Operator_alreadyComputed(self, *args)

    def numProperties(self, *args):
        r"""
        Return the number of different values used for "properties".

             For example, the number of colors or the number of parts used
             for the overall graph/matrix.

             :rtype: int
             :return: Global number of values for properties

             Remarks: Infact, it returns the upper bound of the interval of
             taken values. For example, for the colors "1,2,4" , it will
             return "4"
        """
        return _Base.Operator_numProperties(self, *args)

    def numLocalProperties(self, *args):
        r"""
        Return the number of different values used for "properties"
             for this process only.

             :rtype: int
             :return: Local number of values for properties
        """
        return _Base.Operator_numLocalProperties(self, *args)

    def numElemsWithProperty(self, *args):
        r"""
        Return the number of **LOCAL** elements with the given property.

             :type property: int
             :param property: [in] Value of the property to consider.

             :rtype: int
             :return: Number of **local** elems which have this property.
        """
        return _Base.Operator_numElemsWithProperty(self, *args)

    def elemsWithProperty(self, *args):
        r"""
        Fill user-allocated list (of length len) with the local element
             ids of the LOCAL elements with the given property.

             :type property: int
             :param property: [in]  Value of the property to consider.

             :type elementList: int
             :param elementList: [out] User allocated array (of size at least
                 ``len)`` of local ID that have the asked property.

             :type len: int
             :param len: [in] Maximum lenght for the array. If ``len`` is
                 greater than the result of numElemsWithProperty() for
           ``property``, only the first and relevant elements are filled.

             Remarks: Memory space which is not useful in the array is not
             initialized or used in this method.
        """
        return _Base.Operator_elemsWithProperty(self, *args)

    def extractPropertiesView(self, *args):
        r"""
        Give access of the property array that is owned by the current
             processor.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Pointer to the the properties array inside
                                   the object.

             Remarks: This pointer is only significant if the object still exists.
             Otherwise, you must use See also: Isorropia::Operator::extractPropertiesCopy().

             See also: Isorropia::Operator::extractPropertiesCopy()
        """
        return _Base.Operator_extractPropertiesView(self, *args)

    def extractPropertiesCopy(self, *args):
        r"""
        Copy a part of the property array.

             :type len: int
             :param len: [in] of the array given by the user.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Array of properties. Allocated by the user with
                                   a size of at least ``len`` elements.

             Remarks: Memory space which is not useful in the array is not
             initialized or used in this method.

             See also: Isorropia::Operator::extractPropertiesView()
        """
        return _Base.Operator_extractPropertiesCopy(self, *args)

# Register Operator in _Base:
_Base.Operator_swigregister(Operator)
class Colorer(Operator):
    r"""
    Interface (abstract base class) for computing a new coloring and
       describing the result.

       The colors returned have values between 1 and C, where C is the number of colors used.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_Colorer

    def color(self, *args):
        r"""
        Method which does the work of computing a new coloring.

            :type forceColoring: boolean, optional
            :param forceColoring: Optional argument defaults to false.
                  Depending on the implementation, color() should only perform a
                  coloring the first time it is called, and subsequent repeated
                  calls are no-ops. If the user's intent is to re-compute the
                  coloring (e.g., if parameters or other inputs have been
                  changed), then setting this flag to true will force a new
                  coloring to be computed.
        """
        return _Base.Colorer_color(self, *args)

    def numColors(self, *args):
        r"""
        Method which returns the number (global) of colors used.

             :rtype: int
             :return: The overall number of colors used. All colors used for
                 all vertices are between 1 and this value (included).

             See also: Isorropia::Operator::numProperties()
        """
        return _Base.Colorer_numColors(self, *args)

    def numElemsWithColor(self, *args):
        r"""
        Return the number of **local** elements of a given color.

             :type theColor: int
             :param theColor: The wanted color.

             :rtype: int
             :return: The number of **local** of the asked color.

             See also: Isorropia::Operator::numElemsWithProperty()
        """
        return _Base.Colorer_numElemsWithColor(self, *args)

    def extractColorsView(self, *args):
        r"""
        Give access of the color assignments array that is owned by the current
             processor.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Pointer to the color assignements array inside
                                   the object.

             Remarks: This pointer is only significant if the object still exists.
             Otherwise, you must use See also: Isorropia::Operator::extractPartsCopy()

             See also: Isorropia::Operator::extractPropertiesView()
        """
        return _Base.Colorer_extractColorsView(self, *args)

    def extractColorsCopy(self, *args):
        r"""
        Copy a part of the color assignments array.

             :type len: int
             :param len: [in] of the array given by the user.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Array of color assignments. Allocated by the user with
                                   a size of at least ``len`` elements.

             Remarks: Memory space which is not useful in the array is not
             initialized or used in this method.

             See also: Isorropia::Operator::extractPropertiesCopy()
        """
        return _Base.Colorer_extractColorsCopy(self, *args)

    def elemsWithColor(self, *args):
        return _Base.Colorer_elemsWithColor(self, *args)

# Register Colorer in _Base:
_Base.Colorer_swigregister(Colorer)
class Partitioner(Operator):
    r"""
    Interface (abstract base class) for computing a new partitioning and
     describing the layout of elements in the new partition (the parts).

     If the methods which describe the new partitioning (e.g.,
     operator [], elemsInPart()) are called before compute_partitioning()
     has been called, behavior is not well defined. Implementations will
     either return empty/erroneous data, or throw an exception. In most
     cases, implementations will probably call compute_partitioning()
     internally in a constructor or factory method, so this won't usually
     be an issue.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_Partitioner

    def partition(self, *args):
        r"""
        Method which does the work of computing a new partitioning.
            Implementations of this interface will typically be constructed
            with an object or information describing the existing ('old')
            partitioning. This method computes a 'new' rebalanced
            partitioning for that input data.

            :type forceRepartitioning: boolean, optional
            :param forceRepartitioning: Optional argument defaults to false.
                   Depending on the implementation, partitioning() should
                   only perform a repartitioning the first time it is called, and
                   subsequent repeated calls are no-ops. If the user's intent is
                   to re-compute the partitioning (e.g., if parameters or other
                   inputs have been changed), then setting this flag to true
                   will force a new partitioning to be computed.

            See also: Isorropia::Operator::compute()
        """
        return _Base.Partitioner_partition(self, *args)

    def numElemsInPart(self, *args):
        r"""
        Return the number of LOCAL elements in a given part.

             :type part: int
             :param part: [in] the part ID we want to know the number of local
                 elements.

             :rtype: int
             :return: number of local elements that belongs to the
                 given part.

             See also: Isorropia::Operator::numElemsWithProperty()
        """
        return _Base.Partitioner_numElemsInPart(self, *args)

    def elemsInPart(self, *args):
        r"""
        Fill user-allocated list (of length len) with the
             local element ids to be located in the given part

             :type part: int
             :param part: [in] the part ID we consider

             :type elementList: int
             :param elementList: [out] array of elements that belongs to this
                 part ID, must be allocated by user with size at least ``len``

             :type len: int
             :param len: [in] maximum number of elements we can put in the
                 array. Usually, may be the result of
                 Isorropia::Partitioner::numElemsInPart().  .

             See also: Isorropia::Operator::elemsWithProperty()
        """
        return _Base.Partitioner_elemsInPart(self, *args)

    def extractPartsView(self, *args):
        r"""
        Give access of the part assignments array that is owned by the current
             processor.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Pointer to the the part assignements array inside
                                   the object.

             Remarks: This pointer is only significant if the object still exists.
             Otherwise, you must use See also: Isorropia::Operator::extractPartsCopy()

             See also: Isorropia::Operator::extractPropertiesView()
        """
        return _Base.Partitioner_extractPartsView(self, *args)

    def extractPartsCopy(self, *args):
        r"""
        Copy a part of the part assignment array.

             :type len: int
             :param len: [in] of the array given by the user.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Array of part assignments. Allocated by the user with
                                   a size of at least ``len`` elements.

             Remarks: Memory space which is not useful in the array is not
             initialized or used in this method.

             See also: Isorropia::Operator::extractPropertiesCopy()
        """
        return _Base.Partitioner_extractPartsCopy(self, *args)

# Register Partitioner in _Base:
_Base.Partitioner_swigregister(Partitioner)
class Redistributor(object):
    r"""
     Abstract base class for classes which are constructed with a
    Partitioner instance, and define methods to redistribute their objects.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_Redistributor

    def __init__(self, *args):
        _Base.Redistributor_swiginit(self, _Base.new_Redistributor(*args))

# Register Redistributor in _Base:
_Base.Redistributor_swigregister(Redistributor)
class CostDescriber(object):
    r"""
    Interface (abstract base class) for describing the weights or costs
     associated with the vertices and/or edges or hyperedges of the object to be
     partitioned, ordered or colored.

     A CostDescriber object is created by the application.  If no CostDescriber is supplied by the
     application, sensible default weights should be used.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_CostDescriber

# Register CostDescriber in _Base:
_Base.CostDescriber_swigregister(CostDescriber)
class Orderer(Operator):
    r"""
    Interface (abstract base class) for computing a new ordering and
     describing the layout of elements in the new order.

     If the methods which describe the new ordering (e.g., operator[],
     etc.) are called before order() has been called, behavior is not
     well defined. Implementations will either return empty/erroneous
     data, or throw an exception. In most cases, implementations will
     probably call order() internally in a constructor or factory method,
     so this won't usually be an issue.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_Orderer

    def order(self, *args):
        r"""
        Method which does the work of computing a new ordering.

            :type forceOrdering: boolean, optional
            :param forceOrdering: Optional argument defaults to false.
                   Depending on the implementation, compute_partitioning() should
                   only perform a repartitioning the first time it is called, and
                   subsequent repeated calls are no-ops. If the user's intent is
                   to re-compute the partitioning (e.g., if parameters or other
                   inputs have been changed), then setting this flag to true
                   will force a new partitioning to be computed.
        """
        return _Base.Orderer_order(self, *args)

    def extractPermutationView(self, *args):
        r"""
        Give access of the "direct" permutation vector that is owned by the current
             processor.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Pointer to the the part assignements array inside
                                   the object.

             Remarks: This pointer is only significant if the object still exists.
             Otherwise, you must use See also: Isorropia::Operator::extractPartsCopy()

             See also: Isorropia::Operator::extractPropertiesView()
        """
        return _Base.Orderer_extractPermutationView(self, *args)

    def extractPermutationCopy(self, *args):
        r"""
        Copy a part of the "direct" permutation vector.

             :type len: int
             :param len: [in] of the array given by the user.

             :type size: int
             :param size: [out] Number of elements in the array.

             :type array: int
             :param array: [out] Direct permutation vector. Allocated by the user with
                                   a size of at least ``len`` elements.

             Remarks: Memory space which is not useful in the array is not
             initialized or used in this method.

             See also: Isorropia::Operator::extractPropertiesCopy()
        """
        return _Base.Orderer_extractPermutationCopy(self, *args)

# Register Orderer in _Base:
_Base.Orderer_swigregister(Orderer)
class LevelScheduler(Operator):
    r"""
    Interface (abstract base class) for an operator that computes
       a partitioning of local elements into levels.  On each process the
       levels begin at 1 and increase by 1.  All elements in the same
       level can be used in calculation concurrently.  All elements in
       level i are dependent upon the completion of the calculations involving
       the elements in level i-1.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Base.delete_LevelScheduler

    def schedule(self, *args):
        r"""
        Method which does the work of computing a new level schedule.

            :type forceScheduling: boolean, optional
            :param forceScheduling: Optional argument defaults to false.
                  Depending on the implementation, schedule() should only perform a
                  scheduling the first time it is called, and subsequent repeated
                  calls are no-ops. If the user's intent is to re-compute the
                  scheduling (e.g., if parameters or other inputs have been
                  changed), then setting this flag to true will force a new
                  scheduling to be computed.
        """
        return _Base.LevelScheduler_schedule(self, *args)

    def numLevels(self, *args):
        r"""
        Method which returns the number of levels.

             :rtype: int
             :return: The number of levels on the local process.
                         Levels begin at 1 and increase by 1.

             See also: Isorropia::Operator::numProperties()
        """
        return _Base.LevelScheduler_numLevels(self, *args)

    def numElemsWithLevel(self, *args):
        r"""
        Return the number of **elements** in a given level.

             :type level: int
             :param level: The wanted level.

             :rtype: int
             :return: The number of **elements** in the level.

             See also: Isorropia::Operator::numElemsWithProperty()
        """
        return _Base.LevelScheduler_numElemsWithLevel(self, *args)

    def elemsWithLevel(self, *args):
        r"""
         Fill user-allocated list (of length len) with the local ID for each
        element in the given level.

              :type level: int
              :param level: the wanted level

              :type elementList: int
              :param elementList: an array to receive local elements of the given level

              :type len: int
              :param len: the number of elements wanted

              See also: Isorropia::Operator::elemsWithProperty()
        """
        return _Base.LevelScheduler_elemsWithLevel(self, *args)

# Register LevelScheduler in _Base:
_Base.LevelScheduler_swigregister(LevelScheduler)

